
![](media/logo.png)


| | oneM2M Technical Specification |
|-|-|
|Document Number |oneM2M- TS-0023-V5.6.0 |
|Document Name: |SDT based Information Model and Mapping for Vertical Industries |
|Date: |2024-06-27 |
|Abstract: |This technical specification includes oneM2M-defined information models for appliances from various vertical industries and the mapping with other information models from external organizations. |
|Template Version: January 2017 (Do not modify) |Template Version: January 2017 (Do not modify) |

<mark>Editor's note: We need to decide how the Phrase "oneM2M Technical Specification" in the table header above is been formatted. In the original word document this is single line (using col-span)</mark>

The present document is provided for future development work within oneM2M only. The Partners accept no liability for any use of this specification.

The present document has not been subject to any approval process by the oneM2M Partners Type 1.  Published oneM2M specifications and reports for implementation should be obtained via the oneM2M Partners' Publications Offices.





About oneM2M 

The purpose and goal of oneM2M is to develop technical specifications which address the need for a common M2M Service Layer that can be readily embedded within various hardware and software, and relied upon to connect the myriad of devices in the field with M2M application servers worldwide. 

More information about oneM2M may be found at:  http//www.oneM2M.org

Copyright Notification

(c) 2018, oneM2M Partners Type 1 (ARIB, ATIS, CCSA, ETSI, TIA, TSDSI, TTA, TTC).

All rights reserved.

The copyright extends to reproduction in all media.



Notice of Disclaimer & Limitation of Liability 

The information provided in this document is directed solely to professionals who have the appropriate degree of experience to understand and interpret its contents in accordance with generally accepted engineering or other professional standards and applicable regulations. No recommendation as to products or vendors is made or should be implied. 

NO REPRESENTATION OR WARRANTY IS MADE THAT THE INFORMATION IS TECHNICALLY ACCURATE OR SUFFICIENT OR CONFORMS TO ANY STATUTE, GOVERNMENTAL RULE OR REGULATION, AND FURTHER, NO REPRESENTATION OR WARRANTY IS MADE OF MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR AGAINST INFRINGEMENT OF INTELLECTUAL PROPERTY RIGHTS. NO oneM2M PARTNER TYPE 1 SHALL BE LIABLE, BEYOND THE AMOUNT OF ANY SUM RECEIVED IN PAYMENT BY THAT PARTNER FOR THIS DOCUMENT, WITH RESPECT TO ANY CLAIM, AND IN NO EVENT SHALL oneM2M BE LIABLE FOR LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES. oneM2M EXPRESSLY ADVISES ANY AND ALL USE OF OR RELIANCE UPON THIS INFORMATION PROVIDED IN THIS DOCUMENT IS AT THE RISK OF THE USER.


# Contents




# 1 Scope
The present document describes the oneM2M defined information model for appliances from various vertical industries, including the description of how it is mapped with other information models from external organizations. It also explains the ontology for the Harmonized Information Model.


# 2 References
References are either specific (identified by date of publication and/or edition number or version number) or nonspecific. For specific references, only the cited version applies. For non-specific references, the latest version of the reference document (including any amendments) applies.


## 2.1 Normative references
The following referenced documents are necessary, partially or totally, for the application of the present document. Their use in the context of this TS is specified by the normative statements that are referring back to this clause


- <a name="_ref_1">[1]</a>    oneM2M Smart Device Template.  
  
  NOTE: Available at https://git.onem2m.org/MAS/SDT
  
- <a name="_ref_2">[2]</a>    Java coding rule.

  NOTE: Available at [http://www.oracle.com/technetwork/java/codeconventions-135099.html](http://www.oracle.com/technetwork/java/codeconventions-135099.html).

- <a name="_ref_3">[3]</a>    oneM2M TS-0001: "Functional Architecture".

- <a name="_ref_4">[4]</a>    oneM2M TS-0004: "Service Layer Core Protocol Specification"

- <a name="_ref_5">[5]</a>    oneM2M TS-0005: "Management Enablement (OMA)".

- <a name="_ref_6">[6]</a>    ISO:80000-1: Quantities and unit -- Part 1: General.

  NOTE:  Available at https://www.iso.org/search.html?q=80000-1.
  
- <a name="_ref_7">[7]</a>    Open Mobile Alliance(tm): "OMA-ER-Device-WebAPIs-V1-0-20160419-C: "Enabler Release Definition for DWAPI 1.0".

  NOTE: Available at  http://www.openmobilealliance.org/release/DWAPI/V1_0-20160419-C/OMA-ERELD-DWAPI_V1_0-20160419-C.pdf

- [8]    void
- [9] void
- [10] void
- [11] void
- [12] void
- [13] void

- <a name="_ref_14">[14]</a>    W3C Recommendation: "XML Schema Part 2: Datatypes Second Edition", 28 October 2004.

  NOTE:  Available at https://www.w3.org/TR/xmlschema-2/ .

- <a name="_ref_15">[15]</a>    NIST standard FIPS PUB 180-4: "Secure Hash Standard (SHS)".

- <a name="_ref_16">[16]</a>    IETF RFC 4566: "SDP: Session Description Protocol". 

- <a name="_ref_17">[17]</a>    IANA Time Zone Database
  
  NOTE: Available at [https://www.iana.org/time-zones](https://www.iana.org/time-zones)  

- <a name="_ref_18">[18]</a>    Void

- <a name="_ref_19">[19]</a>    Open Mobile Alliance(tm): "OMA-ER-GotAPI-V1-1-20151215-C: " Generic Open Terminal API Framework (GotAPI)".

- <a name="_ref_20">[20]</a>    NIST SP 330:2019: "The International System of Units (SI) 2019 Edition"
  
  NOTE: Available at [https://www.nist.gov/pml/special-publication-330](https://www.nist.gov/pml/special-publication-330)  

- <a name="_ref_21">[21]</a>    Recommendation ITU-T X.1303 bis: "Common alerting protocol (CAP 1.2)".

  NOTE: Available at [https://www.itu.int/rec/T-REC-X.1303bis-201403-I](https://www.itu.int/rec/T-REC-X.1303bis-201403-I)

- <a name="_ref_22">[22]</a>    ISO/IEC 8859-1:1998, Information technology - 8-bit single-byte coded graphic character sets - Part 1: Latin alphabet No. 1

## 2.2 Informative references

The following referenced documents are not necessary for the application of the present document but they assist the user with regard to a particular subject area.


- <a name="_ref_i.1">[i.1]</a>    oneM2M Drafting Rules.

  NOTE: Available at [http://www.onem2m.org/images/files/oneM2M-Drafting-Rules.pdf](http://www.onem2m.org/images/files/oneM2M-Drafting-Rules.pdf).

- <a name="_ref_i.2">[i.2]</a>    oneM2M TR-0017: "Home Domain Abstract Information Model".

- <a name="_ref_i.3">[i.3]</a>    Void.

- <a name="_ref_i.4">[i.4]</a>    IEEE 802.15.4: "IEEE Standard for Local and metropolitan area networks--Part 15.4: Low-Rate Wireless Personal Area Networks (LR-WPANs)".

- <a name="_ref_i.5">[i.5]</a>    oneM2M TS-0012: "Base Ontology".

- <a name="_ref_i.6">[i.6]</a>    [https://en.wikipedia.org/wiki/Multiple_inheritance](https://en.wikipedia.org/wiki/Multiple_inheritance)

- <a name="_ref_i.7">[i.7]</a>    [https://www.me.go.kr/home/web/index.do?menuId=10272&condition.code1=007](https://www.me.go.kr/home/web/index.do?menuId=10272&condition.code1=007)

- <a name="_ref_i.8">[i.8]</a>    OCF DEVICE SPECIFICATION V1.3.0

  NOTE: Available at [https://openconnectivity.org/specs/OCF_Device_Specification_v1.3.0.pdf](https://openconnectivity.org/specs/OCF_Device_Specification_v1.3.0.pdf)  

- <a name="_ref_i.9">[i.9]</a>    Ju-Hun Park, Hui Sik Kim, Sang-A Hong, Sun Young Jang, "A Study on the Definition of Terms for Domestic Train Control System", Korean Society for Railway,  2015.

  Note Available at  http://railway.or.kr/Papers_Conference/201502/pdf/KSR2015A114.pdf

- <a name="_ref_i.10">[i.10]</a>    CTCS-3??????????? (Overall technology plan Train Control System), ???????(Chinese Railway Press), 2008, ISBN: 9787113091590

- <a name="_ref_i.11">[i.11]</a>     DSL Forum TR-069: "CPE WAN Management Protocol".

- <a name="_ref_i.12">[i.12]</a>   DSL Forum TR-181: "Broadband User Services (BUS)".

- <a name="_ref_i.13">[i.13]</a>    oneM2M TR-0035: "Developer guide of device management"

- <a name="_ref_i.14">[i.14]</a>    3GPP TS 22.268: "Public Warning System (PWS) requirements (Release 16)".

- <a name="_ref_i.15">[i.15]</a>    oneM2M TS-0006: "Management enablement (BBF)"



# 3 Definition of terms, symbols  and Abbreviations

## 3.1 Terms

For the purposes of the present document, the following terms and definitions apply:

- Device Class ID: URN to identify the Device model definition.

- ModuleClass ID: URN to identify the ModuleClass model definition.

## 3.2 Symbols

Void.


## 3.3 Abbreviations
For the purposes of the present document, the following abbreviations apply:

`ATC          Automatic Train Control`  
`ATP          Automatic Train Protection`  
`BTM          Balise Transmission Module`  
`CTCS-3       Chinese Train Control System-3`  
`GotAPI       Generic Open Terminal Application Programming Interface`  
`DWAPI        Device Web Application Programming Interface`  
`DWAPI-3DP    Device Web Application Programming Interface for 3D printer`  
`DWAPI-PCH    Device Web Application Programming Interface for Personal Connected Healthcare`
`HIM          Harmonized Information Model`


# 4 Conventions
The key words "Shall", "Shall not", "May", "Need not", "Should", "Should not" in the present document are to be interpreted as described in the oneM2M Drafting Rules <a href="#_ref_i.1">[i.1]</a>.


# 5 Harmonised Information Model

## 5.1 Introduction
The present document intends to provide the unified means in the oneM2M system by defining a Harmonized Information Model (HIM) for the devices such as TV, refrigerator, air conditioner, clothes washer, oven, and robot cleaner. For the reasons of interworking with external technologies and efficiency, the principle of the Harmonized Information Model is designed based on HGI SDT 3.0 <a href="#_ref_1">[1]</a>.

The principle of defining the Harmonized Information Model is introduced in clause [5.2 Design Principle of the Harmonised Information Model](#52-design-principle-of-the-harmonised-information-model). Module Classes which oneM2M systems support are explained in clauses [5.3 ModuleClasses](#53-moduleclasses). In the subsequent clauses [5.4 SubDevice models](#54-subdevice-models) and [5.5 Device models](#55-device-models), Sub-Device and Device models are defined.


## 5.2 Design Principle of the Harmonised Information Model

### 5.2.1 Basic design principle of information modelling

The design principle of the oneM2M Harmonized Information Model is to use SDT4.0 originally introduced in oneM2M TR0017 <a href="#_ref_i.2">[i.2]</a>. Note, that those terms starting with a capital letter in this clause are SDT terms and are explained in <a href="#_ref_1">[1]</a>.

**Domain** is a unique name which acts like a namespace (e.g., "org.onem2m.home.modules"). It is set by the organization creating the SDT, allowing reference to a package of definitions for the contained ModuleClasses and DeviceClass models.

**ModuleClasses** specifies a single service (e.g., [audioVolume](#5318-audiovolume), powerOn/Off) with one or more **Actions**, **Properties**, **DataPoints** and **Events**. Each service which is described as a ModuleClass can be re-used in many DeviceClasses.

**DeviceClass** model is a physical, addressable, identifiable appliance, sensor and actuator with one or more ModuleClasses, Properties and SubDevices.

**SubDevice** is a device which may be embedded in a DeviceClass and/or is addressed via another DeviceClass.

Figure 5.2.1-1 depicts the basic structure of SDT 4.0. Further details about SDT 4.0 and its elements can be found in <a href="#_ref_1">[1]</a>.

Specifications of new DeviceClass models and ModuleClasses are encouraged to re-use the definitions specified in the present document as much as possible. If re-use is not possible and new DeviceClass and/or ModuleClasses definitions are necessary, it is strongly advised to closely follow the guidelines and definition style from the present document.


![SDT 4.0 Basic Elements](media/SDT_4_0_basic_elements.png)

**Figure 5.2.1-1: Design Structure of the Harmonized Information Model using SDT 4.0**-


The R/W column of the ModuleClasses' data point tables in clause [5.3](#53-moduleclasses) reflects the intentions of how a data point in a ModuleClass shall be used semantically. This is a "behavioural contract" between applications or users of the modelled devices on the semantic level. Further, the devices or IPE's (for NoDN) are expected to implement and control the mappings in clause [5.2.2](#522-description-rules-for-module-classes-and-deviceclasses) to implement this "behavioural contract".


### 5.2.2 Description rules for Module Classes and DeviceClasses
When the Harmonized Information Model is described based on SDT, the following rules shall be applied:


- Rule 1: CamelCase rule:

    - When naming each element, lowerCamelCase shall be used as the Java coding rules <a href="#_ref_2">[2]</a>.
    - Element names shall only contain upper and lower case alphanumerical characters in the ranges "a..z", "A..Z" and "0..9" as defined in <a href="#_ref_22">[22]</a>, and the underscore character "_". Element names shall not contain whitespace characters. 
    - The underscore character "_" shall only be used as a separator in element names that contain only uppercase characters.

- Rule 2: Rule for description of Action, DataPoint:

    - DataPoint shall be used to represent stateless operations. (e.g. *state* of [binarySwitch](#53112-binaryswitch) for on/off operations).
    - Action shall be used when describing stateful condition, handling unknown internal state conditions (e.g. [upVolume](#5318-audiovolume)/[downVolume](#5318-audiovolume) by increasing/decreasing the audioVolume in steps, handling transactional procedures, or checking integrity using username plus password at the same time).

- Rule 3: Rule for description of DataPoint and Property:

    - Non-functional information shall be described as a Property. Functional information shall be described as a DataPoint. (E.g. non-functional information: version, id; functional information: targetTemperature, targetVolume).

- Rule 4: Definition of the Domain:

    - The Domains are specified as "org.onem2m.[domain]", where [domain] is one of the domain names defined in [6.4.1](#641-introduction). The name is chosen according to the domain in which the element is defined. 
    - The sub-domains for DeviceClasses, SubDevices, ModuleClasses and Actions shall be specified as "org.onem2m.[domain].device", "org.onem2m.[domain].subdevice", "org.onem2m.[domain].moduleclass", and "org.onem2m.[domain].action" respectively.

- Rule 5: Naming rule for the element:

    - the name of each element should be concise and avoid repeating its parent element name; but
    - it may include the name of its parent element for readability. (e.g., lightDimmerUp, lightDimmerDown under lightDimmer);
    - all DeviceClasses, SubDevices, ModuleClasses, and Actions of a domain shall be uniquely named.

- Rule 6: Criteria for marking elements as optional or mandatory:

    - An element shall only be defined as mandatory if it is foreseen to be universally mandatory to all implementing technologies.

- Rule 7: Enumeration type:

    - When describing the meaning of values for enumeration type elements, they may be described under clause [5.6](#56-enumeration-type-definitions).
    - The enumeration types for the harmonized information model are based on &lt;xs:integer>, and the numeric values are interpreted as specified in clause [5.6](#56-enumeration-type-definitions). 
    - The name of an enumeration type shall start with the prefix "enum". This prefix shall not be used with non-enumeration type names.
    - All enumeration types are defined under the same domain called Horizontal Domain, which does not contain any other entity. They also shall use the same XSD name space identifiers as defined in clause [6.5.1](#651-introduction). Even if an enumeration type is used in multiple module classes from different domains, this enumeration type is defined only once.

- Rule 8: Rule for unit  in documentation :

    - SI (International Systems of Units in <a href="#_ref_20">[20]</a>) measurement (e.g. metre, kilogram, second) should be considered as first candidate.
    - Otherwise, it may be kept consistency with implementing technologies such as other SDO's specification.
    - Units of measures shall be given in the form of a shortcut compliant to table 5.2.2-1. 

**Table 5.2.2-1: Shortcuts for units**

|Original name |Short name |Explanation |
|-|-|-|
|Ampere |A | |
|Ampere Hour |Ah | |
|Bar |bar | |
|Celsius |°C | |
|Centimetres |cm | |
|Cubic metre |m3 | |
|Cubic metre per hour |m3/h | |
|Decibel |dB | |
|Decibel-milliwatts |dBm | |
|Degrees |deg | |
|Dots per inch |dpi |dpi is the common unit for spatial dot density |
|g-force |g-f | |
|Grams |g | |
|Hectopascal |hPa | |
|Hertz |Hz | |
|Kilocalories |kcal | |
|Kilocalories per hour |kcal/h | |
|Kilograms per square metre |kg/m2 | |
|Kilopascal |kPa | |
|kilovar |kvar | |
|Kilowatt |kW | |
|Megabyte |MB |1 MB = 1 024 x 1 024 bytes |
|MegaHertz |MHz | |
|Metre |m | |
|Metres per second |m/s | |
|Milligram per cubic metre |mg/m3 | |
|Microgram per cubic metre |µg/m3 | |
|Milligram per decilitre |mg/dl | |
|Milligram per litre |mg/L | |
|Millimetre |mm | |
|Millimetre of mercury |mmHg | |
|Milliseconds |ms | |
|Milliwatt per cubic centimetre |mW/cm2 | |
|Minute |min | |
|Odour unit per cubic metre |OU/m3 | |
|Ohm |ohm | |
|Parts per million |ppm | |
|Percent |pct | |
|Picofarad |pF | |
|Pixel |px | |
|Seconds |s  | |
|Siemens per metre |S/m | |
|Volt |V | |
|Watt |W | |
|Watt hour |Wh | |

<mark>NOTE: Popular unit in particular industrial domain should be considered  (e.g. cm for human height, calories for energy consumption in healthcare domain). It should be made coherent in the present document, as possible.</mark>



- Rule 9: Rule for type :

    - Measured and/or calculated values should be represented in float (without taking care of resolution of values).

      <mark>NOTE: It should be made coherent in the document, as possible. Unit should not be fixed as a rule but be decided with correspondence to each DeviceClass or ModuleClass.</mark>

- Rule 10: Inheritance of ModuleClasses :

    - A ModuleClass may inherit from another existing ModuleClass in order to provide additional functionalities based on the existing ModuleClass. However, inheritance from multiple ModuleClasses is not allowed (due to the "diamond problem" <a href="#_ref_i.6">[i.6]</a>).
    - Inheritance of ModuleClass shall only be used in the case that extending an existing ModuleClass is not appropriate, i.e. the functionality to be added is irrelevant to the original design purpose of the existing ModuleClass (e.g. adding a 'time' DataPoint to a '[binarySwitch](#53112-binaryswitch)' ModuleClass). 

- Rule 11: When to differentiate between current and target Data Points in ModuleClasses:

    - Device operations, which are executed when setting data points to specific values, may take some time to reach the desired result. For example, setting a new temperature to a heater does not immediately change the room temperature, but it may take some time for the heater to increase the temperature. Therefore, it is sometimes necessary to distinguish between current and target data points.
    - A ModuleClass shall provide an additional "target" data point when the "current" data point ...
      - is writeable, and
      - the functionality that is mapped to the data point is an operation, not a configuration function, and
      - the operation may take some time to start and/or to complete, or reach the desired result.  
    - When a ModuleClass provides current and target data points then the name for the current data point shall have the prefix "current", and the name for the target data point shall have the prefix "target". Both data points shall have the same suffix, for example "currentTemperature" and "targetTemperature".

- Rule 12: Algorithm to generate short names for DeviceClasses, ModuleClasses, Data Points, Actions:

    - Every domain in oneM2M defines their own short names, i.e. there may exist the same short name in more than one domain, but these short names are distinguished by the domain prefix.
    - Previous defined short names of the home domain, e.g. from a previous version of the specification, shall be taken into account. They are assigned to the same original names.
    - The algorithm to generate the short names from the original names works as follows:
      - The maximum length of a short name for TS-0023 is 5 characters. This length includes the optional appended distinguishing number (see below), but not the suffix for announced resources.
      - If the length of the original name is equal or less than 5 characters, then store the original name as an intermediate result.
      - Else, if the length of the original name is greater than 5 characters, then perform the following procedure:
        - The first and the last character of the original name are stored as first and second character as an intermediate result.
        - All the upper-case characters of the original name, starting with the first upper-case character, are inserted one by one before the last character of the intermediate result, up to a total length of 5 characters of the intermediate result.
        - In case the length of the intermediate result after these steps is less than 5 characters, then the intermediate result is filled with characters from the original string until the length of the intermediate result is 5 characters, following this procedure: the second character of the original name is inserted as the second character of the intermediate result while shifting all characters from the intermediate result by one character forward. This is repeated with the third, fourth, etc., character from the original name.
      - The intermediate result is now compared with all existing short names. If the intermediate result can be found in the list of existing short names, then execute the following steps until the intermediate result cannot be found in the list of previously defined short names:
        - Replace the last character of the intermediate result with an integer number, starting with 0. If the number becomes a two-digit number, then replace the last two characters of the intermediate result, and so forth.
        - Repeat the check described above. If the intermediate result is still the same as an existing short name, then the appended integer number is increased by 1, and the check is repeated.
      - The intermediate result is now stored as a new short name in the list of existing short names.
    - Short names for announced resources are created by taking the regular short name of the entity and appending the characters "Annc" to it. Short names for announced resources therefore have a maximum length of 9 characters.
    - Short names for [FlexContainerInstance] specializations for ModuleClasses, DeviceClasses, SubDeviceClasses, and Actions are created by taking the regular short name of the entity and appending the characters "Inst" to it. Short names for these resources therefore have a maximum length of 9 characters.

Table 5.2.2-2 provides some examples for short names that have been created by the described algorithm.

**Table 5.2.2-2: Examples for original name to short name mappings**

|Original name |short name |
|-|-|
|co2 |co2 |
|[clock](#53118-clock) |clock |
|currentJobMode |cuJMe |
|absoluteStartTime |abSTe |
|absoluteStopTime |abST0 |
|[impactSensor](#53147-impactsensor) |impSr |
|impactSensorAnnc |impSrAnnc |




- Rule 13: Rule for R/W column:

    - The value used in this column defines the interface as it applies to the user of this module. The entity that this module represents (device AE or IPE AE) can read or write to any or all of the data points as needed in order to implement the defined interface to the user.  &lt;accessControlPolicy> resources shall be defined to enforce access control to the data points of the module defined such that R in the R/W column has RETRIEVE accessControlOperations and  RW in the R/W column has RETRIEVE and UPDATE accessControlOperations.

- Rule 14: Rule for Optional and Multiplicity:

    - The value used in the "Optional" column of ModuleClass definitions is mapped to the "optional" element attribute for SDT DataPoint elements.
    - The value used in the "Multiplicity" column of DeviceClass and SubDevice definitions is mapped to "minOccurs" and "maxOccurs" element attribute for SDT DeviceClass elements as follows:
      - 1 : minOccurs = 1, maxOccurs = 1
      - 0..1 : minOccurs = 0, maxOccurs = 1
      - 0..N : minOccurs = 0, maxOccurs = unbound
      - 1..N : minOccurs = 1, maxOccurs = unbound



## 5.3 ModuleClasses

### 5.3.1 Common Domain

#### 5.3.1.1 threeDprinter

This ModuleClass provides capabilities for a 3D printer. 

**Table 5.3.1.1-1: Actions of threeDprinter**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|none |start3Dprint |none |true |Start 3D printing. |
|none |stop3Dprint |none |true |Stop 3D printing. |




**Table 5.3.1.1-2: DataPoints of threeDprinter ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|printType |[hd:enum3DprinterTechnology](#561-hdenum3dprintertechnology) |R |false | |The type of printing technology (see clause [5.6.1](#561-hdenum3dprintertechnology)). |
|printSizeX |xs:float |R |false |mm |This data point represents the maximum size of a printing object in the direction of X-axis. |
|printSizeY |xs:float |R |false |mm |This data point represents the maximum size of printing object in the direction of Y-axis. |
|printSizeZ |xs:float |R |false |mm |This data point represents the maximum size of printing object in the direction of Z-axis. |
|network |xs:boolean |R |false | |This value indicates the Wide Area Network (WAN) connectivity of the 3D printer, such as Internet or GSM.<br />"False" indicates that the printer does not have network connectivity to a WAN. "True" indicates that the printer has WAN network connectivity. |
|memorySize |xs:float |R |false |MB |This value represents the total memory size of the printer. The unit of measure is Megabyte (MB). |




#### 5.3.1.2 acousticSensor
This ModuleClass provides capabilities for an acoustic sensor. 


**Table 5.3.1.2-1: DataPoints of acousticSensor ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|loudness |xs:float |R |false |dB | |
|acousticStatus |xs:integer |R |true |pct |The acousticStatus is expressed in percent, whereas a value of 0 means "no sound" and a value of 100 means "most noisy". |




#### 5.3.1.3 airConJobMode
This ModuleClasses provides capabilities to control and monitor the job modes of an air conditioner.


**Table 5.3.1.3-1: DataPoints of airConJobMode ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentJobMode |[hd:enumAirConJobMode](#563-hdenumairconjobmode) |RW |false | |Currently active job mode (see clause [5.6.3](#563-hdenumairconjobmode)).  |
|currentJobModeName |xs:string |R |true | |Name of the current job mode as a string. This can be used when currentJobMode is vendor-specific. |
|jobModes |list of [hd:enumAirConJobMode](#563-hdenumairconjobmode) |R |false | |List of possible job states the device supports (see clause [5.6.3](#563-hdenumairconjobmode)).  |




#### 5.3.1.4 airFlow
This ModuleClass provides capabilities for controlling the air flow of a device.


**Table 5.3.1.4-1: DataPoints of airFlow ModuleClass**

|Name |Type |Readable |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|speed |xs:integer |RW |false | |The current speed level in the range of the [minSpeed, maxSpeed] data points. |
|minSpeed |xs:integer |R |true | |The minimum value for the speed level. If not present, the default is 0. |
|maxSpeed |xs:integer |R |true | |The maximum value for the speed level. If not present, the default is 100. |
|verticalDirection |[hd:enumVerticalDirection](#5636-hdenumverticaldirection) |RW |true | |The vertical direction of the air flow (see clause [5.6.36](#5636-hdenumverticaldirection)). |
|supportedVerticalDirection |List of [hd:enumVerticalDirection](#5636-hdenumverticaldirection) |R |true | |List of supported vertical directions. |
|horizontalDirection |[hd:enumHorizontalDirection](#5622-hdenumhorizontaldirection) |RW |true | |The horizontal direction of the air flow (see clause [5.6.22](#5622-hdenumhorizontaldirection)). |
|supportedHorizontalDirection |List of [hd:enumHorizontalDirection](#5622-hdenumhorizontaldirection) |R |true | |List of supported horizontal directions. |
|automode |xs:Boolean |RW |true | |Status of the automode feature. "True" indicates that the speed is set by the device, "False" indicates that the device is not controlling the speed. |




#### 5.3.1.5 airPurifierJobMode
This ModuleClasses provides capabilities to control and monitor the job modes of an airPurifier.

**Table 5.3.1.5-1: DataPoints of airPurifierJobMode ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentJobMode |[hd:enumAirPurifierJobMode](#564-hdenumairpurifierjobmode) |RW |false | |Currently active job mode (see clause [5.6.4](#564-hdenumairpurifierjobmode)).  |
|currentJobModeName |xs:string |R |true | |Name of the current job mode as a  string. This can be used when currentJobMode is vendor-specific. |
|jobModes |list of [hd:enumAirPurifierJobMode](#564-hdenumairpurifierjobmode) |R |false | |List of possible job states the device supports (see clause [5.6.4](#564-hdenumairpurifierjobmode)). |




#### 5.3.1.6 airQualitySensor
This ModuleClass provides capabilities for a monitoring sensor that measures the air quality.


**Table 5.3.1.6-1: DataPoints of airQualitySense ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|monitoringEnabled |xs:boolean |RW |true | |The current status of monitoring. "True" indicates enabled, and "False" indicates not enabled. |
|pm1 |xs:integer |R |true |µg/m3 |The concentration of particle matter under 1um.. The minimum value is 0. |
|pm25 |xs:integer |R |true |µg/m3 |The concentration of particle matter under 2,5um. The minimum value is 0. |
|pm10 |xs:integer |R |true |µg/m3 |The concentration of particle matter under 10um. The minimum value is 0. |
|tsp |xs:float |R |true |µg/m3 |Total suspended particle. |
|odor |xs:integer |R |true |OU/m3 |The concentration of odour that reflects air pollution. The minimum value is 0. |
|humidity |xs:float |R |true |pct |The measured humidity. The minimum value is 0, and the maximum value is 100. |
|temperature |xs:float |R |true |°C |The current temperature |
|airPressure |xs:float |R |true |KPa |The air pressure. |
|co |xs:float |R |true |mg/m3 |This value indicates the CO level. |
|co2 |xs:float |R |true |mg/m3 |This value indicates the CO2 level. |
|ch2o |xs:float |R |true |µg/m3 |This value indicates the CH2O level. |
|voc |xs:float |R |true |ppm |This value indicates the VOC (Volatile Organic Compounds). |
|no2  |xs:float |R |true |µg/m3 |This value indicates the concentration of NO2. |
|so2  |xs:float |R |true |µg/m3 |This value indicates the concentration of SO2. |
|o3 |xs:float |R |true |µg/m3 |This value indicates the concentration of O3. |
|noise |xs:float |R |true |dB |This value indicates the level of noise. |
|windDirection  |xs:float |R |true |deg |The wind direction. The value range is [0-359]. North is 0,0 degrees, east is 90,0 degrees, south is 180,0 degrees, west is 270,0 degrees. |
|windSpeed |xs:float |R |true |m/s |The wind speed |



#### 5.3.1.7 alarmSpeaker
This ModuleClass provides the capabilities to initiate and monitor an alarm.


**Table 5.3.1.7-1: DataPoints of alarmSpeaker ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|tone  |[hd:enumTone](#5634-hdenumtone) |RW |true | |Representing the tones of the alarm (see clause [5.6.34](#5634-hdenumtone)). |
|light |[hd:enumAlertColourCode](#565-hdenumalertcolourcode) |R |true | |Representing the lighting mode of the alarm (see clause [5.6.5](#565-hdenumalertcolourcode)). |
|alarmStatus |xs:boolean |R |false | |"True" indicates the alarm start while "False" indicates the alarm stop. |




#### 5.3.1.8 audioVolume
This ModuleClass provides capabilities to control and monitor volume


**Table 5.3.1.8-1: Actions of audioVolume**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|none |upVolume |none |true |Increase the volume by the amount of the stepValue up to the maxValue. |
|none |downVolume |none |true |Decrease the volume by the amount of the stepValue down to 0. |
|none |muteAudioVolume |none |true |Save the current audio volume and set the volume to 0. |




**Table 5.3.1.8-2: DataPoints of audioVolume**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|volumeValue |xs:integer |RW |false |pct |The rounded percentage of the current volume in the range of [0, maxValue]. 0 percentage shall mean no sound produced. |
|stepValue |xs:integer |R |true |pct |Step value used by the "upVolume" and "downVolume" actions. |
|maxValue |xs:integer |R |true |pct |Maximum value allowed for Volume. maxValue is 100 by default if "maxValue" is not provided. |
|muteEnabled |xs:boolean |RW |false | |The current status of the mute enablement. "True" indicates enabled (that is, no sound), and "False" indicates not enabled (that is, sound is played). |
|saveAudioVolume |xs:integer |RW |true |pct |Save the current audio volume for the muteAudioVolume |




#### 5.3.1.9 autoDocumentFeeder
This ModuleClasses provides capabilities to monitor the state of autoDocumentFeeder (ADF). ADF is a feature which takes several pages and feeds the paper one page at a time into a scanner or printer, allowing the user to scan, print or fax, multiple-page documents without having to manually replace each page.


**Table 5.3.1.9-1: DataPoints of autoDocumentFeeder ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentAdfState |[hd:enumAdfState](#562-hdenumadfstate) |R |false | |Current state of the ADF.  |
|adfStates |list of [hd:enumAdfState](#562-hdenumadfstate) |R |false | |List of possible ADF states that are supported by the device (see clause [5.6.2](#562-hdenumadfstate)). |




#### 5.3.1.10 battery
This ModuleClass provides capabilities to indicate the detection of low battery and gives an alarm if the triggering criterion is met. The level data point in the ModuleClass represents the current battery charge level.


**Table 5.3.1.10-1: DataPoints of battery ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|level |xs:integer |R |false |pct |The rounded percentage of the current charging level of a battery in the range of [0, 100]. 0 percentage shall mean that no charge remains. |
|capacity |xs:integer |R |true |mAh |The total capacity of battery in mAh. |
|rechargeable |xs:boolean |R |true | |To indicate the battery is rechargeable or not. "True" indicates rechargeable. |
|charging |xs:boolean |R |true | |The status of charging. "True" indicates enabled, and "False" indicates not enabled.  |
|discharging |xs:boolean |R |true | |The status of discharging. "True" indicates charging, and "False" indicates not charging. |
|lowBattery |xs:boolean |R |true | |To indicate that the battery is on a low charge level. |
|batteryThreshold |xs:integer |RW |true | |When a battery's "level" is less than "batteryThreshold" then "lowBattery" is set to "True". This data point can be used to raise an alarm, depending on the implementation. |
|chargingVoltage |xs:float |R |true |V |The voltage to charge the battery |
|chargingAmpere |xs:float |R |true |A |The ampere to charge the battery |
|dischargingVoltage |xs:float |R |true |V |The voltage to discharge the battery |
|dischargingAmpere |xs:float |R |true |A |The ampere to discharge the battery |
|batteryMaterial |[hd:enumBatteryMaterial](#5650-hdenumbatterymaterial) |R |true | |The material of the cell of the battery |
|batteryShape |[hd:enumBatteryShape](#5651-hdenumbatteryshape) |R |true | |The size of the battery such as "AAA". |




#### 5.3.1.11 binaryObject
This ModuleClass describes the handling of a binary object (blob). 

**Table 5.3.1.11-1: DataPoints of binaryObject ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|object |xs:string |RW |false | |This data point contains the base64 encoded binary object. |
|objectType |xs:string |RW |false | |This data point contains the type and subtype of the binary object as a MIME type. |
|size |xs:integer |RW |true | |The size of the decoded binary object. |
|hash |xs:string |RW |true | |The hash code of the blob. If present, it is used to check the decoded content of the "object" data point for integrity. The algorithm used for generating the hash value is SHA-2 <a href="#_ref_15">[15]</a>. The data point contains the hash as a hex encoded value. |




#### 5.3.1.12 binarySwitch
This ModuleClass provides capabilities to control and monitor the state of power.


**Table 5.3.1.12-1: Actions of binarySwitch ModuleClass**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|none |toggle |none |true |Toggle the switch. |




**Table 5.3.1.12-2: DataPoints of binarySwitch ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|state |xs:boolean |RW |false | |The current status of the binarySwitch. "True" indicates turned-on, and "False" indicates turned-off. |




#### 5.3.1.13 bioElectricalImpedanceAnalysis
This ModuleClass provides the analysis of human body tissue based on impedance measurement.


**Table 5.3.1.13-1: DataPoints of bioElectricalImpedanceAnalysis ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|water |xs:float |R |false |pct |The water content measurement from the BIA.  |
|fat |xs:float |R |false |pct |The fat content measurement from the BIA.  |
|muscle |xs:float |R |false |pct |The muscle content measurement from the BIA. |
|bone |xs:float |R |false |pct |The bone content measurement from the BIA.  |
|visceraFat |xs:float |R |false |pct |The viscera fat content measurement from the BIA. |
|kcal |xs:float |R |false |kcal |The kcal (kilocalories) measurement from the BIA. |
|resistance |xs:float |R |false |ohm |The resistance of human body.  |




#### 5.3.1.14 bodyCompositionAnalyser
This ModuleClass provides the capability to report the measurement of body composition analyser characteristics.

**Table 5.3.1.14-1: DataPoints of body composition analyser ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|bodyLength |xs:float |R |true |cm |The measurement of body length by Weight scale and Body composition analyser.  |
|bmi |xs:float |R |true |kg/m2 |The measurement of Body Mass Index (BMI) by a weight scale and a body composition analyser.  |
|fatFreeMass |xs:float |R |true |kg |The measurement of fat free mass by a weight scale and a body composition analyser. |
|softLeanMass |xs:float |R |true |kg |The measurement of soft lean mass by a weight scale and a body composition analyser. |
|muscleMass |xs:float |R |true |kg |The measurement of muscle mass by a weight scale and a body composition analyser. |
|basalMetabolism |xs:float |R |true |kcal |The measurement of basal metabolism by a weight scale and a body composition analyser. |
|impedance |xs:float |R |true |ohm |The measurement of impedance by a weight scale and a body composition analyser. |
|Mass |xs:float |R |true |kg |The measurement of  mass by a weight scale and a body composition analyser.  |
|bodyWaterMass |xs:float |R |true |kg |The measurement of body water mass by a weight scale and a body composition analyser.  |
|inorganicSaltMass |xs:float |R |true |g |The measurement of inorganic salt mass by a weight scale and a body composition analyser.  |
|somatotype |xs:string |R |true | |The measurement of somatotype by Weight scale and Body composition analyser.  |




#### 5.3.1.15 boiler
This ModuleClass provides capabilities to control the status of the boiling functionality for water heaters.


**Table 5.3.1.15-1: DataPoints of boiler ModuleClass**

|Name |Type |R-W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|status |xs:boolean |RW |false | |The status of boiling. "True" indicates boiling, "False" indicates not boiling. |




#### 5.3.1.16 brewing
This ModuleClass provides capabilities to control and monitor a brewing process. It is intended to be part of devices that prepare hot drinks such as a coffee or a tea.


**Table 5.3.1.16-1: DataPoints of brewing ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|cupsNumber |xs:integer |RW |false | |The current number of the cups requested to brew. |
|strength |[hd:enumTasteStrength](#5633-hdenumtastestrength) |RW |true | |The current strength of the drink taste (see clause [5.6.33](#5633-hdenumtastestrength)). A higher value indicates a stronger taste. |




#### 5.3.1.17 brightness
This ModuleClass provides capabilities to control and monitor the brightness of a light for example from a lamp. Brightness is scaled as a percentage. A lamp or a monitor can be adjusted to a level of light between very dim (0 % is the minimum brightness) and very bright (100 % is the maximum brightness).


**Table 5.3.1.17-1: DataPoints of brightness ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|brightness |xs:integer |RW |false |pct |The status of brightness level. |




#### 5.3.1.18 clock
This ModuleClass provides capabilities to control and monitor time and date information.


**Table 5.3.1.18-1: DataPoints of clock ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentTime |xs:time |RW |false | |Information of the current time  |
|currentDate |xs:date |RW |false | |Information of the current date |
|currentTimeZone |xs:string |RW |true | |Name of current time zone according to the IANA Timezone data format (TZ) <a href="#_ref_17">[17]</a>,  for example, "America/New York".  |




#### 5.3.1.19 clothesDryerJobMode
This ModuleClasses provides capabilities to control and monitor the job modes of a clothes dryer.

**Table 5.3.1.19-1: DataPoints of clothesDryerJobMode ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentJobMode |[hd:enumClothesDryerJobMode](#567-hdenumclothesdryerjobmode) |RW |false | |Currently active job mode  (see clause [5.6.7](#567-hdenumclothesdryerjobmode)).  |
|currentJobModeName |xs:string |R |true | |The name of current job mode as a string. This can be used when "currentJobMode" is vendor-specific. |
|jobModes |list of [hd:enumClothesDryerJobMode](#567-hdenumclothesdryerjobmode) |R |false | |List of possible job states the device supports. |




#### 5.3.1.20 clothesWasherJobMode
This ModuleClasses provides capabilities to control and monitor the job mode of a washer.


**Table 5.3.1.20-1: DataPoints of clothesWasherJobMode ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentJobMode |[hd:enumClothesWasherJobMode](#569-hdenumclotheswasherjobmode) |RW |false | |Currently active job mode (see clause [5.6.9](#569-hdenumclotheswasherjobmode)). |
|currentJobModeName |xs:string |RW |true | |The name of the current job mode as a string. This can be used when the currentJobMode is vendor-specific. |
|jobModes |list of [hd:enumClothesWasherJobMode](#569-hdenumclotheswasherjobmode) |R |false | |List of possible job states that the device supports (see clause [5.6.9](#569-hdenumclotheswasherjobmode)). |




#### 5.3.1.21 clothesWasherDryerJobMode
This ModuleClasses provides capabilities to control and monitor the job modes of clothesWasherDryer.

Table 5.3.1.21-1: DataPoints of clothesWasherDryerJobMode ModuleClass


|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentJobMode |[hd:enumClothesWasherDryerJobMode](#568-hdenumclotheswasherdryerjobmode) |RW |false | |Currently active job (see clause [5.6.8](#568-hdenumclotheswasherdryerjobmode)). |
|currentJobModeName |xs:string |RW |true | |The name of the current job mode as a string. This can be used when currentJobMode is vendor-specific. |
|jobModes |list of [hd:enumClothesWasherDryerJobMode](#568-hdenumclotheswasherdryerjobmode) |R |false | |List of possible job states the device supports (see clause [5.6.8](#568-hdenumclotheswasherdryerjobmode)). |




#### 5.3.1.22 clothesWasherJobModeOption
This ModuleClasses provides capabilities to control and monitor the washing job mode options of a washer.


**Table 5.3.1.22-1: DataPoints of clothesWasherJobModeOption ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|washTemp |[hd:enumGeneralTemperature](#5619-hdenumgeneraltemperature) |RW |true | |This data point represents the water temperature level  (see clause [5.6.19](#5619-hdenumgeneraltemperature)). |
|soilLevel |[hd:enumGeneralLevel](#5617-hdenumgenerallevel) |RW |true | |This data point represents the washing level (see clause [5.6.17](#5617-hdenumgenerallevel)). |
|spinSpeed |[hd:enumGeneralSpeed](#5618-hdenumgeneralspeed) |RW |true | |This data point represents the spin-dry speed level (see clause [5.6.18](#5618-hdenumgeneralspeed)). |
|preWash |xs:boolean |RW |true | |This data point indicates pre-wash. "True" indicates enabled, "False" indicates disabled. |
|speedWash |xs:boolean |RW |true | |This data point indicates speed wash. "True" indicates enabled, "False" indicates disabled. |
|steamTreat |xs:boolean |RW |true | |This data point indicates steam treat. "True" indicates enabled, "False" indicates disabled.  |
|coldWash |xs:boolean |RW |true | |This data point indicates cold wash. "True" indicates enabled, "False" indicates disabled. |
|extraRinse |xs:boolean |RW |true | |This data point indicates extra rinse. "True" indicates enabled, "False" indicates disabled. |




#### 5.3.1.23 colour
This ModuleClass provides the capabilities to set the value of the Red, Green, and Blue colour channels for a colour device.


**Table 5.3.1.23-1: DataPoints of colour ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|red |xs:integer |RW |false | |The value of the Red colour channel of RGB. The range is [0,255]. |
|green |xs:integer |RW |false | |The value of the Green colour channel of RGB. The range is [0,255]. |
|blue |xs:integer |RW |false | |The value of the Blue colour channel of RGB. The range is [0,255]. |




#### 5.3.1.24 colourSaturation
This ModuleClass provides capabilities to control and monitor a colour saturation value.


**Table 5.3.1.24-1: DataPoints of colourSaturation ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|colourSaturation |xs:integer |RW |false |pct |The status of colour saturation level. "colourSaturation" has a range of [0,100]. A "colourSaturation" value of 0 means that a device displays or produces black and white images. A "colourSaturation" value of 50 means that a  device displays or produces normal colour images. A "colourSaturation" value of 100 means that a device displays or produces very colourful images. |




#### 5.3.1.25 connectivity
This ModuleClass provides capabilities to monitor network connectivity. 

**Table 5.3.1.25-1: DataPoints of connectivity ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|rsrp |xs:integer |R |false |dBm |Reference signal received power (RSRP) is a measurement of the received power level in an LTE cell network. |
|rsrq |xs:integer |R |true |dB |Reference signal received quality (RSRQ) indicates the quality of the received reference signal. RSRQ is defined as the ratio NxRSRP/(E-UTRA carrier RSSI), where N is the number of RB's of the E-UTRA carrier RSSI measurement bandwidth. The measurements in the numerator and denominator shall be made over the same set of resource blocks. |
|cellID |xs:integer |R |true | |Serving Cell ID in case Network Bearer Resource is a Cellular Network. |
|rssi |xs:integer |R |true |dBm |In telecommunications, received signal strength indicator (RSSI) is a measurement of the power present in a received radio signal. |
|signalECL |xs:integer |R |true | |Based on measurements of the reference signal's received power, the UE will select an entry coverage enhancement level (ECL) to camp into the cell. The coverage level will determine the Narrowband Physical Random Access Channel (NPRACH) resources used by the device and will inform the eNB of the device receiver sensitivity conditions. |
|sinr |xs:integer |R |true |dB |Signal to interference plus noise ratio (SINR) is commonly used in wireless communication as a way to measure the quality of wireless connections. |
|pci |xs:string |R |true | |Physical Cell ID is an identification of a cell at physical layer. |
|dailyActivityTime |xs:integer |R |true |s |Daily communication time (Starts at 00:00h). |
|dailyNumberOfConnections |xs:integer |R |true | |Daily number of connections (Starts at 00:00h). |
|commFreqValue |xs:integer |R |true |MHz |Communication frequency value (commFreqValue) is the transmission frequency of the wireless signal. |
|currentCycleBegin |xs:datetime |R |true | |A timestamp that indicates the beginning of the current cycle for counting the transfer volume and transmission errors. |
|currentCycleVolume |xs:integer |R |true |bytes |Number of bytes transferred since currentCycleBegin. |
|currentCycleTransmissionErrors |xs:integer |R |true | |Number of transmission errors since currentCycleBegin. |
|minimumCommunicationLatency |xs:integer |R |true |s |The minimum time delay between the last communication attempt. |




#### 5.3.1.26 cookerHoodJobMode
This ModuleClasses provides capabilities to control and monitor the job modes of a cookerHood.


**Table 5.3.1.26-1: DataPoints of cookerHoodJobMode ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentJobMode |[hd:enumCookerHoodJobMode](#5610-hdenumcookerhoodjobmode) |RW |false | |The currently active job mode.  |
|currentJobModeName |xs:string |R |true | |The name of the current job mode as a string. This can be used when currentJobMode is vendor-specific. |
|jobModes |list of [hd:enumCookerHoodJobMode](#5610-hdenumcookerhoodjobmode) |R |false | |List of possible job states the device supports (see clause [5.6.10](#5610-hdenumcookerhoodjobmode)). |




#### 5.3.1.27 credentials
This ModuleClass provides the capability to manage user credentials which allows a user to authenticate on an appliance or a server that is associated with the appliance. The authentication depends on a user login and password, or on a token. An example appliance which may include this ModuleClass is a camera. 


**Table 5.3.1.27-1: DataPoints of credentials ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|loginName |xs:string |W |true | |The user's login name. |
|password |xs:string |W |true | |The user's password. |
|token |xs:string |W |true | |An authentication token, for example an OAuth token. |




#### 5.3.1.28 dehumidifierJobMode
This ModuleClasses provides capabilities to control and monitor the job modes of a dehumidifier device.


**Table 5.3.1.28-1: DataPoints of dehumidifierJobMode ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentJobMode |[hd:enumDehumidifierJobMode](#5611-hdenumdehumidifierjobmode) |RW |false | |The currently active job mode (see clause [5.6.11](#5611-hdenumdehumidifierjobmode)).  |
|currentJobModeName |xs:string |R |true | |The name of the current job mode as a string. This can be used when currentJobMode is vendor-specific. |
|jobModes |list of [hd:enumDehumidifierJobMode](#5611-hdenumdehumidifierjobmode) |R |false | |List of possible job states the device supports.  |




#### 5.3.1.29 dishWasherJobMode
This ModuleClasses provides capabilities to control and monitor the job modes of a dishWasher.


**Table 5.3.1.29-1: DataPoints: DataPoints of dishWasherJobMode ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentJobMode |[hd:enumDishWasherJobMode](#5612-hdenumdishwasherjobmode) |RW |false | |The currently active job mode.  |
|currentJobModeName |xs:string |R |true | |The name of the current job mode as a string. This can be used when the currentJobMode is vendor-specific. |
|jobModes |list of [hd:enumDishWasherJobMode](#5612-hdenumdishwasherjobmode) |R |false | |List of possible job states the device supports (see clause [5.6.12](#5612-hdenumdishwasherjobmode)). |




#### 5.3.1.30 doorStatus
This ModuleClass provides the status of a door. It is intended to be part of a device such as a refrigerator and an oven that might have multiple doors. 


**Table 5.3.1.30-1: DataPoints of doorStatus ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|doorState |[hd:enumDoorState](#5615-hdenumdoorstate) |R |false | |Current state of the door (see clause [5.6.15](#5615-hdenumdoorstate)). |
|openDuration |m2m:timestamp |R |true | |The time duration the door has been open.  |
|openAlarm |xs:boolean |RW |true | |The state of the door open alarm. "True" indicates that the open alarm is active. "False" indicates that the open alarm is not active. |




#### 5.3.1.31 electricVehicleConnector
This ModuleClass provides information about charging/discharging devices for electric vehicles.


**Table 5.3.1.31-1: DataPoints of electricVehicleConnector ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|status |xs:boolean |R |false | |The status of connection. "True" means connected, "False" means not connected. |
|chargingCapacity |xs:integer |R |true |Ah |Rated charging capacity. |
|dischargingCapacity |xs:integer |R |true |Ah |Rated discharging capacity. |




#### 5.3.1.32 energyConsumption
This ModuleClass describes the measured energy consumed by the device since power up. One particular use case for the energyConsumption ModuleClass is a smart meter.


**Table 5.3.1.32-1: DataPoints of energyConsumption ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|power |xs:float |R |true |W |The power of the device. |
|absoluteEnergyConsumption |xs:float |R |false |Wh |The absolute energy consumption, reflecting the real measurement of accumulative energy.  |
|roundingEnergyConsumption |xs:integer |R |true | |This energy consumption data is calculated by multiplying significantDigits with multiplyingFactors, and rounding down the result. |
|significantDigits |xs:integer |R |true | |The number of effective digits for data. |
|multiplyingFactors |xs:float |R |true | |The unit for data multiplying factors, for example 1 kWh, 0,1 kWh, 0,01 kWh etc. |
|voltage |xs:float |R |true |V |The voltage of the device. |
|current |xs:float |R |true |A |The current of the device.  |
|frequency |xs:float |R |true |Hz |The frequency of the device.  |
|measuringScope |xs:string |RW |true | |The measuring scope of the meter, for example the whole house, a room, or a device. |




#### 5.3.1.33 energyGeneration
This ModuleClass provides information about generation data on electric generator devices such as a photo voltaic power system, fuel cells, or microgeneration.


**Table 5.3.1.33-1: DataPoints of energyGenerationModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|powerGenerationData |xs:float |R |true |W |Amount of instantaneous generation data. |
|roundingEnergyGeneration |xs:integer |R |true | |This energy consumption data is calculated by multiplying significantDigits with multiplyingFactors, and rounding down the result. |
|significantDigits |xs:integer |R |true | |The number of effective digits for data. |
|multiplyingFactors |xs:float |R |true | |The unit for data multiplying factors, for example 1 kWh, 0,1 kWh, 0,01 kWh etc. |
|generationSource |xs:string |RW |false | |The type of generating source. |




#### 5.3.1.34 faultDetection
This ModuleClass provides information about whether a fault has occurred in a device.

**Table 5.3.1.34-1: DataPoints of faultDetection ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|status |xs:boolean |R |false | |The status of fault detection. |
|code |xs:integer |R |true | |The numeric representation of the fault. |
|description |xs:string |R |true | |The message representation of the fault. |




#### 5.3.1.35 filterInfo
This ModuleClass is for monitoring filter information of a device.


**Table 5.3.1.35-1: DataPoints of filterInfo ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|usedTime |xs:integer |R |false | |The cumulative used time in seconds of a filter |
|needsReplacement |xs:boolean |R |true | |This value indicates that the filter needs to be replaced. |
|filterLifetime |xs:integer |R |true |pct |Percentage lifetime remaining for the water filter. |




#### 5.3.1.36 foaming
This ModuleClass provides capabilities to control and monitor desired parameters of foam e.g. for foaming milk. It is initially intended to be part of a device that prepare drinks with milk (for example a coffee machine or hot chocolate machine).


**Table 5.3.1.36-1: DataPoints of foaming ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|foamingStrength |[hd:enumFoamStrength](#5616-hdenumfoamstrength) |RW |false | |The current strength of foamed milk. A higher value indicates more foamed milk (see clause [5.6.16](#5616-hdenumfoamstrength)). |




#### 5.3.1.37 galleryMode
This ModuleClass provides information about the mode of display. The galleryMode includes the display orientation, display interval and display order.  

**Table 5.3.1.37-1: DataPoints of galleryMode ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|displayOrientation |[hd:enumDisplayOrientation](#5614-hdenumdisplayorientation) |RW |false | |The orientation of display. |
|displayInterval |xs:integer |RW |true |s |The interval of changing display content. |
|displayOrder |[hd:enumDisplayOrder](#5613-hdenumdisplayorder) |RW |true | |The sequence of the displaying content. |


#### 5.3.1.38 gasChargingControl
This ModuleClass provides capabilities to recharge the gas meter. 

**Table 5.3.1.38-1: DataPoints of gasChargingControl ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|billingNumber |xs:string |RW |true | |The billing number of the remote recharge. |
|rechargeCredit |xs:float |RW |true | |Amount of recharge money in local currency. |
|surplusCredit |xs:float |R |true | |Amount of surplus money in local currency. |
|rechargeGas |xs:float |RW |true |m3 |Amount of recharge gas. |
|surplusGas |xs:float |R |true |m3 |Amount of surplus gas. |


#### 5.3.1.39 gasMeterAlarm
This ModuleClass provides capabilities to set service parameters of a gas meter. 


**Table 5.3.1.39-1: DataPoints of gasMeterAlarm ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|lowGasAlarm |xs:boolean |R |true | |The alarm of insufficient amount of gas. |
|lowCreditAlarm |xs:boolean |R |true | |The alarm of insufficient amount of money. |
|leakageAlarm |xs:boolean |R |true | |The alarm of gas leakage. |
|lockedDownAlarm |xs:boolean |R |true | |The alarm of the gas meter being locked. When the gas meter is in use, the lower wheel does not work, called the "dead meter". |
|largeFlowAlarm |xs:boolean |R |true | |The alarm of large flow occurring. The instantaneous flow passed exceeds the setting maximum flow of the gas meter. |
|magneticDisturb |xs:boolean |R |true | |The alarm of magnetic interference occurring. |
|singleCountAlarm |xs:boolean |R |true | |The alarm of single reed switch counting. The normal condition is that the double reed switches are working. If only a single reed switch is working, it means that the metering has a problem and shall fire the alarm. |


#### 5.3.1.40 gasMeterReportInfo
This ModuleClass provides information of measurements of a gas meter.

**Table 5.3.1.40-1: DataPoints of gasMeterReportInfo ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|totalUseValue |xs:float |R |false |m3 |The total consumption of gas. |
|valveStatus |xs:boolean |R |true | |The status of the gas meter valve.<br />"True": open<br />"False": close |


#### 5.3.1.41 geoLocation
This ModuleClass provides the capability to get or set geo-location information.


**Table 5.3.1.41-1: DataPoints of geoLocation ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|latitude |xs:float |RW |false |deg |The current latitude part of a geo-location.  |
|longitude |xs:float |RW |false |deg |The current longitude part of a geo-location.  |
|altitude |xs:float |RW |true |m |The optional current altitude part of a geo-location. |
|heading |xs:float |RW |true | |The azimuth of a device measured in degrees to true north. North is 0,0 degrees, east is 90,0 degrees, south is 180,0 degrees, west is 270.0 degrees. A negative value indicates an unknown heading. |
|horizontalAccuracy |xs:float |R |true | |The optional current horizontal accuracy of the geo-location. The unit of measures is meters and describes a radius around the latitude/longitude coordinate. |
|verticalAccuracy |xs:float |R |true |m |The optional current vertical accuracy of the altitude. |
|headingAccuracy |xs:float |R |true |deg |The optional current maximum deviation between the heading and the true geomagnetic heading. |
|targetLatitude |xs:float |RW |true |deg |The optional target latitude part of a geo-location. This can be used to move a device to a new location. |
|targetLongitude |xs:float |RW |true |deg |The optional target longitude part of a geo-location. This can be used to move a device to a new location. |
|targetAltitude |xs:float |RW |true |m |The optional target altitude part of a geo-location. This can be used to move a device to a new altitude. |

?    


#### 5.3.1.42 glucometer
This ModuleClass provides the capability to report the measurement of glucose characteristics. 


**Table 5.3.1.42-1: DataPoints of glucometer ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|concentration |xs:float |R |false |mg/dl |The measurement of concentration by Glucometer. |
|hba1c |xs:float |R |true |pct |The measurement of HbA1c by Glucometer.  |
|contextExercise |xs:float |R |true |pct |The measurement of context exercise by Glucometer.  |
|contextMedication |xs:float |R |true |mg/dl |The measurement of context medication by Glucometer. |
|contextCarbohydratesAmount |xs:float |R |true |g |The measurement of context carbohydrates by Glucometer. |
|contextCarbohydratesSource |xs:string |R |true | |The timing of meals (for example "breakfast carbohydrates"). |
|contextMeal |xs:string |R |true | |The style of meals (for example "casual"). |
|contextLocation |xs:string |R |true | |The body location where the Glucometer is worn (for example "finger"). |
|contextTester |xs:string |R |true | |The test style (for example "self"). |
|contextHealth |xs:string |R |true | |The severity of symptoms (for example "minor"). |




#### 5.3.1.43 grinder
This ModuleClass is for controlling a grinder, for example in a coffee machine. 


**Table 5.3.1.43-1: DataPoints of grinder ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|useGrinder |xs:boolean |RW |false | |The current status of the grinder enablement. "True" indicates enabled, and "False" indicates disabled. |
|coarseness |[hd:enumGrindCoarseness](#5621-hdenumgrindcoarseness) |RW |true | |The wished coarseness of the solid supplies after grinding, for example for coffee beans (see clause [5.6.21](#5621-hdenumgrindcoarseness)). |
|grainsRemaining |[hd:enumGrainsLevel](#5620-hdenumgrainslevel) |R |true | |The level of remaining grains in a machine having a grinder, for example for remaining coffee beans in the coffee machine grinder (see clause [5.6.20](#5620-hdenumgrainslevel)). |




#### 5.3.1.44 heatingZone
This ModuleClass provides the capabilities to monitor the status of the heating zone, for example for a cooktop.


**Table 5.3.1.44-1: DataPoints of heatingZone ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|heatingLevel |xs:integer |R |false | |The current heating level of the zone. The value range is from 0 (indicating that the zone is not heating) up to the maxHeatingLevel. |
|maxHeatingLevel |xs:integer |R |false | |The maximum value allowed for the heating level of the zone. |




#### 5.3.1.45 height
This ModuleClass provides the capability to report the measurement of height.


**Table 5.3.1.45-1: DataPoints of height ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|height |xs:float |R |false |cm |The height measurement. |




#### 5.3.1.46 hotWaterSupply
This ModuleClass provides information about the status of supplying hot water into tanks or bath tubs.


**Table 5.3.1.46-1: DataPoints of hotWaterSupply ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|bath |xs:boolean |RW |true | |The status of whether a bath tub is filled. |




#### 5.3.1.47 impactSensor
This ModuleClass describes the capabilities on an impact sensor. The impact is a high force or shock over a short time period and the impactSensor detects this.


**Table 5.3.1.47-1: DataPoints of impactSensor ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|impactStatus |xs:boolean |R |false | |The "impactStatus" indicates as follows:<br />"True"  means that a physical impact is detected, "False" means indicates a normal status (no impact detected). |
|impactLevel |xs:float |R |true | |The "impactLevel" provides the level of impact. The unit of measure is "g" (G-force). |
|impactDirectionHorizontal |xs:float |R |true | |The "impactDirection" indicates the horizontal direction where the impact comes from. The value is 0 to 360 degrees. 0 is the front of the sensor and with clockwise increment.   |
|impactDirectionVertical |xs:float |R |true | |The "impactDirection" indicates the vertical direction where the impact comes from. The value is 0 to 360 degrees. 0 is the front of the sensor and with upward increment. |




#### 5.3.1.48 keepWarm
This module allows to control the 'keep warm' feature in devices like coffee machines, kettles etc. It allows to keep water warm for a desired time. This ModuleClass inherits from [binarySwitch](#53112-binaryswitch) (see clause [5.3.1.12](#53112-binaryswitch)) to store setting for the 'keep warm' feature. If the "state" data point in a keepWarmSwitch is "True" then the 'keep warm' function will be performed just after boiling (or heating) process is finished (otherwise this function will not be applied).


**Table 5.3.1.48-1: DataPoints of keepWarm ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|time |xs:integer |RW |true | |The desired duration of 'keep water warm' function. It indicates how long water shall be kept warm, for example after the boiling in a kettle. The value indicates a time expressed in minutes. |
|targetTemperature |xs:float |RW |true |C |Content temperature. |




#### 5.3.1.49 keypad
This ModuleClass provides the capability to perform a user defined service through the key-in number. For example, a user can define key 1 as "perform a take-out from a restaurant with combo meal 1". The IoT service provider or user can define the services. 


**Table 5.3.1.49-1: DataPoints of keypad ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|keyNumber |xs:integer |R |false | |The number of the pressed key. |




#### 5.3.1.50 liquidLevel
This ModuleClass provides the desired level of water (or other liquid)  for an appliance, for example the desired level of milk for a cup of coffee from a coffee machine. 


**Table 5.3.1.50-1: DataPoints of liquidLevel ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|liquidLevel |[hd:enumLiquidLevel](#5624-hdenumliquidlevel) |RW |false | |The desired level of water or other liquid, for example the desired level of milk in a cup of coffee (see clause [5.6.24](#5624-hdenumliquidlevel)). |




#### 5.3.1.51 liquidRemaining
This ModuleClass provides the status of water level (or other liquid) for an appliance, for example the level of remaining milk in a coffee machine.


**Table 5.3.1.51-1: DataPoints of liquidRemaining ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|liquidRemaining |[hd:enumLiquidLevel](#5624-hdenumliquidlevel) |R |false | |The remaining level of water or other liquid in an appliance (see clause [5.6.24](#5624-hdenumliquidlevel)). |




#### 5.3.1.52 lock
This ModuleClass provides the function to lock and unlock an object. 


**Table 5.3.1.52-1: DataPoints of lock ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|lock |xs:boolean |RW |false | |"True" indicates the object is locked, while "False" indicates the object is not locked. |




#### 5.3.1.53 mediaSelect
This ModuleClass provides capabilities to control and monitor media input and output of device such as TV or SetTopBox.


**Table 5.3.1.53-1: DataPoints of mediaSelect ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|mediaID |xs:integer |RW |false | |The numeric index of the activated media in the supported media sources list "supportedMediaSources". |
|supportedMediaSources |list of [hd:enumSupportedMediaSources](#5632-hdenumsupportedmediasources) |R |false | |List of supported input or output media for the given device (see clause [5.6.32](#5632-hdenumsupportedmediasources)). |
|mediaName |xs:string |R |true | |Specifies a pre-defined media input or output. |
|status |xs:boolean |R |true | |Specifies whether the specific media instance is selected ("True") or not ("False"). |
|mediaType |[hd:enumSupportedMediaSources](#5632-hdenumsupportedmediasources) |R |false | |Specifies the type of the media (see clause [5.6.32](#5632-hdenumsupportedmediasources)). |




#### 5.3.1.54 motionSensor
This ModuleClass provides the capabilities to indicate the occurrence of motion and raising of an alarm if the triggering criterion is met. 


**Table 5.3.1.54-1: DataPoints of motionSensor ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|alarm |xs:boolean |R |false | |The detection of the motion occurrence. |
|silentTime |xs:integer |RW |true |s |The time that a motionSensor restrains from sending an alarm in case continuous motions are detected after one alarm is produced. This data point can be used to avoid repeated alarm reports.  |
|sensitivity |xs:integer |RW |true | |The level of the detection accuracy of the motion sensor. This data point can be used to control the number of the report. |




#### 5.3.1.55 numberValue
This ModuleClass provides the capabilities to represent a number. It also has capabilities for controlled increment and decrement a counter. It can be used to present a number-related functionality in a technology where there is only a weak semantic specification of that functionality. 


**Table 5.3.1.55-1: Actions of numberValue ModuleClass**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|none |decrementNumberValue |none |true |Decrement the "numberValue" by the value of "step", down to the value of "minimum". |
|none |incrementNumberValue |none |true |Increment the "numberValue" by the value of "stepValue", up to the value of "maxValue". |
|none |resetNumberValue |none |true |Reset the "numberValue" to its "defaultValue". |




**Table 5.3.1.55-2: DataPoints of numberValue ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|numberValue |xs:float |RW |false | |The actual value of the number. |
|minValue |xs:float |RW |true | |The optional minimum value of the number. The default is the system-specific minimum value for a float value. |
|maxValue |xs:float |RW |true | |The optional maximum value of the number. The default is the system-specific maximum value for a float value. |
|defaultValue |xs:float |RW |true | |The optional default value for the number. The default is 0,0 . |
|step |xs:float |RW |true | |The optional step size for controlled increment and decrement. The default is 1.0 , even when this data point is not implemented. |




#### 5.3.1.56 openLevel
This ModuleClass provides the capabilities to control and monitor the open status of an entity, for example a curtain.


**Table 5.3.1.56-1: Actions of openLevel ModuleClass**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|none |open |None |true |Increase the open level by the amount of the "stepValue" up to the "maxLevel". |
|none |close |None |true |Decrease the open level by the amount of the "stepValue" down to the "minLevel". |




**Table 5.3.1.56-2: DataPoints of openLevel ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|openLevel |xs:integer |RW |false |pct |The rounded percentage of the current open level of entity in the range of [0, 100]. 0 percentage shall mean the entity is closed. |
|stepValue |xs:integer |RW |true | |The step value used by the "open" and "close" actions. |
|minLevel |xs:integer |RW |true | |The minimum value allowed for the "openLevel" status. The default value is 0, which means fully closed. |
|maxLevel |xs:integer |RW |true | |The maximum value allowed for the "openLevel" status. The default value is 100, which means fully opened. |




#### 5.3.1.57 operationMode
This ModuleClasses provides capabilities to control or monitor the operation mode of appliances.


**Table 5.3.1.57-1: DataPoints of operationMode ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|startPause |xs:boolean |RW |false | |A value of "True" triggers or starts an operation, and "False" pauses the operation. |




#### 5.3.1.58 overcurrentSensor
This ModuleClass provides capabilities for an over-current sensor. 

**Table 5.3.1.58-1: DataPoints of overcurrentSensor ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|overcurrentStatus |xs:boolean |R |false | |The overcurrentStatus indicates as follows:<br />"True" indicates that an over-current is detected, and "False" indicates a normal status, this means that an over-current is not detected. |
|detectedTime |m2m:timestamp |R |true | |The time when the over-current was detected. |
|duration |xs:float |R |true |ms |The duration of the detected over-current. |




#### 5.3.1.59 oximeter
This ModuleClass provides the capability to report the measurement of blood oxygen characteristics. 


**Table 5.3.1.59-1: DataPoints of oximeter ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|oxygenSaturation |xs:integer |R |false |pct |The measurement of oxygen saturation by Oximeter.  |




#### 5.3.1.60 ozoneMeter
This ModuleClass provides capabilities for an ozone meter. The "ozoneValue..." attributes are optional, but one of them SHALL be provided.


**Table 5.3.1.60-1: DataPoints of ozoneMeter ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|ozoneValuePPM |xs:float |R |true |ppm | |
|ozoneValueMG |xs:float |R |true |mg/m | |
|ozoneStatus |[hd:enumOzoneStatus](#5626-hdenumozonestatus) |R |true | |The ozoneStatus indicates the level of ozone status. (see clause [5.6.26](#5626-hdenumozonestatus)).  |
|maxValue |xs:float |R |true | |The maximum value shows the measurement range of the ozone meter (for example maxValue=5 means the range is 0 to 5 ppm). This attribute is only used that the ozone meter provides "ppm" value. |




#### 5.3.1.61 magneticSensorParameters
This ModuleClass provides capabilities to set service parameters for parking detectors. 


**Table 5.3.1.61-1: DataPoints of magneticSensorParameters ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|detectionInterval |xs:integer |RW |false |s |Time interval for detecting the geomagnetic field strength. |
|initialMagnetic |xs:float |RW |true | |The value of initial geomagnetic field strength, which is usually set when the parking detector is initially installed. It may be reset later if the geomagnetic field strength of the local environment is affected by other factors. The value is used as the reference threshold to determine the parkingStatus. When the parking detector detects that the strength of the magnetic field is greater than the initialMagnetic, the parkingStatus is set to "true", otherwise, the parkingStatus is set to "false". |
|magneticSensitivityLevel |xs:integer |RW |true | |The level of detection sensitivity. It is implementation specific. |
|highMagneticAlarm |xs:boolean |R |false | |The alarm of high magnetic interference. The alarm threshold is implementation specific. |


#### 5.3.1.62 parkingStatus
This ModuleClass provides the status of the parking detector.

**Table 5.3.1.62-1: DataPoints of parkingStatus ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|parkingStatus |xs:boolean |R |false | |This value indicates the status of the parking space.<br />"False": not occupied. <br />"True": occupied. |


#### 5.3.1.63 periodicalReportConfig
This ModuleClass provides capabilities to set parameters of periodic report.

**Table 5.3.1.63-1: DataPoints of periodicalReportConfig ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|backoffTime |xs:integer |RW |false |s |The number of seconds to wait before connecting to network. |
|period |xs:integer |RW |true |s |Reporting period. |
|retryTimes |xs:integer |RW |true | |The maximum number of re-sent attempts in the case of report failure. |
|retryInterval |xs:integer |RW |true |s |The minimum time interval between each message transmission retry. |



#### 5.3.1.64 phoneCall
This ModuleClass provides the capability get or set the caller and recipient IDs as well as to initiate and terminate a call.


**Table 5.3.1.64-1: Actions of phoneCall ModuleClass**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|none |call |none |true |Initiate an outgoing call. |
|none |answer |none |true |Answer (pickup) an incoming call. |
|none |hangup |none |true |Hangup an established call. |




**Table 5.3.1.64-2: DataPoints of phoneCall ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|callerID |xs:string |RW |false | |This data point represents the initiating caller identification of a call. In case of an outgoing call this would be the local line ID. This data point is optional. When it is empty for an incoming call, then the caller ID is unknown. When it is empty for an outgoing call, then it is expected that it is set by the PBX or the operator. The format of caller ID is not specified here. |
|recipientID |xs:string |RW |false | |This data point represents the receiving caller identification of a call. In case of an incoming call this would be the local line ID and optionally extension. The format of caller ID is not specified here. |
|callState |[hd:enumCallState](#566-hdenumcallstate) |R |true | |This data point represents the current state of an associated phone device regarding calls. |




#### 5.3.1.65 playerControl
This ModuleClass provides capabilities to control and monitor the operational modes of a media player functionality.


**Table 5.3.1.65-1: Actions of playerControl ModuleClass**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|none |nextTrack |none |true |Go forward to a next chapter, section or similar marker in the media. |
|none |previousTrack |none |true |Go back to a previous chapter, section or similar marker in the media. |




**Table 5.3.1.65-2: DataPoints of playerControl ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentPlayerMode |[hd:enumPlayerMode](#5627-hdenumplayermode) |RW |false | |The current mode of the player. |
|currentPlayerModeName |xs:string |R |true | |Name of current player mode in string. This can be used when "currentPlayerMode" is vendor-specific. |
|supportedPlayerModes |list of [hd:enumPlayerMode](#5627-hdenumplayermode) |R |false | |List of supported modes for a player. |
|speedFactor |xs:float |RW |true | |The optional factor of speeding up or slowing down playback, rewind or fast forward. |




#### 5.3.1.66 powerSave
This ModuleClass provides capabilities to enable the power saving mode of a device and monitor the current status.


**Table 5.3.1.66-1: DataPoints of powerSave ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|powerSaveEnabled |xs:boolean |RW |false | |The current status of the power saving mode. "True" indicates enabled, and "False" indicates not enabled. |




#### 5.3.1.67 printQueue
This ModuleClass provides the capabilities for monitoring printing list information. 


**Table 5.3.1.67-1: DataPoints of printQueue ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|uri |list of xs:uri |trueR |false | |The URI of the printing file. The URI could be "file://www.example.com/file.extension". |
|printingState |list of [hd:enumJobState](#5623-hdenumjobstate) |R |false | |The printingState is indicating the status of the printing file. <br><mark>Editor Note: Better mapping explanation needed. This doesn't seem to be the same as the usual list of enums used in other ModuleClasses</mark> |




#### 5.3.1.68 pulsemeter
This ModuleClass provides the capability to report the measurement of pulse characteristics. 

**Table 5.3.1.68-1: DataPoints of pulsemeter ModuleClass**

|Name |Type |R-W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|pulseRate |xs:float |R |false |bpm |The measurement of pulserate by pulse meter.  |
|rr |xs:float |R |true |ms |The measurement of RR interval by pulse meter.  |
|energy |xs:float |R |true |kcal/h |The measurement of energy by pulse meter.  |
|modality |xs:string |R |true | |The modality of a particular SpO2 measurement. |




#### 5.3.1.69 pushButton
This ModuleClass provides the capability to indicate the operation of a push button style switch. A typical application can be an SOS button.


**Table 5.3.1.69-1: DataPoints of pushButton ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|pushed |xs:boolean |R |false | |This data point indicates the press of the button. |




#### 5.3.1.70 recorder
This ModuleClass provides the capability to record video/audio for a defined duration.


**Table 5.3.1.70-1: DataPoints of recorder ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|duration |xs:integer |RW |false |s |The duration for video/audio recording. Set to trigger the recorder.  |




#### 5.3.1.71 refrigeration
This ModuleClass provides capabilities for a refrigeration function.


**Table 5.3.1.71-1: DataPoints of refrigeration ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|rapidFreeze |xs:boolean |RW |true | |Controls the rapid freeze capability. "True" indicates active, "False" indicates inactive. |
|rapidCool |xs:boolean |RW |true | |Controls the rapid cool capability. "True" indicates active, "False" indicates inactive. |
|defrost |xs:boolean |RW |true | |Controls the defrost cycle. "True" indicates active, "False" indicates inactive. |
|deodorize |xs:boolean |RW |true | |Controls the deodorize cycle. "True" indicates active, "False" indicates inactive. |
|degerm |xs:boolean |RW |true | |Controls the degerm cycle. "True" indicates active, "False" indicates inactive. |




#### 5.3.1.72 relativeHumidity
This ModuleClass provides the capability for a device to report the humidity based on a specified rule that is vendor dependent.


**Table 5.3.1.72-1: DataPoints of relativeHumidity ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|relativeHumidity |xs:float |R |false |pct |The measurement of the relative humidity value. |
|desiredHumidity |xs:float |RW |true |pct |Desired value for humidity. This data point indicates the desired humidity. |




#### 5.3.1.73 remoteControlEnable
This ModuleClasses provides capabilities to monitor the remote controllability of the appliance. 


**Table 5.3.1.73-1: DataPoints of remoteControlEnable ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|remoteControlEnabled |xs:boolean |R |false | |This data point enables or disables remote controllability and is set by a user locally. "True" indicates  enabled remote access, and "False" indicates disabled remote access. |




#### 5.3.1.74 robotCleanerJobMode
This ModuleClasses provides capabilities to control and monitor the job modes of a robotCleaner.


**Table 5.3.1.74-1: DataPoints of robotCleanerJobMode ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentJobMode |[hd:enumRobotCleanerJobMode](#5628-hdenumrobotcleanerjobmode) |RW |false | |Currently active job mode (see clause [5.6.28](#5628-hdenumrobotcleanerjobmode)).  |
|currentJobModeName |xs:string |R |true | |Name of current job mode as a string. This can be used when "currentJobMode" is vendor-specific. |
|jobModes |list of [hd:enumRobotCleanerJobMode](#5628-hdenumrobotcleanerjobmode) |R |false | |List of possible job states the device supports (see clause [5.6.28](#5628-hdenumrobotcleanerjobmode)). |




#### 5.3.1.75 runState
This ModuleClasses provides capabilities to control and the monitor machine state of appliances.


**Table 5.3.1.75-1: DataPoints of runState ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentMachineState |[hd:enumMachineState](#5625-hdenummachinestate) |RW |false  | |The currently active machine state  (see clause [5.6.25](#5625-hdenummachinestate)). |
|machineStates |list of [hd:enumMachineState](#5625-hdenummachinestate) |R |false | |A list of possible machine states the device supports (see clause [5.6.25](#5625-hdenummachinestate)). |
|currentJobState |[hd:enumJobState](#5623-hdenumjobstate) |R |true  | |The currently active job state at the level of some transaction being executed by the device  (see clause [5.6.23](#5623-hdenumjobstate)). |
|jobStates |list of [hd:enumJobState](#5623-hdenumjobstate) |R |true | |The list of possible job states that the device supports (see clause [5.6.23](#5623-hdenumjobstate)). |
|progressPercentage |xs:float |R |true |pct |The indication of current job progress in percentage. |




#### 5.3.1.76 securityMode
This ModuleClasses provides capabilities to control and monitor a security mode.


**Table 5.3.1.76-1: DataPoints of securityMode ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentSecurityMode |[hd:enumSecurityMode](#5629-hdenumsecuritymode) |RW |false  | |Current security mode (see clause [5.6.29](#5629-hdenumsecuritymode)). |
|securityModes |list of [hd:enumSecurityMode](#5629-hdenumsecuritymode) |R |false | |List of possible security modes the device supports (see clause [5.6.29](#5629-hdenumsecuritymode)). |




#### 5.3.1.77 sessionDescription
This ModuleClass provides the capabilities for a sessionDescription containing a URL at which the specified media can be accessed and the definition of media using SDP.


**Table 5.3.1.77-1: DataPoints of mediaType ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|url |xs:uri |R |true | |A URL at which the specified media can be accessed. |
|sdp |xs:string |R |true | |Media description using SDP. One or more comma separated multiple SDP lines (SDP media or attribute line) can be included using SDP description syntax as defined in the SDP specification in IETF RFC4566 <a href="#_ref_16">[16]</a>. |




#### 5.3.1.78 signalStrength
This ModuleClass provides the capability to monitor the strength of the signal.


**Table 5.3.1.78-1: DataPoints of signalStrength ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|lqi |xs:integer |R |false |pct |The current value of link quality indicator, which reflects the scaling of rssi by dividing the received signal strength over reference signal strength. The common unit for lqi is percentage [0,100]. For the detailed definition, see IEEE 802.15.4 <a href="#_ref_i.4">[i.4]</a>, clause 6.7.8. |
|rssi |xs:float |R |true | |The current value of received signal strength indicator, which reflects the raw signal level. |

NOTE: Need further study for this module class.


#### 5.3.1.79 slcAlarm
This ModuleClass provides capabilities to provide alarm information of street light controller. 

**Table 5.3.1.79-1: DataPoints of slcAlarm ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|overCurrentThreshold |xs:float |RW |true |A |The threshold of over current. |
|overCurrentDuration |xs:integer |RW |true |min |The duration of over current to trigger the alarm. |
|underCurrentThreshold |xs:float |RW |true |A |The threshold of under current. |
|underCurrentDuration |xs:integer |RW |true |min |The duration of under current to trigger the alarm. |
|overVoltageThreshold |xs:float |RW |true |V |The threshold of over voltage. |
|overVoltageDuration |xs:integer |RW |true |min |The duration of over voltage to trigger the alarm. |
|underVoltageThreshold |xs:float |RW |true |V |The threshold of under voltage. |
|underVoltageDuration |xs:integer |RW |true |min |The duration of under voltage to trigger the alarm. |
|overVoltagePercent |xs:integer |RW |true |pct |The threshold of over current in terms of percentage. The value range is [0,100]. This is the alternative trigger of the overVoltageAlarm and should be mutually exclusive to the overVoltageThreshold.  |
|underVoltagePercent |xs:integer |RW |true |pct |The duration of under current in terms of percentage. The value range is [0,100]. This is the alternative trigger of the underVoltageAlarm and should be mutually exclusive to the underVoltageThreshold. |
|standardreferenceVoltage |xs:float |RW |true |V |The reference voltage used as the basis of the overVoltagePercent and underVoltagePercent. |
|overCurrentAlarm |xs:boolean |R |false | |The alarm of over current. |
|underCurrentAlarm |xs:boolean |R |false | |The alarm of under current. |
|overVoltageAlarm |xs:boolean |R |false | |The alarm of over voltage. |
|underVoltageAlarm |xs:boolean |R |false | |The alarm of under voltage. |


#### 5.3.1.80 slcParameterSetting
This ModuleClass provides capabilities to set service parameters. 

**Table 5.3.1.80-1: DataPoints of slcParameterSetting ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|lightCount |xs:integer |RW |true | |Number of lamp holders controlled by the street light controller. |
|timePlanStatus |xs:boolean |RW |true | |"False" indicates the time plan is not used. "True" indicates the time plan is being used. |
|timeRangeCount |xs:integer |RW |true | |The number of time ranges for the time plan. |
|timeRange |list of xs:time |RW |true | |An array of sequential time points which define the time plan. Each time point is the start time of the next time range as well as the end of previous time range in the time plan. |
|timeRangeLightDimmingValue |list of xs:string |RW |true | |An array containing the dimming values in different time ranges. In the case that lightCount is larger than 1, it is a 2-dimensional array describing the dimming value of each lamp holder in each time range.  |


#### 5.3.1.81 slcReportInfo
This ModuleClass provides information of status of the street light controller.

**Table 5.3.1.81-1: DataPoints of slcReportInfo ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|voltageFrequency |xs:float |R |true |Hz |The frequency of voltage. |
|switchStatus |xs:boolean |RW |false | |This value indicates the status of light switch. "False": off, "True": on. |
|onlineStatus |xs:boolean |R |true | |This value indicates the communication status of light. "False": offline, "True": online. |
|lightVoltage |xs:float |R |false |V |The voltage of the street light controller. |
|lightCurrent |xs:float |R |false |A |The current of the street light controller. |
|lightDimmingValue |xs:integer |RW |false |pct |The dimming value of the street light. |
|lightPowerFactor |xs:float |R |false | |The light power factor is the ratio of active power to apparent power. Power factor is a factor that measures the efficiency of electrical equipment. The value range is [0,1]. |
|lightActivePower |xs:float |R |true |kW |Active power is the electrical power required to keep the electrical equipment running normally, that is, the electrical power that converts electrical energy into other forms of energy, such as mechanical, optical, thermal, and so on. |
|lightReactivePower |xs:float |R |true |kVA |The reactive power is the electrical power required to establish an alternating magnetic field and induced magnetic flux. |
|lightApparentPower |xs:float |R |true |kVA |This value indicates the apparent power that is mainly used to calculate the energy consumption of the street light. |
|lightPolarizationAxis |xs:float |R |true |degree |The angle of the polarization axis in case street light devices support this feature. |
|colourTemperature |xs:integer |R |true |K |The current colour temperature of the street lights. |
|lampTechnology |xs:string |R |true | |A string that indicates the type of lamp technology that is used in the street lamps, e.g. "LED", "Tungsten", etc |


#### 5.3.1.82 smokeSensor
This ModuleClass provides the capabilities to indicate the detection of smoke and raising an alarm if the triggering criterion is met. 


**Table 5.3.1.82-1:: Actions of smokeSensor ModuleClass**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|none |muteSmokeSensor |none |true |Mute the smoke sensor alarm. |
|none |test |none |true |Testing the alarm |




**Table 5.3.1.82-2: DataPoints of smokeSensor ModuleClass**

|Name |Type |R-W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|alarm |xs:boolean |R |false | |The alarm is indicated as follows:<br />"True" indicates that smoke has been detected, "False" indicates a normal status, that means that smoke is not detected. |
|detectedTime |m2m:timestamp |RW |true | |The date and time the smoke is detected. |
|smokeThreshold |xs:integer |RW |true |ppm |The threshold to trigger the alarm.  |
|currentValue |xs:integer |R |true | |The current data value of the smoke sensor. |
|sensorFault |xs:boolean |R |true | |"True" indicates the sensor fault status of smoke sensor. "False" indicates the sensor fault of smoke sensor has been eliminated. |
|lowVoltage |xs:boolean |R |true | |"True" indicates the low voltage status of smoke sensor. "False" indicates the low voltage alarm of smoke sensor has been eliminated. |
|dismantled |xs:boolean |R |true | |"True" indicates the smoke sensor is dismantled. "False" indicates the dismantled alarm of smoke sensor has been eliminated. |
|powerOn |xs:boolean |R |true | |"True" indicates the smoke sensor is powered on. "False" is invalid. |




#### 5.3.1.83 sphygmomanometer
This ModuleClass provides the capability to report the measurement of blood pressure characteristics. 


**Table 5.3.1.83-1: DataPoints of sphygmomanometer ModuleClass**

|Name |Type |R-W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|diastolicPressure  |xs:float |R |false |mmHg |The measurement of diastolic pressure by sphygmomanometer.  |
|systolicPressure |xs:float |R |false |mmHg |The measurement of systolic pressure by sphygmomanometer.  |
|meanPressure |xs:float |R |false |mmHg |The measurement of mean arterial pressure by sphygmomanometer.  |




#### 5.3.1.84 spinLevel
This ModuleClass provides capabilities to control and monitor the level of spin. It is intended to be part of devices which use spinning function such as a washing machine and a dryer.


**Table 5.3.1.84-1: DataPoints of spinLevel ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|spinLevelStrength |[hd:enumSpinLevelStrength](#5630-hdenumspinlevelstrength) |RW |false | |The value of spin-dry level (see clause [5.6.30](#5630-hdenumspinlevelstrength)). A higher value indicates a higher spin level. |




#### 5.3.1.85 steamClosetJobMode
This ModuleClasses provides capabilities to control and monitor the job modes of steamCloset.


**Table 5.3.1.85-1: DataPoints of steamClosetJobMode ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentJobMode |[hd:enumSteamClosetJobMode](#5631-hdenumsteamclosetjobmode) |RW |false | |Currently active job mode (see clause [5.6.31](#5631-hdenumsteamclosetjobmode)).  |
|currentJobModeName |xs:string |R |true | |Name of current job mode as a string. This can be used when "currentJobMode" is vendor-specific. |
|jobModes |list of [hd:enumSteamClosetJobMode](#5631-hdenumsteamclosetjobmode) |R |false | |List of possible job states the device supports (see clause [5.6.31](#5631-hdenumsteamclosetjobmode)). |




#### 5.3.1.86 televisionChannel
This ModuleClass provides capabilities to set and get channels of a device that has a channel list.


**Table 5.3.1.86-1: Actions of televisionChannel ModuleClass**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|none |upChannel |None |true |Change the current channel to the next channel in the stored list of available channels. If the current channel is the last one in the list, the new set channel may be the first one in the list. |
|none |downChannel |None |true |Change the current channel to the previous channel in the stored list of available channels. If the current channel is the first one in the list, the new set channel may be the last one in the list. |




**Table 5.3.1.86-2: DataPoints of televisionChannel ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|channelNumber |xs:integer |RW |false | |Current channel number.  |
|availableChannels |list of xs:integer |R |true | |The list of available channel numbers which may be build by automatic scan and/or manual selection. |
|previousChannel |xs:integer |R |true | |The channel number which was selected previously. |
|channelName |xs:string |R |true | |Current human-friendly channel name in string, for example 'CNN'. |




#### 5.3.1.87 temperature
This ModuleClass provides capabilities to represent the current temperature and target temperature of devices such as an air conditioner, refrigerator, oven, etc.


**Table 5.3.1.87-1: DataPoints of temperature ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentTemperature |xs:float |R |false | |The current temperature. |
|targetTemperature |xs:float |RW |true | |The desired temperature to reach. |
|unit |[hd:enumTemperatureUnit](#5640-hdenumtemperatureunit) |RW |true |C or F or K |Default values is 'C'. |
|minValue |xs:float |R |true | |Minimum value of "targetTemperature". |
|maxValue |xs:float |R |true | |Maximum value of "targetTemperature". |
|stepValue |xs:float |R |true | |Step value allowed for "targetTemperature". |


#### 5.3.1.88 temperatureAlarm
This ModuleClass provides the capabilities to indicate the detection of abnormal temperatures and raises an alarm if the triggering criterion is met. 

**Table 5.3.1.88-1: DataPoints of temperatureAlarm ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|unit | [hd:enumTemperatureUnit](#5640-hdenumtemperatureunit) |RW |true |C or F or K |Default value is 'C'. |
|temperature |xs:float |R |true |Defined in the 'unit' |To report the value of the temperature.  |
|highTemperatureAlarm |xs:boolean |R |false | |High temperature alarm. |
|highTemperatureAlarmThreshold |xs:float |RW |true |Defined in the data point 'unit' |The threshold of maximum temperature alarm. |
|lowTemperatureAlarm |xs:boolean |R |false | |Low temperature alarm. |
|lowTemperatureAlarmThreshold |xs:float |RW |true |Defined in the data point 'unit' |The threshold of minimum temperature alarm. |
|alarmTimestamp |xs:datetime |R |true | |The timestamp since the alarm is active. |


#### 5.3.1.89 textMessage
This ModuleClass provides capabilities to set and get a text message.


**Table 5.3.1.89-1: Actions of textMessage ModuleClass**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|none |resetTextMessage |none |true |Reset  the receiver of the message to the "defaultValue". |




**Table 5.3.1.89-2: DataPoints of textMessage ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|textMessage |xs:string |RW |false | |The current message value. |
|supportedMessageValues |list of xs:string |R |true | |List of supported values for the message. Each of the values in this list shall be URL-encoded. An encoded value shall not contain white spaces. |
|minLength |xs:integer |R |true | |The optional minimum length in characters of the message. The default is 0. |
|maxLength |xs:integer |R |true | |The optional maximum length in characters of the message. The default is unlimited. |
|messageEncoding |xs:string |R |true | |The optional expected method for character encoding of the message. The default is "UTF-8". |
|defaultValue |xs:string |RW |true | |The optional default value for "textMessage". The default is an empty string. |




#### 5.3.1.90 timer
This ModuleClass provides capabilities to monitor and control the times when the appliance executes its operations, that means when it starts, when it ends etc.


**Table 5.3.1.90-1: Actions of timer ModuleClass**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|none |activateClockTimer |None |true |Activate current clock timer. |
|none |deactivateClockTimer |None |true |Deactivate current clock timer. |




**Table 5.3.1.90-2: DataPoints of timer ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|referenceTimer |xs:integer |R |true | |A timer (for example. a time-based value, App Defined Epoch, Progressive) expressed in seconds. The value indicates a time counter to be used as reference for the other time-based data points of this ModuleClass. Usually it is the time since the last event of power-on of the producer (or more in detail the time since the boot of its connectivity node). |
|targetTimeToStart |xs:integer  |RW |true | |A time span (for example a time-based value, App Defined Epoch, Fixed) expressed in seconds. The value indicates the time when the appliance is expected to start its operation, starting counting from the last "referenceTimer". |
|targetTimeToStop |xs:integer  |RW |true | |A time span (for example a time-based value, App Defined Epoch, Fixed) expressed in seconds. The value indicates the time when the appliance is expected to stop its operation, starting counting from the last "referenceTimer". |
|estimatedTimeToEnd |xs:integer |R |true | |A timer (for example a time-based value, App Defined Epoch, Progressive) expressed in seconds. The value indicates the time to the end of an appliance's operations. It is calculated at runtime by the device itself during the execution of its operation. |
|runningTime |xs:integer |R |true | |A timer (for example a time-based value, App Defined Epoch, Progressive) expressed in seconds. It indicates the time of the current operation. Usually its value is increasing one value per  second. It starts counting from 0 when the operation starts and stops counting when the operation ends. |
|targetDuration |xs:integer |R |true | |A time span (for a time-based value, App Defined Epoch, Fixed) expressed in seconds. The value indicates a time that represents the target duration of the operation as per user selection.  |
|absoluteStartTime |m2m:timestamp |RW |true | |An absolute time to specify the start time. |
|absoluteStopTime |m2m:timestamp |RW |true | |An absolute time to specify the stop time. |




#### 5.3.1.91 turbo
This ModuleClass provides capabilities to enable turbo mode and monitor the current status of the turbo function. It is intended to be part of devices which use turbo function such as an air conditioner, a washing machine, etc.


**Table 5.3.1.91-1: DataPoints of turbo ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|turboEnabled |xs:boolean |RW |false | |The current status of the turbo mode. "True" indicates enabled, and "False" indicates not enabled. |




#### 5.3.1.92 uvSensor
This ModuleClass describes the capabilities of an ultraviolet sensor. 


**Table 5.3.1.92-1: DataPoints of uvSensor ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|uvValue |xs:float |R |false |mW/cm2 | |
|uvStatus |[hd:enumUvStatus](#5635-hdenumuvstatus) |R |true | |The "uvStatus" indicates the level of the UV radiation status (see clause [5.6.35](#5635-hdenumuvstatus)).  |




#### 5.3.1.93 waterFlow
This ModuleClass provides capabilities for controlling the water strength of a device.


**Table 5.3.1.93-1: DataPoints of waterFlow ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|waterLevelStrength |[hd:enumWaterFlowStrength](#5637-hdenumwaterflowstrength) |RW |false | |The desired level of water flow (see clause [5.6.37](#5637-hdenumwaterflowstrength)). A higher value indicates higher water flow. |



#### 5.3.1.94 waterMeterAlarm
This ModuleClass provides capabilities to provide alarm information of water meter, such as the alarm of low water flow. Once an alarm is fired, a notification should be sent out from the device and no historical alarm is stored locally, therefore no need to associate timestamp with the alarms. 

**Table 5.3.1.94-1: DataPoints of waterMeterAlarm ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|highFlowAlarmThreshold |xs:float |RW |false |m3 |The threshold of continuous high flow alarm. |
|highFlowDuration |xs:integer |RW |true |s |The duration of high water flow. |
|highFlowAlarm |xs:boolean |R |false | |Continuous high water flow alarm. |
|lowFlowAlarmThreshold |xs:float |RW |true |m3 |The threshold of continuous low flow alarm. |
|lowFlowDuration |xs:integer |RW |true |s |The duration of low water flow. |
|lowFlowAlarm |xs:boolean |R |true | |Continuous low water flow alarm. |
|reverseFlowAlarmThreshold |xs:float |RW |true |m3 |The threshold of continuous reverse flow alarm. |
|reverseFlowDuration |xs:integer |RW |true |s |The duration of reverse water flow. |
|reverseFlowAlarm |xs:boolean |R |false | |Reverse flow alarm. |
|highPressureAlarmThreshold |xs:float |RW |false |bar |The threshold of high water pressure alarm. |
|highPressureAlarm |xs:boolean |R |false | |High water pressure alarm. |
|lowPressureAlarmThreshold |xs:float |RW |false |bar |The threshold of low water pressure alarm. |
|lowPressureAlarm |xs:boolean |R |false | |Low water pressure alarm. |
|highTemperatureAlarmThreshold |xs:float |RW |false |C |The threshold of maximum water temperature alarm. |
|highTemperatureAlarm |xs:boolean |R |false | |High water temperature alarm. |
|lowTemperatureAlarmThreshold |xs:float |RW |false |C |The threshold of minimum water temperature alarm. |
|lowTemperatureAlarm |xs:boolean |R |false | |Low water temperature alarm.. |
|highTemperatureInnerAlarmThreshold |xs:float |RW |true |C |The threshold of high temperature alarm inside water meter. |
|innerHighInternalTemperatureAlarm |xs:boolean |R |true | |Internal high temperature alarm. |
|innerErrorAlarm |xs:boolean  |R |true | |Internal error alarm. |
|innerTemperatureSensorFault |xs:boolean |R |true | |Internal temperature sensor failure. |
|tamperAlarm |xs:boolean |R |true | |Data was tampered alarm. |
|waterTemperatureSensorFault |xs:boolean |R |false | |Water temperature sensor failure. |
|pressureSensorFault |xs:boolean |R |true | |Pressure sensor failure. |
|communicationAlarm |xs:boolean |R |true | |Communication abnormality alarm. |
|magneticInterference |xs:boolean |R |true | |Magnetic interference warning. |
|storageFault |xs:boolean |R |true | |Storage failure alarm. |
|urgencyButtonPush |xs:boolean |R |true | |Indicate the event of the urgency button being pushed. Pushing the urgency button may give a user a temporary right to still use the water meter (e.g. for 3 days) after an unpaid bill. |
|buttonFault |xs:boolean |R |true | |Button error flag. |
|demolitionAlarm |xs:boolean |R |true | |Demolition sign. |
|impulseFault |xs:boolean  |R |true | |Pulse anomaly flag. |
|vibrationSensorFault |xs:boolean |R |true | |Vibration sensor failure. |


#### 5.3.1.95 waterMeterReportInfo
This ModuleClass provides information of measurements of the water meter.

**Table 5.3.1.95-1: DataPoints of waterMeterReportInfo ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|dailyUseWaterTime |xs:integer |R |true |s |The total time of water consumption daily. |
|cumulativeFlow |xs:float |R |false |m3 |The total consumption of water(since the activation of the meter).  |
|cumulativeFlowDaily |xs:float |R |true |m3 |The cumulative daily consumption of water (begins at 00:00).  |
|positiveCumulativeFlow |xs:float |R |true |m3 |The positive cumulative consumption of water daily (begins at 00:00). |
|negativeCumulativeFlow |xs:float |R |true |m3 |The negative cumulative consumption of water daily (begins at 00:00). |
|peakFlowRate |xs:float |R |true |m3/h |Daily maximum instantaneous water flow rate. |
|peakFlowRateTime |m2m:timestamp |R |true | |The timestamp of the daily highest instantaneous water flow rate. |
|lowestFlowRate |xs:float |R |true |m3/h |Daily lowest instantaneous water flow rate. |
|lowestFlowRateTime |m2m:timestamp |R |true | |The timestamp of daily lowest instantaneous water flow rate. |
|peakReverseFlowRate |xs:float |R |true |m3/h |Daily reverse maximum instantaneous water flow rate. |
|peakReverseFlowRateTime |m2m:timestamp |R |true | |The timestamp of daily reverse highest instantaneous water flow rate. |
|lowestReverseFlowRate |xs:float |R |true |m3/h |Daily reverse lowest instantaneous water flow rate. |
|lowestReverseFlowRateTime |m2m:timestamp |R |true | |The timestamp of daily reverse lowest instantaneous water flow rate. |
|intervalFlow |list of xs:float |R |true |m3 |Water consumption records measured at the interval of "flowInterval" described in clause [5.3.1.96](#53196-watermetersetting) per day.  |
|reverseIntervalFlow |list of xs:float |R |true |m3 |Water reverse consumption records measured at the interval of "reverseFlowInterval" described in clause [5.3.1.96](#53196-watermetersetting) per day. |
|waterIntervalTemperature |list of xs:float |R |true |C |Water temperature records measured at the interval of "waterTemperatureInterval" described in clause [5.3.1.96](#53196-watermetersetting) per day. |
|waterIntervalPressure |list of xs:float |R |true |bar |Water pressure records measured at the interval of "waterPressureInterval" described in clause [5.3.1.96](#53196-watermetersetting) per day. |


#### 5.3.1.96 waterMeterSetting
This ModuleClass provides capabilities to set service parameters for data sampling and reporting. 


**Table 5.3.1.96-1: DataPoints of waterMeterSetting ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|flowInterval |xs:integer |RW |false |s |The measurement interval of water consumption. |
|reverseFlowInterval |xs:integer |RW |false |s |The measurement interval of reverse water consumption. |
|waterTemperatureInterval |xs:integer |RW |true |s |The measurement interval of water temperature. |
|waterPressureInterval |xs:integer |RW |true |s |The measurement interval of reverse water pressure. |
|intensiveSampleInterval |xs:integer |RW |true |s |The time interval of intensive data sampling. |
|intensiveReportInterval |xs:integer |RW |true |s |The time interval of intensive data report. |
|intensiveReportStartTime |m2m:timestamp |RW |true | |The start time of data intensive report. |


#### 5.3.1.97 waterSensor
This ModuleClass provides the capabilities to indicate whether or not water has been sensed, and raising an alarm if the triggering criterion is met. 


**Table 5.3.1.97-1: DataPoints of waterSensor ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|alarm |xs:boolean |R |false | |The detection of water.<br />The alarm is indicated as follows:<br />"True" indicates that water has been detected, "False" indicates a normal status, that means that water is not detected. |



#### 5.3.1.98 waterQualityMonitor
This ModuleClass provides the information of water quality detection.

**Table 5.3.1.98-1: DataPoints of waterQualityMonitor ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|algae |xs:float |R |true |mg/L |Blue-green algae |
|anionics |xs:float |R |true |mg/L |An-ionic surfactant |
|aroh |xs:float |R |true |mg/L |Volatile phenol (ArOH) |
|as |xs:float |R |true |mg/L |Arsenic (As) |
|biotoxicity |xs:float |R |true |mg/L |Biological toxicity |
|bod |xs:float |R |true |mg/L |Biochemical oxygen demand (BOD) is the amount of dissolved oxygen consumed during the biochemical reaction of biodegradable organic matter that is decomposed by microorganisms in water under certain conditions. |
|cod |xs:float |R |true |mg/L |Chemical oxygen demand (COD) is the amount of reducing substance that needs to be oxidized in a water sample. |
|conductivity |xs:float |R |true |S/m |Conductivity is a parameter used to describe the ease of charge flow in a substance. |
|cd |xs:float |R |true |mg/L |Cadmium (Cd) |
|chlorophyll_a |xs:float |R |true |mg/L |Chlorophyll a |
|cn |xs:float |R |true |mg/L |Cyanide (CN) |
|cr6 |xs:float |R |true |mg/L |Hexavalent chromium (Cr6) |
|cu |xs:float |R |true |mg/L |Cuprum (Cu) |
|do |xs:float |R |true |mg/L |Dissolved oxygen (DO). Molecular oxygen in the air dissolved in water is called dissolved oxygen |
|f |xs:float |R |true |mg/L |Fluoride (F) |
|fe |xs:float |R |true |mg/L |Total iron (Fe) |
|ftu |xs:float |R |true |mg/L |Turbidity (FTU) which refers to degree of hindrance of the solution as the light passes through it. |
|hg |xs:float |R |true |mg/L |Mercury (Hg) |
|kmno4 |xs:float |R |true |mg/L |Permanganate index which refers to the amount of oxidant consumed in the water samples using potassium permanganate as an oxidant in an acidic or alkaline medium. (KMnO4) |
|nh3nh4 |xs:float |R |true |mg/L |Ammonia nitrogen (NH3NH4) is the nitrogen in the form of free ammonia (NH3) and ammonium ions (NH4+) in water. |
|no3n |xs:float |R |true |mg/L |Nitrate nitrogen (NO3N) |
|oil |xs:float |R |true |mg/L |Petroleum pollutants |
|pb |xs:float |R |true |mg/L |Lead (Pb) |
|ph |xs:float |R |true | |Potential Of Hydrogen (pH) |
|sulfide |xs:float |R |true |mg/L |Sulphide |
|temperature |xs:float |R |true |C |Water temperature |
|tn |xs:float |R |true |mg/L |Total nitrogen (TN) which is defined as the total amount of various forms of inorganic and organic nitrogen in water. |
|tp |xs:float |R |true |mg/L |Total phosphorus (TP) which is the result of the conversion of various forms of phosphorus into orthophosphate after digestion of the water sample, measured in milligrams of phosphorus per litre of water sample. |
|zn |xs:float |R |true |mg/L |Zinc (Zn) |



#### 5.3.1.99 weight
This ModuleClass provides the capability to report the measurement of weight.


**Table 5.3.1.99-1: DataPoints of weight ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|weight |xs:float |R |false |kg |The weight measurement.  |
|unit |[hd:enumWeightUnit](#5639-hdenumweightunit) |RW |true | |The unit of measure for the weight values. The default is kilogram (kg). (see clause [5.6.39](#5639-hdenumweightunit)). |


#### 5.3.1.100 anemometer
This ModuleClass provides the capabilities to indicate the measure of the wind speed.

**Table 5.3.1.100-1: DataPoints of anemometer ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|windSpeed |xs:float |R |false |m/s |The speed of the wind |

#### 5.3.1.101 barometer
This ModuleClass provides the capabilities to measure the atmospheric pressure and indicate the detection of abnormal pressure, and raise an alarm if a triggering criterion is met.

**Table 5.3.1.101-1: DataPoints of barometer ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|alarm |xs:boolean |R |true | |This data point indicates the status of detection of an abnormal pressure. "True" indicates an abnormal pressure, "False" indicates a normal pressure. |
|atmosphericPressure |xs:float |R |false |hPa |To report the value of the atmospheric pressure.  |
|minPressureThreshold |xs:integer |RW |true |hPa |The min threshold to trigger the alarm. |
|maxPressureThreshold |xs:integer |RW |true |hPa |The max threshold to trigger the alarm. |


#### 5.3.1.102 rainGauge

This ModuleClass provides the capabilities to measure the height of fallen rain.

**Table 5.3.1.102-1: Actions of rainGauge ModuleClass**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|none |resetGauge |none |false |Empty the water container. Set the height value to 0. |


**Table 5.3.1.102-2: DataPoints of rainGauge ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|gaugeHeight |xs:integer |R |false |mm |This data point indicates the number of mm of rainfall since the last reset of the device. |


#### 5.3.1.103 infraredSensor
This ModuleClass provides the capabilities to indicate whether or not an object has been sensed.

**Table 5.3.1.103-1: DataPoints of infraredSensor ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|detectedValue |xs:boolean |R |false | |The "detectedValue" indicates as follows:<br />"True" means that an object is detected, "False" means no object is detected. |
|detectedTime |m2m:timestamp |R |false | |The time when the object was detected. |


#### 5.3.1.104 disposal

This ModuleClass provides capabilities to control the status of the disposing functionality for garbage disposal.

**Table 5.3.1.104-1: DataPoints of disposal ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|disposalStatus |xs:boolean |RW |false | |The status of disposal. "True" indicates disposing, "False" indicates not disposing. |


#### 5.3.1.105 waterFilterType
This ModuleClass indicates the type of the water purifier.

**Table 5.3.1.105-1: DataPoints of waterFilterType ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|filterType |[hd:enumWaterFilterType](#5641-hdenumwaterfiltertype) |R |false | |The type of water purifier. List of Water Filter Type(see clause [5.6.41](#5641-hdenumwaterfiltertype)). |

#### 5.3.1.106 touchScreen
This ModuleClass provides the capability to get selections of a user from the pre-defined menus on the screen as parts of a process of charging transportation payment card of the user.

**Table 5.3.1.106-1: DataPoints of touchScreen ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|pushed |xs:boolean |R |false | |This data point indicates the press of the button.  |
|positionX |xs:integer |R |false |px |This data point indicates the horizontal position of the touching. (1..N) |
|positionY |xs:integer |R |false |px |This data point indicates the vertical position of the touching. (1..N) |


#### 5.3.1.107 prePaidCardReader
The Pre-paid card reader ModuleClass provides functions to read NFC card and indicates its information.
**Table 5.3.1.107-1: DataPoints of prePaidCardReader ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|readStatus |xs:boolean |R |false | |This data point indicates the status of reading the pre-paid card.<br />"True" means the reader reads the pre-paid card successfully. |
|cardInfo |xs:string |R |false | |The card information is a string |
|balance |xs:float |RW |false | |This data point indicates the balance of the pre-paid card. |
|currency |xs:string |R |true | |The currency is depended on the country which the card is used.<br />For example, the unit could be "Dollar" or "$" in US, "Euro" in EU and "Won" in Korea. |



#### 5.3.1.108 billDeposit
This ModuleClass provides the capability to deposit bills, indicates the balance of the deposited bills and detects fakes.

**Table 5.3.1.108-1: DataPoints of billDeposit ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|depositStatus |xs:boolean |R |false | |This data point indicates the deposit is made successfully or not. |
|balance |xs:float |R |false | |This data point indicates the balance of the deposited bills.  |
|count |xs:integer |R |false | |The data point indicates the number of bills which are deposited.  |
|currency |xs:string |R |true | |The currency is depended on the country which the deposited bills are used.<br />For example, the currency could be "Dollar" in US, "Euro" in EU and "Won" in Korea. |
|fakeStatus |xs:boolean |R |false | |This data point indicates that the deposited bills are fake notes. |


#### 5.3.1.109 billWithdrawal
This ModuleClass provides the capability to withdraw bills which are deposited by the [billDeposit](#531108-billdeposit) ModuleClass.

**Table 5.3.1.109-1: DataPoints of billWithdrawal ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|withdrawalStatus |xs:boolean |R |false | |This data point indicates the withdrawal is made successfully or not. |
|balance |xs:float |R |false | |This data point indicates the balance of the withdrawn bills.  |
|count |xs:integer |R |false | |The data point indicates the number of bills which are withdrawn.  |


#### 5.3.1.110 coinDeposit
This ModuleClass provides the capability to deposit coins, indicates the balance of the deposited coins and detects fakes.

**Table 5.3.1.110-1: DataPoints of coinDeposit ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|depositStatus |xs:boolean |R |false | |This data point indicates the deposit is made successfully or not. |
|balance |xs:float |R |false | |This data point indicates the balance of the deposited coins.  |
|count |xs:integer |R |false | |The data point indicates the number of coins which are deposited. |
|currency |xs:string |R |true | |The currency is depended on the country that the deposited coins are used.<br />For example, the unit could be "Dollar" in US, "Euro" in EU and "Won" in Korea. |
|fakeStatus |xs:boolean |R |false | |This data point indicates that the deposited coins are fake. |



#### 5.3.1.111 cashDispenser
This ModuleClass provides the capability to withdraw designated amount of cash or returns all the deposited bills and coins by the [billDeposit](#531108-billdeposit) ModuleClass and [coinDeposit](#531110-coindeposit) ModuleClass.

**Table 5.3.1.111-1: DataPoints of cashDispenser ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|dispenseStatus |xs:boolean |R |false | |This data point indicates the dispense is successful or not. |
|balance |xs:float |R |false | |This data point indicates the balance of the dispensed bills and coins.  |
|count |xs:integer |R |false | |The data point indicates the number of bills and coins which are dispensed. |
|currency |xs:string |R |true | |The currency is depended on the country that the dispensed bills and coins are used.<br />For example, the unit could be "Dollar" in US, "Euro" in EU and "Won" in Korea. |


#### 5.3.1.112 cardScanner
This ModuleClass provides the capability to scan an image of a card, gets the card information from the image and provides the information.

**Table 5.3.1.112-1: DataPoints of cardScanner ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|scanStatus |xs:boolean |R |false | |This data point indicates the scanning process is successful. |
|cardInfo |xs:string |R |false | |The card information is a string value.  |



#### 5.3.1.113 headingSensor
This ModuleClass provides the capabilities to indicate the heading (e.g. status of get-in and get-out) of a pedestrian or a vehicle which crossing a control point (e.g. entrance and gate).

**Table 5.3.1.113-1: DataPoints of headingSensor ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|heading |xs:float |RW |false |degree |The azimuth of a device measured in degrees to true north. North is 0,0 degrees, east is 90,0 degrees, south is 1800 degrees, west is 270,0 degrees. A negative value indicates an unknown heading. |
|headingAccuracy |xs:float |R |true |degree |The optional current maximum deviation between the heading and the true geomagnetic heading. |


#### 5.3.1.114 signalPanel
This ModuleClass displays a signal (e.g. direction arrow) to indicate a gate is permitted to get-in or get-out on a panel.

**Table 5.3.1.114-1: DataPoints of signalPanel ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|signal |xs:boolean |RW |false | |The signal is true, the panel indicates go forward signal or icon. If the signal is false, the panel displays stop signal or icon. |


#### 5.3.1.115 crossingBarrier
An active barrier is used to block a pedestrian or vehicle from a control point (e.g. entrance and gate).

**Table 5.3.1.115-1: DataPoints of crossingBarrier ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|barrierDefault |xs:boolean |RW |true | |The value of the barrier default is true, the default status of the barrier is closed and vice versa. |
|barrierStatus |xs:boolean |RW |false | |The value of the barrier status is true, the barrier is closed and vice versa. |
|timer |xs:time |RW |true | |The timer indicates the duration of barrierStatus is changed. This means that barrierStatus is set to the current value of barrierDefault. |


#### 5.3.1.116 threeDDisplay
This ModuleClass provides capabilities to give the information of a 3D display.

**Table 5.3.1.116-1: DataPoints of threeDDisplay ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|threeDDisplayType |[hd:enum3DDisplayType](#5652-hdenum3ddisplaytype) |R |false | |The type of 3D display technology (see clause [5.6.52](#5652-hdenum3ddisplaytype)) |
|threeDDisplayViewAngle |xs:integer |R |true |degree |This data point indicates viewing angle of the 3D display (1..360) |
|threeDDisplayResolutionX |xs:integer |R |true |px |This data point indicates resolution of X-axis of the 3D display. |
|threeDDisplayResolutionY |xs:integer |R |true |px |This data point indicates resolution of Y-axis of the 3D display. |
|threeDGlasses |xs:boolean |R |true | |This data point indicates the 3D display uses 3D  glasses (True) or not. |


#### 5.3.1.117 threeDScanner
This ModuleClass provides the capability to scanning 3D object for the user.

**Table 5.3.1.117-1: DataPoints of threeDScanner ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|threeDScannerType |[hd:enum3DScannerType](#5653-hdenum3dscannertype) |R |false | |This data point indicates type of the 3D scanner (see clause [5.6.53](#5653-hdenum3dscannertype)) |
|threeDScanResolution |xs:integer |R |false |dpi  |This data point indicates the scanning resolution. |
|maxSizeX |xs:float |R |true |cm |This data point indicates the maximum horizontal size of the scanning. |
|maxSizeY |xs:float |R |true |cm |This data point indicates the maximum vertical size of the scanning. |
|maxSizeZ |xs:float |R |true |cm |This data point indicates the maximum depth of the scanning. |


#### 5.3.1.118 blender
This ModuleClass is for controlling a blender, for example in a juicer. 

**Table 5.3.1.118-1: DataPoints of blender ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|useBlender |xs:boolean |RW |false | |The current status of the blender enablement. "True" indicates enabled, and "False" indicates disabled. |
|spinSpeed |[hd:enumSpinLevelStrength](#5630-hdenumspinlevelstrength) |RW |true | |Choose the right spin speed according to the hardness of the object (eg.fruits and vegetables) (see clause [5.6.30](#5630-hdenumspinlevelstrength)) |


#### 5.3.1.119 shoesWasherJobMode
This ModuleClasses provides capabilities to control and monitor the job modes of a shoesWasher.

**Table 5.3.1.119-1: DataPoints: DataPoints of shoesWasherJobMode ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|currentJobMode |[hd:enumShoesWasherJobMode](#5654-hdenumshoeswasherjobmode) |RW |false | |The currently active job mode. (see clause [5.6.54](#5654-hdenumshoeswasherjobmode)) |
|currentJobModeName |xs:string |R |true | |The name of the current job mode as a string. This can be used when the currentJobMode is vendor-specific. |
|jobModes |list of [hd:enumShoesWasherJobMode](#5654-hdenumshoeswasherjobmode) |R |false | |List of possible job states the device supports (see clause [5.6.54](#5654-hdenumshoeswasherjobmode)) |


### 5.3.2 City Domain

<mark>For further studies.</mark>

### 5.3.3 Health Domain

<mark>For further studies.</mark>

### 5.3.4 Home Domain

<mark>For further studies.</mark>

### 5.3.5 Industry Domain

<mark>For further studies.</mark>

### 5.3.6 Vehicular Domain

<mark>For further studies.</mark>

### 5.3.7 Agriculture Domain

#### 5.3.7.1 cowActivityMonitor
This ModuleClass provides capabilities to measure activity data in terms of step count. The data sampling rate is every hour by default.

**Table 5.3.7.1-1: DataPoints of cowActivityMonitor ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|stepsPerPeriod |list of xs:integer |R |false | |Counted steps per hour during each report period. The value is updated every report period. The length of the report period can be configured by the [periodicalReportConfig](#53163-periodicalreportconfig) ModuleClass. If not configured, the default length of the period is 1 hour.<br />If the report period is longer than 1 hour, this data point may contain multiple data samples (one for each hour) during last period. The report period should always be set to longer than 1 hour which is the data sampling period. The start time of the data sampling and report period is implementation specific, e.g. the power-on time. |
|updateTime |xs:datetime |R |true | |A timestamp that indicates the update time of the *stepsPerPeriod* data point. |
|historyStepCounts |list of xs:integer |R |false | |The list of stepCounts per hour during the last 24 hours (in total 24 data samples). |


### 5.3.8 Railway Domain

#### 5.3.8.1 baliseTransmissionModule
A balise is an electronic beacon or transponder placed between the rails of a railway as part of an Automatic Train Protection (ATP) system.

The Balise Transmission Module(BTM) ModuleClasses provides capabilities to indicate and to get balise information.

**Table 5.3.8.1-1: DataPoints of baliseTransmissionModule ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|baliseSystemId |[hd:enumBaliseSystemIndicator](#5638-hdenumbalisesystemindicator) |R |true | |Get the hd:enumBaliseSystemIndicator (see clause [5.6.38](#5638-hdenumbalisesystemindicator)).  |
|telegramMessage |xs:string |R |true | |The telegramMessage is system-specific. |


### 5.3.9 Metadata Domain

#### 5.3.9.1 features
This ModuleClass provides metadata information on the parent device.


**Table 5.3.9.1-1: DataPoints of features ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|metadata |list of xs:string |RW |true | |Free metadata information. |
|precision |xs:integer |R |true |pct |Approximated precision of the device data. |
|reliability |xs:integer |R |true |pct |Approximated reliability of the device data. |
|weight |xs:float |R |true |g |The weight of the device. |
|size |list of xs:float |R |true |cm |The size of the device [length, width, height]. |


#### 5.3.9.2 location
This ModuleClass provides information on the location of the parent device.


**Table 5.3.9.2-1: DataPoints of location ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|postalAddress |xs:string |RW |true | |Postal address |
|geoJSON |xs:string |R |true | |Coordinates in GeoJSON format |
|friendlyLocation |xs:string |RW |true | |Friendly location (e.g. 'kitchen') |
|room |xs:string |RW |true | |Room ID in a building (e.g. 'A101') |


#### 5.3.9.3 localization
This ModuleClass provides capabilities for localizing friendly names.

**Table 5.3.9.3-1: DataPoints of localization ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|locale |xs:string |R |false | |Code in ISO 639-1 |
|friendlyName |xs:string |RW |true | |Friendly name for the parent device, in the given locale. |
|description |xs:string |RW |true | |Friendly description for the parent device, in the given locale. |
|friendlyLocation |xs:string |RW |true | |Friendly location, in the given locale (e.g. 'cuisine' for locale 'fr'). |


#### 5.3.9.4 origin
This ModuleClass provides information on the origin of the parent device data.


**Table 5.3.9.4-1: DataPoints of origin ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|originID |xs:string |R |true | |ID of the original data |
|dataType |xs:string |R |true | |Data type of the original data |
|dataSourceID |xs:string |R |true | |ID of the data source that created the original data |




### 5.3.10 Public Safety Domain

#### 5.3.10.1 disseminator
This ModuleClass provides the capability of creating oneM2M based information from CAP based information received from oneM2M SP Gateway (ASN) and of controlling the change of received public warning messages such as updating oneM2M based information and cancelling the dissemination of oneM2M based information.

**Table 5.3.10.1-1: Actions of disseminator ModuleClass**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|result:<br />xs:string |cancel |warningIdentifier: xs:string |true |cancel previously requested warning |


**Table 5.3.10.1-2: DataPoints of disseminator ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|identifier |xs:string |RW |false | |The identifier of the warning message that uniquely identifying this message. |
|sender |xs:string |RW |false | |The identifier of the originator of this alert message. |
|sent |xs:dateTime |RW |false | |The time and date of the origination of this alert message. |
|status |[hd:enumAlertStatus](#5655-hdenumalertstatus) |RW |false | |The code to represent the appropriate handling of the alert message receiver. The value of this DataPoint is specified the CAP 1.2 specification <a href="#_ref_22">[22]</a> <br />(see clause [5.6.55](#5655-hdenumalertstatus)). |
|msgType |[hd:enumAlertMsgType](#5656-hdenumalertmsgtype) |RW |false | |The code to represent the nature of the alert message. The value of this DataPoint is specified the CAP 1.2 specification <a href="#_ref_22">[22]</a> (see clause [5.6.56](#5656-hdenumalertmsgtype)). |
|references |list of xs:string |RW |true | |The list of identifiers for earlier message(s) referenced by this alert message. |
|urgency |[hd:enumUrgency](#5657-hdenumurgency) |RW |false | |The code representing the urgency of the subject event of the alert message (see clause [5.6.57](#5657-hdenumurgency)). |
|severity |[hd:enumSeverity](#5658-hdenumseverity) |RW |false | |The code representing the severity of the subject event of the alert message (see clause [5.6.59](#5658-hdenumseverity)). |
|certainty |[hd:enumCertainty](#5659-hdenumcertainty) |RW |false | |The code representing the certainty of the subject event of the alert message (see clause [5.6.59](#5659-hdenumcertainty)). |
|eventCodes |list of xs:string |RW |false | |The definitions of system-specific codes identifying the event type of the alert message. A code definition consists of valueName and value pair separated by colon. |
|effective |xs:dateTime |RW |true | |The effective time of the information of the alert message. |
|onset |xs:dateTime |RW |true | |The expected time of the beginning of the subject event of the alert message. |
|expires |xs:dateTime |RW |true | |The expiry time of the information of the alert message.  |
|areaLatitude |xs:float |RW |true |degrees |The latitude of the affected area location. |
|areaLongitude |xs:float |RW |true |degrees |The longitude of the affected area location. |
|areaRadius |xs:float |RW |true |metres |The radius of the affected area location. |
|repetitionPeriod |xs:integer |RW |false |seconds |This specifies the repetition period for the warning message. The value of this DataPoint indicates the period of time in seconds after which re-send of the warning message should be repeated. |
|repetitionCount |xs:integer |RW |false | |This specifies the number of times the warning message is to be sent. |


#### 5.3.10.2 emergencyHandler
This ModuleClass provides the capability of triggering things to change into an emergency mode and of enabling things to identify whether an event described in oneM2M based information that is received from Public Warning Center (MN) is relevant to things. If any change happens in received warning messages such as updating oneM2M based information and cancelling the dissemination of oneM2M based information of previously received public warning messages, this ModuleClass updates oneM2M based information corresponding to those received public warning messages to control behaviour of things.

**Table 5.3.10.2-1: DataPoints of emergencyHandler ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|emergencyMode |xs:boolean |RW |false | |This specifies the emergency mode of target device. "True" means the device is working in emergency mode. "False" means the device is working in normal model |
|identifier |xs:string |RW |false | |The identifier of the warning message that uniquely identifying this message. |
|sender |xs:string |RW |false | |The identifier of the originator of this alert message. |
|sent |xs:dateTime |RW |false | |The time and date of the origination of this alert message. |
|status |[hd:enumAlertStatus](#5655-hdenumalertstatus) |RW |false | |The code to represent the appropriate handling of the alert message receiver. The value of this DataPoint is specified by the CAP 1.2 specification <a href="#_ref_22">[22]</a> (see clause [5.6.55](#5655-hdenumalertstatus)). |
|msgType |[hd:enumAlertMsgType](#5656-hdenumalertmsgtype) |RW |false | |The code to represent the nature of the alert message. The value of this DataPoint is specified the CAP 1.2 specification <a href="#_ref_22">[22]</a> (see clause [5.6.56](#5656-hdenumalertmsgtype)). |
|references |list of xs:string |RW |false | |The list of identifiers for earlier message(s) referenced by this alert message. |
|urgency |[hd:enumUrgency](#5657-hdenumurgency) |RW |false | |The code representing the urgency of the subject event of the alert message (see clause [5.6.57](#5657-hdenumurgency)). |
|severity |[hd:enumSeverity](#5658-hdenumseverity) |RW |false | |The code representing the severity of the subject event of the alert message (see clause [5.6.5](#5658-hdenumseverity)). |
|certainty |[hd:enumCertainty](#5659-hdenumcertainty) |RW |false | |The code representing the certainty of the subject event of the alert message (see clause [5.6.59](#5659-hdenumcertainty)). |
|eventCodes |list of xs:string |RW |false | |The definitions of system-specific codes identifying the event type of the alert message. A code definition consists of valueName and value pair separated by colon. |
|effective |xs:dateTime |RW |true | |The effective time of the information of the alert message. |
|onset |xs:dateTime |RW |true | |The expected time of the beginning of the subject event of the alert message. |
|expires |xs:dateTime |RW |true | |The expiry time of the information of the alert message.  |
|areaLatitude |xs:float |RW |true |deg |The latitude of the affected area location. |
|areaLongitude |xs:float |RW |true |deg |The longitude of the affected area location. |
|areaRadius |xs:float |RW |true |m |The radius of the affected area location. |


#### 5.3.10.3 settings
This ModuleClass provides the capability of selecting the option that allows things to decide to take action as receiving oneM2M based information of public warning messages.

<mark>Editor note: For discussion: this MC has the wrong name.</mark>

**Table 5.3.10.3-1: DataPoints of settings ModuleClass**

|Name |Type |R/W |Optional |Unit |Documentation |
|-|-|-|-|-|-|
|optoutStatus |xs:boolean |RW |false | |This specifies the opt-out state for the device. The value of this DataPoint specifies opt-out state. True means that this device does not want to response when a warning has been triggered. |

  NOTE: Opt-out refers to 3GPP TS 22.268 <a href="#_ref_i.14">[i.14]</a> Public Warning System (PWS) requirements specification.


## 5.4 SubDevice models

### 5.4.1 Common Domain

#### 5.4.1.1 Void



#### 5.4.1.2 subDevicePowerOutlet
A powerOutlet is a subDevice that specifies the attachment device for [deviceSmartPlug](#55111-devicesmartplug).


**Table 5.4.1.2-1: Modules of subDevicePowerOutlet model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |0..1 |See clause [5.3.1.12](#53112-binaryswitch). |
|energyConsumption |[energyConsumption](#53132-energyconsumption) |0..1 |See clause [5.3.1.32](#53132-energyconsumption). |
|overcurrentSensor |[overcurrentSensor](#53158-overcurrentsensor) |0..1 |See clause [5.3.1.58](#53158-overcurrentsensor). |
|dimmingLevel |[numberValue](#53155-numbervalue) |0..1 |See clause [5.3.1.55](#53155-numbervalue).<br />This provides the capability to change the energy. |



### 5.4.2 City Domain

<mark>For further studies.</mark>

### 5.4.3 Health Domain

#### 5.4.3.1 subDeviceCuff
A cuff is a subDevice that expresses the attachment device for measuring blood pressure.


**Table 5.4.3.1-1: Modules of subDeviceCuff model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |0..1 |See clause [5.3.1.12](#53112-binaryswitch). |
|sphygmomanometer |[sphygmomanometer](#53183-sphygmomanometer) |1 |See clause [5.3.1.83](#53183-sphygmomanometer). |
|pulsemeter |[pulsemeter](#53168-pulsemeter) |1 |See clause [5.3.1.68](#53168-pulsemeter). |



### 5.4.4 Home Domain

<mark>For further studies.</mark>

### 5.4.5 Industry Domain

<mark>For further studies.</mark>

### 5.4.6 Vehicular Domain

<mark>For further studies.</mark>

## 5.5 Device models

### 5.5.1 Common Domain

#### 5.5.1.1 device3DPrinter
A 3D printer is a smart home appliance to provide 3D printing capabilities.


**Table 5.5.1.1-1: Modules of device3DPrinter Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|threeDprinter |[threeDprinter](#5311-threedprinter) |1 |See clause [5.3.1.1](#5311-threedprinter). |
|runState |[runState](#53175-runstate) |1 |See clause [5.3.1.75](#53175-runstate). |
|temperature |[temperature](#53187-temperature) |1 |See clause [5.3.1.87](#53187-temperature).<br />This value of "currentTemperature" in this module instance represents the temperature of the nozzle. This value SHALL be a float number in a range from 0,0 to 1 000,0. |
|printQueue |[printQueue](#53167-printqueue) |1 |See clause [5.3.1.67](#53167-printqueue). |


#### 5.5.1.2 deviceAirQualityMonitor
An air quality monitor is an environmental monitoring device used to monitor the air quality.

**Table 5.5.1.2-1: Modules of deviceAirQualityMonitor Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|airQualitySensor |[airQualitySensor](#5316-airqualitysensor) |1 |See clause [5.3.1.6](#5316-airqualitysensor). |
|battery |[battery](#53110-battery) |0..1 |See clause [5.3.1.10](#53110-battery). |
|connectivity |[connectivity](#53125-connectivity) |0..1 |See clause [5.3.1.25](#53125-connectivity). |
|periodicalReportConfig |[periodicalReportConfig](#53163-periodicalreportconfig) |0..1 |See clause [5.3.1.63](#53163-periodicalreportconfig). |


#### 5.5.1.3 deviceAudioReceiver
An audio receiver is a device that receives audio signals from a number of sources, processing them to drive speakers.

**Table 5.5.3.1-1: Modules of deviceAudioReceiver model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|audioVolume |[audioVolume](#5318-audiovolume) |1 |See clause [5.3.1.8](#5318-audiovolume). |
|mediaInput |[mediaSelect](#53153-mediaselect) |0..1 |See clause [5.3.1.53](#53153-mediaselect). |
|mediaOutput |[mediaSelect](#53153-mediaselect) |0..1 |See clause [5.3.1.53](#53153-mediaselect). |


#### 5.5.1.4 deviceCamera
A camera is an optical instrument for recording or capturing images, which may be stored locally or transmitted to another locations.

**Table 5.5.1.4-1: Modules of deviceCamera Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|sessionDescription |[sessionDescription](#53177-sessiondescription) |1 |See clause [5.3.1.77](#53177-sessiondescription). |
|playerControl |[playerControl](#53165-playercontrol) |0..1 |See clause [5.3.1.65](#53165-playercontrol). |
|motionSensor |[motionSensor](#53154-motionsensor) |0..1 |See clause [5.3.1.54](#53154-motionsensor). |


#### 5.5.1.5 deviceDoor
A door is a device that is used to open and close a door.

**Table 5.5.1.5-1: Modules of deviceDoor model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|openLevel |[openLevel](#53156-openlevel) |0..1 |See clause [5.3.1.56](#53156-openlevel). |
|doorLock |[lock](#53152-lock) |0..1 |See clause [5.3.1.52](#53152-lock). |
|doorStatus |[doorStatus](#53130-doorstatus) |0..1 |See clause [5.3.1.30](#53130-doorstatus). |


#### 5.5.1.6 deviceDoorLock
A door lock is a device that can be used to lock, for example, a door.

**Table 5.5.1.6-1: Modules of deviceDoorLock Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|doorLock |[lock](#53152-lock) |1 |See clause [5.3.1.52](#53152-lock). |
|doorStatus |[doorStatus](#53130-doorstatus) |0..1 |See clause [5.3.1.30](#53130-doorstatus). |
|battery |[battery](#53110-battery) |0..1 |See clause [5.3.1.10](#53110-battery). |


#### 5.5.1.7 deviceLight
A light is a device that is used to control the state of an illumination appliance.

**Table 5.5.1.7-1: Modules of deviceLight Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|colour |[colour](#53123-colour) |0..1 |See clause [5.3.1.23](#53123-colour). |
|colourSaturation |[colourSaturation](#53124-coloursaturation) |0..1 |See clause [5.3.1.24](#53124-coloursaturation). |
|brightness |[brightness](#53117-brightness) |0..1 |See clause [5.3.1.17](#53117-brightness). |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |


#### 5.5.1.8 deviceMultiFunctionPrinter
A Multi Function Printer (MFP) is an office machine which incorporates the functionality of multiple devices in one, so as to have a smaller footprint in home or office. A typical MFP may act as a combination of printer, scanner and more. This MFP information model provides capabilities to control and monitor MFP specific functions and resources.

**Table 5.5.1.8-1: Modules of deviceMultiFunctionPrinter Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|printerRunState |[runState](#53175-runstate) |1 |See clause [5.3.1.75](#53175-runstate). |
|scannerRunState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|autoDocumentFeeder |[autoDocumentFeeder](#5319-autodocumentfeeder) |0..1 |See clause [5.3.1.9](#5319-autodocumentfeeder). |
|printQueue |[printQueue](#53167-printqueue) |0..1 |See clause [5.3.1.67](#53167-printqueue). |


#### 5.5.1.9 devicePrinter
A printer is a device that is used to monitor or control the state of a printing appliance.

**Table 5.5.1.9-1: Modules of devicePrinter Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|printQueue |[printQueue](#53167-printqueue) |0..1 |See clause [5.3.1.67](#53167-printqueue). |


#### 5.5.1.10 deviceScanner
A scanner is a device that optically scans images, printed text, handwriting or an object, and converts it to a digital image.

**Table 5.5.1.10-1: Modules of deviceScanner model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |1 |See clause [5.3.1.75](#53175-runstate). |
|autoDocumentFeeder |[autoDocumentFeeder](#5319-autodocumentfeeder) |0..1 |See clause [5.3.1.9](#5319-autodocumentfeeder). |


#### 5.5.1.11 deviceSmartPlug
A smart plug is a device that can turn on and off a connected appliance.

**Table 5.5.1.11-1: Modules of deviceSmartPlug model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |0..1 |See clause [5.3.1.12](#53112-binaryswitch). |
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|remoteControlEnable |[remoteControlEnable](#53173-remotecontrolenable) |0..1 |See clause [5.3.1.73](#53173-remotecontrolenable). |


**Table 5.5.1.11-2: SubDevice of deviceSmartPlug Device model**

|SubDevice Instance Name |SubDevice Name |Multiplicity |Description |
|-|-|-|-|
|powerOutlet0<br/><mark>Discuss: This should be "powerOutlet"</mark> |[subDevicePowerOutlet](#5412-subdevicepoweroutlet) |1..N |See clause [5.4.1.2](#5412-subdevicepoweroutlet). |


#### 5.5.1.12 deviceSwitch
A switch is a device that is used to control and monitor the state of power.

**Table 5.5.1.12-1deviceSwitch Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |


#### 5.5.1.13 deviceThermometer
A thermometer is a device that can be used to check, for example, the body or other temperatures.

**Table 5.5.1.13-1: Modules of deviceThermoMeter Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|temperature |[temperature](#53187-temperature) |1 |See clause [5.3.1.87](#53187-temperature). |
|battery |[battery](#53110-battery) |1 |See clause [5.3.1.10](#53110-battery). |
|temperatureAlarm |[temperatureAlarm](#53188-temperaturealarm) |0..1 |See clause [5.3.1.88](#53188-temperaturealarm). |


#### 5.5.1.14 deviceThermostat
A thermostat is used to control the ambient temperature of rooms within, for example, a house. This information model provides capabilities to interact with specific functions of thermostats.

**Table 5.5.1.14-1: Modules of deviceThermostat Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate).<br />The possible values of the "supportedModes" data point for the thermostat device are included in clause 5.6.23. |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |
|temperature |[temperature](#53187-temperature) |1 |See clause [5.3.1.87](#53187-temperature). |


#### 5.5.1.15 deviceWaterValve
A water valve is a device that is used to turn the water supply ON or OFF remotely.

**Table 5.5.1.15-1: Modules of waterValve Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|openLevel |[openLevel](#53156-openlevel) |1 |See clause [5.3.1.56](#53156-openlevel). |


#### 5.5.1.16 deviceServiceButton
A service button is a device that initiates and controls technical or business processes, such as ordering consumer and industrial goods over the Internet. It may support optional ModuleClasses to present information to a user, such as presenting textual and graphical information.

**Table 5.5.1.16-1: Modules of deviceServiceButton Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|pushButton |[pushButton](#53169-pushbutton) |1 |See clause [5.3.1.69](#53169-pushbutton). |
|connectivity |[connectivity](#53125-connectivity) |0..1 |See clause [5.3.1.25](#53125-connectivity). |
|operationMode |[operationMode](#53157-operationmode) |0..1 |See clause [5.3.1.57](#53157-operationmode). |
|battery |[battery](#53110-battery) |0..1 |See clause [5.3.1.10](#53110-battery). |
|textMessage |[textMessage](#53189-textmessage) |0..1 |See clause [5.3.1.89](#53189-textmessage). This ModuleClass may be used to present textual information to a user. |
|image |[binaryObject](#53111-binaryobject) |0..1 |See clause [5.3.1.11](#53111-binaryobject). This ModuleClass may be used to present graphical information to a user. |
|credentials |[credentials](#53127-credentials) |0..1 |See clause [5.3.1.27](#53127-credentials). |
|geoLocation |[geoLocation](#53141-geolocation) |0..1 |See clause [5.3.1.41](#53141-geolocation). This ModuleClass may be used to detect and report the geo-location of a deviceServiceButton device. |


#### 5.5.1.17 deviceGenericSensor
A device that is composed of one or more basic sensors. This generic model is proposed to represent very simple appliances that feature one or more sensing behaviours (mono/multi sensors).

**Table 5.5.1.17-1: Modules of deviceGenericSensor Device model**

|Module Instance Name |Module Class Name |Optional |Description |
|-|-|-|-|
|temperatureAlarm |[temperatureAlarm](#53188-temperaturealarm) |0..1 |See clause [5.3.1.88](#53188-temperaturealarm). |
|acousticSensor |[acousticSensor](#5312-acousticsensor) |0..1 |See clause [5.3.1.2](#5312-acousticsensor). |
|impactSensor |[impactSensor](#53147-impactsensor) |0..1 |See clause [5.3.1.47](#53147-impactsensor). |
|motionSensor |[motionSensor](#53154-motionsensor) |0..1 |See clause [5.3.1.54](#53154-motionsensor). |
|smokeSensor |[smokeSensor](#53182-smokesensor) |0..1 |See clause [5.3.1.82](#53182-smokesensor). |
|uvSensor |[uvSensor](#53192-uvsensor) |0..1 |See clause [5.3.1.92](#53192-uvsensor). |
|waterSensor |[waterSensor](#53197-watersensor) |0..1 |See clause [5.3.1.97](#53197-watersensor). |


#### 5.5.1.18 device3DDisplay
A 3D display is a device to display 3D contents such as 3D character or holographic image. 

**Table 5.5.1.18-1: Modules of device3DDisplay Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|clock |[clock](#53118-clock) |0..1 |See clause [5.3.1.18](#53118-clock). |
|audioVolume |[audioVolume](#5318-audiovolume) |0..1 |See clause [5.3.1.8](#5318-audiovolume). |
|threeDDisplay |[threeDDisplay](#531116-threeddisplay) |1 |See clause [5.3.1.116](#531116-threeddisplay). |
|connectivity |[connectivity](#53125-connectivity) |1 |See clause [5.3.1.25](#53125-connectivity). |
|machineState |[runState](#53175-runstate) |1 |See clause [5.3.1.75](#53175-runstate). |
|lock |[lock](#53152-lock) |0..1 |See clause [5.3.1.52](#53152-lock). |


#### 5.5.1.19 device3DScanner
A 3D scanner is a device to scan 3D objects such as a statue of a character. 

**Table 5.5.1.19-1: Modules of device3DScanner device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|clock |[clock](#53118-clock) |0..1 |See clause [5.3.1.18](#53118-clock). |
|threeDScanState |[runState](#53175-runstate) |1 |See clause [5.3.1.75](#53175-runstate). |
|threeDScanner |[threeDScanner](#531117-threedscanner) |1 |See clause [5.3.1.117](#531117-threedscanner). |
|connectivity |[connectivity](#53125-connectivity) |1 |See clause [5.3.1.25](#53125-connectivity). |


### 5.5.2 City Domain

#### 5.5.2.1 deviceOutdoorLamp
An outdoor lamp is a smart home appliance to provide lights and information for outside of home with smart sensing capabilities such as ultraviolet sensing.


**Table 5.5.2.1-1: Modules of deviceOutdoorLamp Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|brightness |[ brightness](#53117-brightness) |0..1 |See clause [5.3.1.17](#53117-brightness). |
|motionSensor |[motionSensor](#53154-motionsensor) |0..1 |See clause [5.3.1.54](#53154-motionsensor). |
|airQualitySensor |[airQualitySensor](#5316-airqualitysensor) |0..1 |See clause [5.3.1.6](#5316-airqualitysensor). |
|uvSensor |[uvSensor](#53192-uvsensor) |0..1 |See clause [5.3.1.92](#53192-uvsensor). |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer).<br />The timer is used to set duration of giving lights from the moment of triggering by the "[brightness](#53117-brightness)" module or "[motionSensor](#53154-motionsensor)" module. |
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |


#### 5.5.2.2 deviceMagneticParkingMonitor

A parking detector is used to detect the state of the parking space. When the vehicle enters the parking space, the detector measure the change of the geomagnetic field strength, and report the state of the parking space to a server.

**Table 5.5.2.2-1: Modules of deviceMagneticParkingMonitor Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|battery |[battery](#53110-battery) |0..1 |See clause [5.3.1.10](#53110-battery). |
|connectivity |[connectivity](#53125-connectivity) |0..1 |See clause [5.3.1.25](#53125-connectivity). |
|periodicalReportConfig  |[periodicalReportConfig](#53163-periodicalreportconfig)  |0..1 |See clause [5.3.1.63](#53163-periodicalreportconfig). |
|ParkingStatus |[parkingStatus](#53162-parkingstatus) |1 |See clause [5.3.1.62](#53162-parkingstatus). |
|magneticSensorParameters |[magneticSensorParameters](#53161-magneticsensorparameters) |1 |See clause [5.3.1.61](#53161-magneticsensorparameters). |


#### 5.5.2.3 deviceSmartElectricMeter
A smart electric meter is a metering device that is used to measure consumption data for electricity.

**Table 5.5.2.3-1: Modules of deviceSmartElectricMeter Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|battery |[battery](#53110-battery) |0..1 |See clause [5.3.1.10](#53110-battery). |
|binarySwitch |[binarySwitch](#53112-binaryswitch) |0..1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|clock |[clock](#53118-clock) |0..1 |See clause [5.3.1.18](#53118-clock). |
|energyConsumption |[energyConsumption](#53132-energyconsumption) |1 |See clause [5.3.1.32](#53132-energyconsumption). |
|energyGeneration |[energyGeneration](#53133-energygeneration) |0..1 |See clause [5.3.1.33](#53133-energygeneration). |


#### 5.5.2.4 deviceSmartGasMeter
A smart gas meter is a metering device that is used to measure consumption data for gas.

**Table 5.5.2.4-1: Modules of deviceSmartGasMeter Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|battery |[battery](#53110-battery) |0..1 |See clause [5.3.1.10](#53110-battery). |
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|connectivity |[connectivity](#53125-connectivity) |0..1 |See clause [5.3.1.25](#53125-connectivity).  |
|periodicalReportConfig  |[periodicalReportConfig](#53163-periodicalreportconfig)  |0..1 |See clause [5.3.1.63](#53163-periodicalreportconfig). |
|gasMeterReportInfo |[gasMeterReportInfo](#53140-gasmeterreportinfo) |1 |See clause [5.3.1.40](#53140-gasmeterreportinfo). |
|gasMeterControl |[binarySwitch](#53112-binaryswitch) |0..1 |See clause [5.3.1.12](#53112-binaryswitch). |
|gasMeterAlarm |[gasMeterAlarm](#53139-gasmeteralarm) |0..1 |See clause [5.3.1.39](#53139-gasmeteralarm). |


#### 5.5.2.5 deviceSmartWaterMeter
A smart water meter is a metering device that is used to measure consumption data for water.

**Table 5.5.2.5-1: Modules of deviceSmartWaterMeter Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|battery |[battery](#53110-battery) |0..1 |See clause [5.3.1.10](#53110-battery). |
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|connectivity |[connectivity](#53125-connectivity) |0..1 |See clause [5.3.1.25](#53125-connectivity).  |
|periodicalReportConfig |[periodicalReportConfig](#53163-periodicalreportconfig) |0..1 |See clause [5.3.1.63](#53163-periodicalreportconfig). |
|waterMeterSetting |[waterMeterSetting](#53196-watermetersetting) |0..1 |See clause 5.3.1.96. |
|waterMeterReportInfo |[waterMeterReportInfo](#53195-watermeterreportinfo) |1 |See clause 5.3.1.95. |
|waterMeterControl |[binarySwitch](#53112-binaryswitch) |0..1 |See clause [5.3.1.12](#53112-binaryswitch). |
|waterMeterAlarm |[waterMeterAlarm](#53194-watermeteralarm) |0..1 |See clause 5.3.1.94. |


#### 5.5.2.6 deviceStreetLightController
A street light controller is used to control the opening and closing of the street light.

**Table 5.5.2.6-1: Modules of deviceStreetLightController Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|geoLocation |[geoLocation](#53141-geolocation) |0..1 |See clause [5.3.1.41](#53141-geolocation). |
|connectivity |[connectivity](#53125-connectivity) |0..1 |See clause [5.3.1.25](#53125-connectivity). |
|periodicalReportConfig |[periodicalReportConfig](#53163-periodicalreportconfig) |0..1 |See clause [5.3.1.63](#53163-periodicalreportconfig). |
|slcReportInfo |[slcReportInfo](#53181-slcreportinfo) |1 |See clause [5.3.1.81](#53181-slcreportinfo). |
|slcParameterSetting |[slcParameterSetting](#53180-slcparametersetting) |1 |See clause [5.3.1.80](#53180-slcparametersetting). |
|slcAlarm |[slcAlarm](#53179-slcalarm) |1 |See clause [5.3.1.79](#53179-slcalarm). |


#### 5.5.2.7 deviceWaterQualityMonitor
A water quality monitor is an environmental monitoring device used to monitor water quality.

**Table 5.5.2.7-1: Modules of deviceWaterQualityMonitor Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|battery |[battery](#53110-battery) |0..1 |See clause [5.3.1.10](#53110-battery). |
|connectivity |[connectivity](#53125-connectivity) |0..1 |See clause [5.3.1.25](#53125-connectivity). |
|periodicalReportConfig |[periodicalReportConfig](#53163-periodicalreportconfig) |0..1 |See clause [5.3.1.63](#53163-periodicalreportconfig). |
|waterQualityMonitor |[waterQualityMonitor](#53198-waterqualitymonitor) |1 |See clause [5.3.1.98](#53198-waterqualitymonitor). |


#### 5.5.2.8 deviceWeatherStation
A weather station is a device that measures various atmospheric parameters.

**Table 5.5.2.8-1: Modules of deviceWeatherStation Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|outdoorTemperature	 |[temperature](#53187-temperature) |1 |See clause [5.3.1.87](#53187-temperature). |
|indoorTemperature	 |[temperature](#53187-temperature) |0..1 |See clause [5.3.1.87](#53187-temperature). |
|airQualitySensor	 |[airQualitySensor](#5316-airqualitysensor) |0..1 |See clause [5.3.1.6](#5316-airqualitysensor). |
|anemometer |[anemometer](#531100-anemometer) |0..1 |See clause [5.3.1.100](#531100-anemometer). |
|barometer	 |[barometer](#531101-barometer) |0..1 |See clause [5.3.1.101](#531101-barometer). |
|rainGauge |[rainGauge](#531102-raingauge) |0..1 |See clause [5.3.1.102](#531102-raingauge). |
|acousticSensor |[acousticSensor](#5312-acousticsensor) |0..1 |See clause [acousticSensor](#5312-acousticsensor). |
|uvSensor	 |[uvSensor](#53192-uvsensor) |0..1 |See clause [5.3.1.92](#53192-uvsensor). |


### 5.5.3 Health Domain

#### 5.5.3.1 deviceBloodPressureMonitor
A blood pressure monitor is a device that can be used to monitor the blood pressure and is composed of one or more cuffs and a main monitor machine.


**Table 5.5.3.1-1: Modules of deviceBloodPressureMonitor Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|battery |[battery](#53110-battery) |1 |See clause [5.3.1.10](#53110-battery). |
|binarySwitch |[binarySwitch](#53112-binaryswitch) |0..1 |See clause [5.3.1.12](#53112-binaryswitch). |

**Table 5.5.3.1-2: SubDevice of deviceBloodPressureMonitor Device model**

|SubDevice Instance Name |SubDevice Name |Multiplicity |Description |
|-|-|-|-|
|cuff |[subDeviceCuff](#5431-subdevicecuff) |1..N |See clause [5.4.3.1](#5431-subdevicecuff). |




#### 5.5.3.2 deviceGlucosemeter
A glucose meter is a device that can be used to monitor the blood glucose level.


**Table 5.5.3.2-1: Modules of deviceGlucoseMeter Device model**

|<br />Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|glucometer |[glucometer](#53142-glucometer) |1 |See clause [5.3.1.42](#53142-glucometer). |
|battery |[battery](#53110-battery) |1 |See clause [5.3.1.10](#53110-battery). |




#### 5.5.3.3 deviceHeartRateMonitor
A heart rate monitor is a device that can be used to monitor the heart rate.

**Table 5.5.3.3-1: Modules of deviceHeartRateMonitor Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|pulsemeter |[pulsemeter](#53168-pulsemeter) |1 |See clause [5.3.1.68](#53168-pulsemeter). |
|battery |[battery](#53110-battery) |1 |See clause [5.3.1.10](#53110-battery). |




#### 5.5.3.4 devicePulseOximeter
A pulse-oximeter is a device that can be used to monitor the blood characteristics.


**Table 5.5.3.4-1: Modules of devicePulseOxiMeter Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|pulsemeter |[pulsemeter](#53168-pulsemeter) |0..1 |See clause [5.3.1.68](#53168-pulsemeter).<br />When the "[oximeter](#53159-oximeter)" module does not exist, then the "[pulsemeter](#53168-pulsemeter)" module is mandatory. |
|oximeter |[oximeter](#53159-oximeter) |0..1 |See clause [5.3.1.59](#53159-oximeter).<br />When the "[pulsemeter](#53168-pulsemeter)" module does not exist, then the "[oximeter](#53159-oximeter)" module is mandatory. |
|battery |[battery](#53110-battery) |1 |See clause [5.3.1.10](#53110-battery). |




#### 5.5.3.5 deviceWeightScaleAndBodyCompositionAnalyser
A weight scale and body composition analyser is a device that can be used to monitor the weight and body composition.

**Table 5.5.3.5-1: Modules of deviceWeightScaleAndBodyCompositionAnalyser Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|weight |[weight](#53199-weight) |1 |See clause [5.3.1.99](#53199-weight). |
|bodyCompositionAnalyser |[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |1 |See clause [5.3.1.14](#53114-bodycompositionanalyser). |
|bioElectricalImpedanceAnalysis |[bioElectricalImpedanceAnalysis](#53113-bioelectricalimpedanceanalysis) |1 |See clause [5.3.1.13](#53113-bioelectricalimpedanceanalysis). |
|battery |[battery](#53110-battery) |1 |See clause [5.3.1.10](#53110-battery). |




### 5.5.4 Home Domain

#### 5.5.4.1 deviceAirConditioner
An air conditioner is a home appliance used to alter the properties of air (primarily temperature and humidity) to more comfortable conditions. This air conditioner information model provides capabilities to control and monitor air conditioner specific functions and resources.


**Table 5.5.4.1-1: Modules of deviceAirConditioner Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|airConJobMode |[airConJobMode](#5313-airconjobmode) |0..1 |See clause [5.3.1.3](#5313-airconjobmode). |
|airConOperationMode |[operationMode](#53157-operationmode) |0..1 |See clause [5.3.1.57](#53157-operationmode).<br />This module instance is used to trigger an airCon operation that is pre-set in "[airConJobMode](#5313-airconjobmode)". If this data point is not present, then the air conditioner's job mode can be triggered by setting the "[airConJobMode](#5313-airconjobmode)". |
|airCleanOperationMode |[operationMode](#53157-operationmode) |0..1 |See clause [5.3.1.57](#53157-operationmode).<br />This module instance is used to trigger airClean operation. |
|temperature |[temperature](#53187-temperature) |0..1 |See clause [5.3.1.87](#53187-temperature). |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |
|sleepTimer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer).<br />The sleep function, which is vendor-specific algorithm (for example increasing the temperature by one degree for every 30 minutes), is triggered instantly when "targetDuration" is set, and it indicates the time to the end of appliance operation. It is set at runtime by a user application. |
|turbo |[turbo](#53191-turbo) |0..1 |See clause [5.3.1.91](#53191-turbo). |
|airFlow |[airFlow](#5314-airflow) |0..1 |See clause [5.3.1.4](#5314-airflow). |
|powerSave |[powerSave](#53166-powersave) |0..1 |See clause [5.3.1.66](#53166-powersave). |
|airQualitySensor |[airQualitySensor](#5316-airqualitysensor) |0..1 |See clause [5.3.1.6](#5316-airqualitysensor). |
|filterInfo |[filterInfo](#53135-filterinfo) |0..1 |See clause [5.3.1.35](#53135-filterinfo). |


#### 5.5.4.2 deviceAirPurifier
An airPurifier is a home appliance is used to prevent dust and other particles from air by filtering, washing or electrostatic precipitation. This airPurifier information model provides capabilities to control and monitor airPurifier specific functions and resources.

**Table 5.5.4.2-1: Modules of deviceAirPurifier Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|airPurifierJobMode |[airPurifierJobMode](#5315-airpurifierjobmode) |0..1 |See clause [5.3.1.5](#5315-airpurifierjobmode). |
|airPurifierOperationMode |[operationMode](#53157-operationmode) |0..1 |See clause [5.3.1.57](#53157-operationmode).<br />This module instance is used to trigger the airPurifier operation. |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |
|powerSave |[powerSave](#53166-powersave) |0..1 |See clause [5.3.1.66](#53166-powersave). |
|airQualitySensor |[airQualitySensor](#5316-airqualitysensor) |0..1 |See clause [5.3.1.6](#5316-airqualitysensor). |
|filterInfo |[filterInfo](#53135-filterinfo) |0..1 |See clause [5.3.1.35](#53135-filterinfo). |


#### 5.5.4.3 deviceClothesDryer
A clothes dryer is a home appliance for drying clothes. This clothesDryer information model provides capabilities to control and monitor clothes dryer specific functions and resources.

**Table 5.5.4.3-1: Modules of deviceClothesDryer Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|clothesDryerJobMode |[clothesDryerJobMode](#53119-clothesdryerjobmode) |0..1 |See clause [5.3.1.19](#53119-clothesdryerjobmode). |
|clothesDryerOperationMode |[operationMode](#53157-operationmode) |0..1 |See clause [5.3.1.57](#53157-operationmode).<br />This module instance is used to trigger the clothesDryer operation. |


#### 5.5.4.4 deviceClothesWasher
A clothes washer is a home appliance that is used to wash laundry, such as clothing and sheets. This information model provides capabilities to interact with specific functions and resources of clothes washers.

**Table 5.5.4.4-1: Modules of deviceClothesWasher Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|clothesWasherOperationMode |[operationMode](#53157-operationmode) |0..1 |See clause [5.3.1.57](#53157-operationmode). |
|runState |[runState](#53175-runstate) |1 |See clause [5.3.1.75](#53175-runstate). |
|clothesWasherJobMode |[clothesWasherJobMode](#53120-clotheswasherjobmode) |1 |See clause [5.3.1.20](#53120-clotheswasherjobmode). |
|clothesWasherJobModeOption |[clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption) |0..1 |See clause [5.3.1.22](#53122-clotheswasherjobmodeoption). |
|remoteControlEnable |[remoteControlEnable](#53173-remotecontrolenable) |0..1 |See clause [5.3.1.73](#53173-remotecontrolenable). |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |


#### 5.5.4.5 deviceClothesWasherDryer
A clothes washer dryer is a home appliance that is a combination of cloth washer and cloth dryer in a single cabinet. This information model provides capabilities to interact with specific functions and resources of clothes washers and dryers.

**Table 5.5.4.5-1: Modules of deviceClothesWasherDryer Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|clothesWasherDryerOperationMode |[operationMode](#53157-operationmode) |0..1 |See clause [5.3.1.57](#53157-operationmode). |
|runState |[runState](#53175-runstate) |1 |See clause [5.3.1.75](#53175-runstate). |
|clothesWasherDryerJobMode |[clothesWasherDryerJobMode](#53121-clotheswasherdryerjobmode) |1 |See clause [5.3.1.21](#53121-clotheswasherdryerjobmode). |
|clothesWasherJobModeOption |[clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption) |0..1 |See clause [5.3.1.22](#53122-clotheswasherjobmodeoption). |
|remoteControlEnable |[remoteControlEnable](#53173-remotecontrolenable) |0..1 |See clause [5.3.1.73](#53173-remotecontrolenable). |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |


#### 5.5.4.6 deviceCoffeeMachine
A coffee machine is a device that is used to brew a coffee, may add foamed milk, and may include some variants, for example a grinder.

**Table 5.5.4.6-1: Modules of deviceCoffeeMachine Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|clock |[clock](#53118-clock) |0..1 |See clause [5.3.1.18](#53118-clock). |
|brewing |[brewing](#53116-brewing) |1 |See clause [5.3.1.16](#53116-brewing). |
|waterStatus |[liquidRemaining](#53151-liquidremaining) |0..1 |See clause [5.3.1.51](#53151-liquidremaining). |
|milkStatus |[liquidRemaining](#53151-liquidremaining) |0..1 |See clause [5.3.1.51](#53151-liquidremaining). |
|grinder |[grinder](#53143-grinder) |0..1 |See clause [5.3.1.43](#53143-grinder). |
|milkFoaming |[foaming](#53136-foaming) |0..1 |See clause [5.3.1.36](#53136-foaming). |
|milkQuantity |[liquidLevel](#53150-liquidlevel) |0..1 |See clause [5.3.1.50](#53150-liquidlevel). |
|brewingSwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|keepWarm |[keepWarm](#53148-keepwarm) |0..1 |See clause [5.3.1.48](#53148-keepwarm). |


#### 5.5.4.7 deviceCookerHood
A cooker hood is a device containing a mechanical fan that hangs above the stove or cooktop in the kitchen.

**Table 5.5.4.7-1: Modules of deviceCookerHood model**

|Module Instance Name |Module Class Name |Optional |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|airFlow |[airFlow](#5314-airflow) |0..1 |See clause [5.3.1.4](#5314-airflow). |
|cookerHoodJobMode |[cookerHoodJobMode](#53126-cookerhoodjobmode) |0..1 |See clause [5.3.1.26](#53126-cookerhoodjobmode). |


#### 5.5.4.8 deviceCooktop
A cooktop is a device that is a kitchen appliance designed for the purpose of cooking food.

**Table 5.5.4.8-1: Modules of deviceCooktop model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|heatingZone0 |[heatingZone](#53144-heatingzone) |1..N |See clause [5.3.1.44](#53144-heatingzone).  |

<mark>Editor Note: *heatingZone0* needs to be just *heatingZone*. Bring CR.</mark>


#### 5.5.4.9 deviceDehumidifier

A dehumidifier is a device that is used to monitor or control the state of a dehumidifying appliance.

**Table 5.5.4.9-1: Modules of deviceDehumidifier Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|relativeHumidity |[relativeHumidity](#53172-relativehumidity) |0..1 |See clause [5.3.1.72](#53172-relativehumidity). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|dehumidifierJobMode |[dehumidifierJobMode](#53128-dehumidifierjobmode) |0..1 |See clause [5.3.1.28](#53128-dehumidifierjobmode). |
|dehumidifierOperationMode |[operationMode](#53157-operationmode) |0..1 |See clause [5.3.1.57](#53157-operationmode).<br />This module instance is used to trigger dehumidifier operation. |
|Timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |
|powerSave |[powerSave](#53166-powersave) |0..1 |See clause [5.3.1.66](#53166-powersave). |


#### 5.5.4.10 deviceDigitalGallery
A digital gallery is a device that is used to display picture, e.g., paintings from artists, photos from photographers or personal, etc.

Table 5.5.4.10-1: Modules of deviceDigitalGallery Device model

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|galleryMode |[galleryMode](#53137-gallerymode) |1 |See clause [5.3.1.37](#53137-gallerymode). |
|pictureInput |[mediaSelect](#53153-mediaselect) |1 |See clause [5.3.1.53](#53153-mediaselect). |
|powerSave |[powerSave](#53166-powersave) |0..1 |See clause [5.3.1.66](#53166-powersave). |
|clock |[clock](#53118-clock) |0..1 |See clause [5.3.1.18](#53118-clock). |


#### 5.5.4.11 deviceDishWasher
A dish washer is a home appliance used to wash dishes. This information model provides capabilities to interact with specific functions and resources of a dish washer. 

**Table 5.5.4.11-1: Modules of deviceDishWasher Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|dishWasherJobMode |[dishWasherJobMode](#53129-dishwasherjobmode) |0..1 |See clause [5.3.1.29](#53129-dishwasherjobmode). |


#### 5.5.4.12 deviceFan
A fan is a device that is used to monitor or control the state of a fanning device.

**Table 5.5.4.12-1: Modules of deviceFan model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |


#### 5.5.4.13 deviceFoodProbe
A food probe is a device that is used to measure the internal temperature of food.

**Table 5.5.4.13-1: Modules of deviceFoodProbe model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|temperature |[temperature](#53187-temperature) |1 |See clause [5.3.1.87](#53187-temperature). |


#### 5.5.4.14 deviceFreezer
A freezer is a large container like a fridge in which the temperature is kept below freezing point, so that food can be stored inside of it for long periods. This freezer information model provides capabilities to monitor freezer specific functions and resources.

**Table 5.5.4.14-1: Modules of deviceFreezer Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|temperature |[temperature](#53187-temperature) |1 |See clause [5.3.1.87](#53187-temperature). |


#### 5.5.4.15 deviceHomeCCTV
A home CCTV is a smart home appliance to provide monitoring capabilities when people stay way from their home or a room, or to monitor the environmental status of their home or room.

**Table 5.5.4.15-1: Modules of deviceHomeCCTV Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|sessionDescription |[sessionDescription](#53177-sessiondescription) |1 |See clause [5.3.1.77](#53177-sessiondescription). |
|playerControl |[playerControl](#53165-playercontrol) |0..1 |See clause [5.3.1.65](#53165-playercontrol). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|motionSensor |[motionSensor](#53154-motionsensor) |0..1 |See clause [5.3.1.54](#53154-motionsensor). |
|airQualitySensor |[airQualitySensor](#5316-airqualitysensor) |0..1 |See clause [5.3.1.6](#5316-airqualitysensor). |
|ozoneMeter |[ozoneMeter](#53160-ozonemeter) |0..1 |See clause [5.3.1.60](#53160-ozonemeter). |
|smokeSensor |[smokeSensor](#53182-smokesensor) |0..1 |See clause [5.3.1.82](#53182-smokesensor). |
|acousticSensor |[acousticSensor](#5312-acousticsensor) |0..1 |See clause [5.3.1.2](#5312-acousticsensor). |
|impactSensor |[impactSensor](#53147-impactsensor) |0..1 |See clause [5.3.1.47](#53147-impactsensor). |
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|alarmSpeaker |[alarmSpeaker](#5317-alarmspeaker) |0..1 |See clause [5.3.1.7](#5317-alarmspeaker). |


#### 5.5.4.16 deviceHumidifier
A humidifier is a device that is used to monitor or control the state of a humidifying appliance.

**Table 5.5.4.16-1: Modules of deviceHumidifier Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |


#### 5.5.4.17 deviceKettle
Kettle is a device used to boil water. It may set a desired temperature for water and may keep water warm for a desired time.

**Table 5.5.4.17-1: Modules of deviceKettle Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|waterStatus |[liquidRemaining](#53151-liquidremaining) |0..1 |See clause [5.3.1.51](#53151-liquidremaining). |
|boilingSwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|temperature |[temperature](#53187-temperature) |0..1 |See clause [5.3.1.87](#53187-temperature). |
|keepWarm |[keepWarm](#53148-keepwarm) |0..1 |See clause [5.3.1.48](#53148-keepwarm). |


#### 5.5.4.18 deviceMicrogeneration
A microgeneration is a Home Energy Management System (HEMS) device that is used to generate energy. Examples of microgeneration devices are photovoltaics device or fuel cells.

**Table 5.5.4.18-1: Modules of deviceMicrogeneration Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|binarySwitch |[binarySwitch](#53112-binaryswitch) |0..1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|energyGeneration |[energyGeneration](#53133-energygeneration) |1 |See clause [5.3.1.33](#53133-energygeneration). |


#### 5.5.4.19 deviceOven
An oven is a home appliance used to roast and heat food in a complete stove. This information model is applicable to different types of ovens: gas ovens, electrical ovens, steam ovens, microwave ovens, etc. This information model provides capabilities to interact with specific functions and resources of ovens. 

**Table 5.5.4.19-1: Modules of deviceOven Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch).<br />Depending on the manufacturer policies or regulations, the binary switch might only be used to turn the device off. |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |
|temperature |[temperature](#53187-temperature) |1 |See clause [5.3.1.87](#53187-temperature). |


#### 5.5.4.20 deviceRefrigerator
A refrigerator is a home appliance used to store food at temperatures which are a few degrees above the freezing point of water. This information model provides capabilities to interact with specific functions and resource of refrigerators.

**Table 5.5.4.20-1: Modules of deviceRefrigerator Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |0..1 |See clause [5.3.1.12](#53112-binaryswitch). |
|powerSave |[powerSave](#53166-powersave) |0..1 |See clause [5.3.1.66](#53166-powersave). |
|doorStatus |[doorStatus](#53130-doorstatus) |0..1 |See clause [5.3.1.30](#53130-doorstatus). |
|frozenTemperature |[temperature](#53187-temperature) |0..1 |See clause [5.3.1.87](#53187-temperature). |
|fridgeTemperature |[temperature](#53187-temperature) |1 |See clause [5.3.1.87](#53187-temperature). |
|customTemperature |[temperature](#53187-temperature) |0..1 |See clause [5.3.1.87](#53187-temperature).<br />This module can be configured to fridge temperature or frozen temperature based on its usage by manufacturer |
|refrigeration |[refrigeration](#53171-refrigeration) |0..1 |See clause [5.3.1.71](#53171-refrigeration). |
|controlPanelLock |[lock](#53152-lock) |0..1 |See clause [5.3.1.52](#53152-lock). |
|waterFilterInfo |[filterInfo](#53135-filterinfo) |0..1 |See clause [5.3.1.35](#53135-filterinfo). |


#### 5.5.4.21 deviceRiceCooker
A rice cooker is a home appliance used to cook and heat food. It may set a desired heating time for food and may keep food warm for a desired time.

**Table 5.5.4.21-1: Modules of deviceRiceCooker Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch).<br />Depending on the manufacturer policies or regulations, the binary switch might only be used to turn the device off. |
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |
|keepWarm |[keepWarm](#53148-keepwarm) |0..1 |See clause [5.3.1.48](#53148-keepwarm). |


#### 5.5.4.22 deviceRobotCleaner
A robot cleaner is an autonomous robotic vacuum cleaner that has intelligent programming and a limited vacuum cleaning system. This robot cleaner information model provides capabilities to control and monitor robot cleaner specific functions and resources. 

**Table 5.5.4.22-1: Modules of deviceRobotCleaner Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|battery |[battery](#53110-battery) |0..1 |See clause [5.3.1.10](#53110-battery). |
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|robotCleanerOperationMode |[operationMode](#53157-operationmode) |0..1 |See clause [5.3.1.57](#53157-operationmode). |
|remoteControlEnable |[remoteControlEnable](#53173-remotecontrolenable) |0..1 |See clause [5.3.1.73](#53173-remotecontrolenable). |
|robotCleanerJobMode |[robotCleanerJobMode](#53174-robotcleanerjobmode) |1 |See clause [5.3.1.74](#53174-robotcleanerjobmode). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |


#### 5.5.4.23 deviceSecurityPanel
A security panel is a device that can change the security mode of, for example, an alarm system.

**Table 5.5.4.23-1: Modules of deviceSecurityPanel model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|securityMode |[securityMode](#53176-securitymode) |1 |See clause [5.3.1.76](#53176-securitymode). |


#### 5.5.4.24 deviceSetTopBox
A set top box is a device that in general contains a TV tuner input and displays output to a TV.

**Table 5.5.4.24-1: Modules of deviceSetTopBox model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|audioVolume |[audioVolume](#5318-audiovolume) |0..1 |See clause [5.3.1.8](#5318-audiovolume). |
|Channel |[televisionChannel](#53186-televisionchannel) |0..1 |See clause [5.3.1.86](#53186-televisionchannel). |
|mediaInput |[mediaSelect](#53153-mediaselect) |0..1 |See clause [5.3.1.53](#53153-mediaselect). |
|mediaOutput |[mediaSelect](#53153-mediaselect) |0..1 |See clause [5.3.1.53](#53153-mediaselect). |


#### 5.5.4.25 deviceSteamCloset
A deviceSteamCloset is a home appliance that de-wrinkles, sanitizes and dries to clean fabrics similar to a dry cleaner. This information model provides capabilities to interact with specific functions and resources of the steam closet. 

**Table 5.5.4.25-1: Modules of deviceSteamCloset Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|steamClosetJobMode |[steamClosetJobMode](#53185-steamclosetjobmode) |1 |See clause [5.3.1.85](#53185-steamclosetjobmode). |
|steamClosetOperationMode |[operationMode](#53157-operationmode) |0..1 |See clause [5.3.1.57](#53157-operationmode). |


#### 5.5.4.26 deviceStorageBattery
A storage battery is a Home Energy Management System HEMS device that is used to provide the home with electrical energy. 

**Table 5.5.4.26-1: Modules of deviceStorageBattery Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|binarySwitch |[binarySwitch](#53112-binaryswitch) |0..1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|battery |[battery](#53110-battery) |1 |See clause [5.3.1.10](#53110-battery). |


#### 5.5.4.27 deviceTelevision
A television (TV) is a home appliance used to show audio and visual content such as broadcasting programs and network streaming. This TV information model provides capabilities to control and monitor TV specific resources.

**Table 5.5.4.27-1: Modules of deviceTelevision Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|audioVolume |[audioVolume](#5318-audiovolume) |0..1 |See clause [5.3.1.8](#5318-audiovolume). |
|televisionChannel |[televisionChannel](#53186-televisionchannel) |0..1 |See clause [5.3.1.86](#53186-televisionchannel). |
|playerControl |[playerControl](#53165-playercontrol) |0..1 |See clause [5.3.1.65](#53165-playercontrol). |
|mediaInput |[mediaSelect](#53153-mediaselect) |0..1 |See clause [5.3.1.53](#53153-mediaselect). |
|mediaOutput |[mediaSelect](#53153-mediaselect) |0..1 |See clause [5.3.1.53](#53153-mediaselect). |


#### 5.5.4.28 deviceWaterHeater
A water heater is a device that is used to provide hot water through home facilities.

**Table 5.5.4.28-1: Modules of deviceWaterHeater Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|clock |[clock](#53118-clock) |0..1 |See clause [5.3.1.18](#53118-clock). |
|boiler |[boiler](#53115-boiler) |0..1 |See clause [5.3.1.15](#53115-boiler). |
|hotWaterSupply |[hotWaterSupply](#53146-hotwatersupply) |0..1 |See clause [hotWaterSupply](#53146-hotwatersupply). |


#### 5.5.4.29 deviceWindowShade
The window shade is an appliance that provides the ability to cover windows. This device type includes but not limited to roller shades, drapes, and tilt-only blinds.

**Table 5.5.4.29-1: Modules of deviceWindowShade Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|openLevel |[openLevel](#53156-openlevel) |1 |See clause [5.3.1.56](#53156-openlevel). |
|battery |[battery](#53110-battery) |0..1 |See clause [5.3.1.10](#53110-battery). |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |


#### 5.5.4.30 deviceBottleWarmer
A bottle warmer is an appliance designed for the purpose of warming the feeding bottle.

**Table 5.5.4.30-1: Modules of deviceBottleWarmer Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|keepWarm |[keepWarm](#53148-keepwarm) |0..1 |See clause [5.3.1.48](#53148-keepwarm). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |


#### 5.5.4.31 deviceGarbageDisposal
A Garbage Disposal is an appliance designed for the purpose of disposing the kitchen waste.

**Table 5.5.4.31-1: Modules of deviceGarbageDisposal Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|disposal |[disposal](#531104-disposal) |1 |See clause [5.3.1.104](#531104-disposal). |


#### 5.5.4.32 deviceWaterPurifier
A Water Purifier is an appliance to filter the impurity substance in water by different filter elements. This Water Purifier information model provides capabilities to control and monitor Water Purifier specific functions and resources.

**Table 5.5.4.32-1: Modules of deviceWaterPurifier Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |
|waterQualityMonitor |[waterQualityMonitor](#53198-waterqualitymonitor) |0..1 |See clause [5.3.1.98](#53198-waterqualitymonitor). |
|filterInfo |[filterInfo](#53135-filterinfo) |0..1 |See clause [5.3.1.35](#53135-filterinfo). |
|waterLevel |[liquidRemaining](#53151-liquidremaining) |0..1 |See clause [5.3.1.51](#53151-liquidremaining). |
|waterFilter |[waterFilterType](#531105-waterfiltertype) |0..1 |See clause [5.3.1.105](#531105-waterfiltertype). |


#### 5.5.4.33 deviceAirHeater
An air heater is a home appliance used to increase the temperature of an indoor space, for example, a room. This information model provides capabilities to interact with specific functions and resources of air heaters.

**Table 5.5.4.33-1: Modules of deviceAirHeater Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|airHeating |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate).<br />This module class is used to control and monitor the state of an air heater. |
|temperature  |[temperature](#53187-temperature)  |1 |See clause [5.3.1.87](#53187-temperature). |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |


#### 5.5.4.34 deviceJuicer
Juicer is a machine that can quickly press fruits and vegetables into juice. It may set a desired stir time for juice and  can choose the right spin speed of blender according to the hardness of the object (such as fruits and vegetables)  which you want to stir.

**Table 5.5.4.y-1: Modules of deviceJuicer Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch).<br />Depending on the manufacturer policies or regulations, the binary switch might only be used to turn the device off. |
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|blender |[blender](#531118-blender) |0..1 |See clause [5.3.1.118](#531118-blender). |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |


#### 5.5.4.35 deviceShoesWasher
A shoes washer is a home appliance used to wash shoes. This information model provides capabilities to interact with specific functions and resources of a shoes washer. 

**Table 5.5.4.35-1: Modules of deviceShoesWasher Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |1 |See clause [5.3.1.75](#53175-runstate). |
|shoesWasherJobMode |[shoesWasherJobMode](#531119-shoeswasherjobmode) |1 |See clause [5.3.1.119](#531119-shoeswasherjobmode). |
|timer |[timer](#53190-timer) |0..1 |See clause [5.3.1.90](#53190-timer). |


### 5.5.5 Industry Domain

<mark>For further studies.</mark>

### 5.5.6 Vehicular Domain

#### 5.5.6.1 deviceElectricVehicleCharger
An electric vehicle charger is a device that is used for charging or discharging electric vehicles.


**Table 5.5.6.1-1: Modules of deviceElectricVehicleCharger Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|faultDetection |[faultDetection](#53134-faultdetection) |1 |See clause [5.3.1.34](#53134-faultdetection). |
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |1 |See clause [5.3.1.75](#53175-runstate). |
|battery |[battery](#53110-battery) |1 |See clause [5.3.1.10](#53110-battery). |
|electricVehicleConnector |[electricVehicleConnector](#53131-electricvehicleconnector) |1 |See clause [5.3.1.31](#53131-electricvehicleconnector). |




#### 5.5.6.2 deviceElectricMotorcycle
An electric motorcycle is a plug-in electric vehicle with two wheels. The electricity is stored on board in a rechargeable battery which drives one or more electric motors. This information model provides capabilities to interact with specific functions and resources of an electric motorcycle.

**Table 5.5.6.2-1: Modules of deviceElectricMotorcycle Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|runState |[runState](#53175-runstate) |1 |See clause [5.3.1.75](#53175-runstate).<br />This module class is used to control and monitor the state of an electric motorcycle. |
|battery |[battery](#53110-battery) |1..N |See clause [5.3.1.10](#53110-battery). |
|geoLocation |[geoLocation](#53141-geolocation) |1 |See clause [5.3.1.41](#53141-geolocation). |
|clock |[clock](#53118-clock) |0..1 |See clause [5.3.1.18](#53118-clock). |
|connectivity |[connectivity](#53125-connectivity) |0..1 |See clause [5.3.1.25](#53125-connectivity). |
|faultDetection |[faultDetection](#53134-faultdetection) |0..1 |See clause [5.3.1.34](#53134-faultdetection). |
|lock |[lock](#53152-lock) |0..1 |See clause [5.3.1.52](#53152-lock). |


### 5.5.7 Agriculture Domain

#### 5.5.7.1 deviceCowActivityMonitor
A cow activity monitor device is a battery-powered wireless metering device that is used to measure the activity data (e.g. step count) of a cow in the dairy farming industry. The collected data can be used to analyse and predict the estrus of the cow for better mating and milk production.

**Table 5.5.7.1-1: Modules of deviceCowActivityMonitor Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|cowActivityMonitor |[cowActivityMonitor](#5371-cowactivitymonitor) |1 |See clause [5.3.7.1](#5371-cowactivitymonitor). |
|battery |[battery](#53110-battery) |0..1 |See clause [5.3.1.10](#53110-battery). |
|connectivity |[connectivity](#53125-connectivity) |0..1 |See clause [5.3.1.25](#53125-connectivity). |
|periodicalReportConfig  |[periodicalReportConfig](#53163-periodicalreportconfig)  |0..1 |See clause [5.3.1.63](#53163-periodicalreportconfig). |


### 5.5.8 Railway Domain

#### 5.5.8.1 deviceHandheldPTTTerminal
A handheld Push-to-Talk (PTT) terminal is a device of the Railway Domain. The terminal is usually used between the railway workers including train driver, crew and rail-side worker to share their work status via voice communication.

**Table 5.5.8.1-1: Modules of deviceHandheldPTTTerminal Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|audioVolume |[audioVolume](#5318-audiovolume) |1 |See clause [5.3.1.8](#5318-audiovolume). |
|battery |[battery](#53110-battery) |1 |See clause [5.3.1.10](#53110-battery). |
|clock |[clock](#53118-clock) |0..1 |See clause [5.3.1.18](#53118-clock). |
|energyConsumption |[energyConsumption](#53132-energyconsumption) |0..1 |See clause [5.3.1.32](#53132-energyconsumption). |
|keypad |[keypad](#53149-keypad) |1 |See clause [5.3.1.49](#53149-keypad). |
|operationMode |[operationMode](#53157-operationmode) |0..1 |See clause [5.3.1.57](#53157-operationmode). |
|phoneCall |[phoneCall](#53164-phonecall) |1 |See clause [5.3.1.64](#53164-phonecall). |
|PTTButton |[pushButton](#53169-pushbutton) |1 |See clause [5.3.1.69](#53169-pushbutton). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|signalStrength |[signalStrength](#53178-signalstrength) |0..1 |See clause [5.3.1.78](#53178-signalstrength). |


#### 5.5.8.2 deviceTrainborneTerminal
A handheld Push-to-Talk (PTT) terminal is a device of the Railway Domain. The terminal is usually used between the railway workers including train driver, crew and rail-side worker to share their work status via voice communication.

**Table 5.5.8.2-1: Modules of deviceTrainborneTerminal Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|audioVolume |[audioVolume](#5318-audiovolume) |1 |See clause [5.3.1.8](#5318-audiovolume). |
|clock |[clock](#53118-clock) |0..1 |See clause [5.3.1.18](#53118-clock). |
|energyConsumption |[energyConsumption](#53132-energyconsumption) |0..1 |See clause [5.3.1.32](#53132-energyconsumption). |
|keypad |[keypad](#53149-keypad) |1 |See clause [5.3.1.49](#53149-keypad). |
|operationMode |[operationMode](#53157-operationmode) |0..1 |See clause [5.3.1.57](#53157-operationmode). |
|phoneCall |[phoneCall](#53164-phonecall) |1 |See clause [5.3.1.64](#53164-phonecall). |
|PTTButton |[pushButton](#53169-pushbutton) |1 |See clause [5.3.1.69](#53169-pushbutton). |
|runState |[runState](#53175-runstate) |0..1 |See clause [5.3.1.75](#53175-runstate). |
|signalStrength |[signalStrength](#53178-signalstrength) |0..1 |See clause [5.3.1.78](#53178-signalstrength). |
|baliseTransmission |[baliseTransmissionModule](#5381-balisetransmissionmodule) |0..1 |See clause [5.3.8.1](#5381-balisetransmissionmodule). |
|connectivity |[connectivity](#53125-connectivity) |0..1 |See clause [5.3.1.25](#53125-connectivity). |


#### 5.5.8.3 deviceCardRechargingMachine
A card recharging machine is a device of the Railway Domain. The machine provides recharging service for pre-paid card for transportation. Railway users simply recharging their cards and use it as a payment method for transportation fare.

**Table 5.5.8.3-1: Modules of deviceCardRechargingMachine Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|clock |[clock](#53118-clock) |1 |See clause [5.3.1.18](#53118-clock). |
|touchScreen |[touchScreen](#531106-touchscreen) |1 |See clause [5.3.1.106](#531106-touchscreen). |
|keypad |[keypad](#53149-keypad) |0..1 |See clause [5.3.1.49](#53149-keypad). |
|emergencyButton |[pushButton](#53169-pushbutton) |1 |See clause [5.3.1.69](#53169-pushbutton). |
|audioVolume |[audioVolume](#5318-audiovolume) |0..1 |See clause [5.3.1.8](#5318-audiovolume). |
|prePaidCardReader |[prePaidCardReader](#531107-prepaidcardreader) |1 |See clause [5.3.1.107](#531107-prepaidcardreader). |
|billDeposit |[billDeposit](#531108-billdeposit) |1 |See clause [5.3.1.108](#531108-billdeposit). |
|billWithdrawal |[billWithdrawal](#531109-billwithdrawal) |1 |See clause [5.3.1.109](#531109-billwithdrawal). |
|coinDeposit |[coinDeposit](#531110-coindeposit) |1 |See clause [5.3.1.110](#531110-coindeposit). |
|cashDispenser |[cashDispenser](#531111-cashdispenser) |1 |See clause [5.3.1.111](#531111-cashdispenser). |
|cardScanner |[cardScanner](#531112-cardscanner) |0..1 |See clause [5.3.1.112](#531112-cardscanner). |
|connectivity |[connectivity](#53125-connectivity) |1 |See clause [5.3.1.25](#53125-connectivity). |
|machineState |[runState](#53175-runstate) |1 |See clause [5.3.1.75](#53175-runstate). |
|lock |[lock](#53152-lock) |1 |See clause [5.3.1.52](#53152-lock). |


#### 5.5.8.4 deviceSmartGate
A smart gate is a device of the Railway Domain. The gate provides passenger service for checking ticket and control the gate usage. Railway users simply use the gate with their ticket (e.g. passenger card) which have pre-paid card function.

**Table 5.5.8.4-1: Modules of deviceSmartGate Device model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|clock |[clock](#53118-clock) |1 |See clause [5.3.1.18](#53118-clock). |
|touchScreen |[touchScreen](#531106-touchscreen) |0..1 |See clause [5.3.1.106](#531106-touchscreen). |
|emergencyButton |[pushButton](#53169-pushbutton) |0..1 |See clause [5.3.1.69](#53169-pushbutton). |
|audioVolume |[audioVolume](#5318-audiovolume) |0..1 |See clause [5.3.1.8](#5318-audiovolume). |
|ticketReader |[prePaidCardReader](#531107-prepaidcardreader) |1 |See clause [5.3.1.107](#531107-prepaidcardreader). |
|crossingSensor |[crossingBarrier](#531115-crossingbarrier) |1 |See clause [5.3.1.115](#531115-crossingbarrier). |
|connectivity |[connectivity](#53125-connectivity) |1 |See clause [5.3.1.25](#53125-connectivity). |
|gateState |[runState](#53175-runstate) |1 |See clause [5.3.1.75](#53175-runstate). |
|directionPanel |[headingSensor](#531113-headingsensor) |0..1 |See clause [5.3.1.113](#531113-headingsensor). |
|crossingIndicatorColour |[colour](#53123-colour) |1 |See clause [5.3.1.23](#53123-colour). |
|crossingIndicatorColourSaturation |[colourSaturation](#53124-coloursaturation) |1 |See clause [5.3.1.24](#53124-coloursaturation). |
|crossingIndicatorColourBrightness |[brightness](#53117-brightness) |1 |See clause [5.3.1.17](#53117-brightness). |
|crossingBarrier |[crossingBarrier](#531115-crossingbarrier) |1 |See clause [5.3.1.115](#531115-crossingbarrier). |


#### 5.5.8.5 deviceSmartScreenDoor
A smart screen door is a device of the Railway Domain. The screen doors are pairs of sliding doors in a platform with synchronization of doors of a train that is staying in the platform. When the train doors are open, the smart screen doors are open in simultaneously, and vice versa. The screen doors are used in the metro platform mostly.

**Table 5.5.8.5-1: Modules of deviceSmartScreenDoor Device Model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|audioVolume |[audioVolume](#5318-audiovolume) |0..1 |See clause [audioVolume](#5318-audiovolume). |
|binarySwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|releaseSwitch |[binarySwitch](#53112-binaryswitch) |1 |See clause [5.3.1.12](#53112-binaryswitch). |
|crossingIndicatorColourBrightness |[brightness](#53117-brightness) |0..1 |See clause [5.3.1.17](#53117-brightness). |
|crossingIndicatorColour |[colour](#53123-colour) |0..1 |See clause [5.3.1.23](#53123-colour). |
|crossingIndicatorColourSaturation |[colourSaturation](#53124-coloursaturation) |0..1 |See clause [5.3.1.24](#53124-coloursaturation). |
|connectivity |[connectivity](#53125-connectivity) |1 |See clause [5.3.1.25](#53125-connectivity). |
|crossingSensor |[crossingBarrier](#531115-crossingbarrier) |1 |See clause [5.3.1.115](#531115-crossingbarrier). |
|screenDoor |[doorStatus](#53130-doorstatus) |1..N |See clause [5.3.1.30](#53130-doorstatus). |
|directionPanel |[headingSensor](#531113-headingsensor) |0..1 |See clause [5.3.1.113](#531113-headingsensor). |
|emergencyButton |[pushButton](#53169-pushbutton) |1 |See clause [5.3.1.69](#53169-pushbutton). |
|gateState |[runState](#53175-runstate) |1 |See clause [5.3.1.75](#53175-runstate). |


### 5.5.9 Public Safety Domain

#### 5.5.9.1 devicePWSCenter

<mark>Missing description</mark>

**Table 5.5.9.1-1: Modules of devicePWSCenter Device**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|disseminator |[Disseminator](#53101-disseminator) |1 |See clause [5.3.10.1 Disseminator](#53101-disseminator). |

#### 5.5.9.2 devicePWSEquipment

<mark>Missing description</mark>

**Table 5.5.9.2-1: Modules of devicePWSEquipment Device**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|emergencyHandler |[emergencyHandler](#53102-emergencyhandler) |1 |See clause [5.3.10.2](#53102-emergencyhandler). |
|settings |[settings](#53103-settings) |1 |See clause [settings](#53103-settings). |

## 5.6 Enumeration type definitions

### 5.6.0 Introduction

All enumeration types are defined in the same domain, Horizontal Domain, prefix 'hd'.


### 5.6.1 hd:enum3DprinterTechnology
Used for the "printType" data point of the ["threeDprinter"](#5311-threeDprinter)  ModuleClass.

**Table 5.6.11: Interpretation of hd:enum3DprinterTechnology**

|Value |Interpretation |Note |
|-|-|-|
|1 |Fused Filament Fabrication |FFF |
|2 |Fused Deposition Modelling |FDM |
|3 |Digital Light Processing |DLP |
|4 |Powder Bed & inkjet head 3D Printing |PBP |
|5 |Photopolymer Jetting Technology |PolyJet |
|6 |Laminated Object Manufacturing |LOM |
|7 |Stereolithography Apparatus |SLA |
|8 |Selective Laser Sintering |SLS |

NOTE: See clause ["5.3.1.1 "threeDprinter"](#5311-threeDprinter).


### 5.6.2 hd:enumAdfState
Used for the "currentAdfState" and "adfStates" data points of the "[autoDocumentFeeder](#5319-autodocumentfeeder)" ModuleClass.

**Table 5.6.21: Interpretation of hd:enumAdfState**

|Value |Interpretation |Note |
|-|-|-|
|1 |processing | |
|2 |empty | |
|3 |jam | |
|4 |loaded | |
|5 |mispick |The product did not pick up the paper in the document feeder. |
|6 |hatchOpen |The product hatch is open. |
|7 |duplexPageTooShort | |
|8 |duplexPageTooLong | |
|9 |multipickDetected | |
|10 |inputTrayFailed | |
|11 |inputTrayOverloaded | |

NOTE: See clause [5.3.1.9 autoDocumentFeeder](#5319-autodocumentfeeder). <mark>Negative values are reserved for vendor specific modes.</mark>




### 5.6.3 hd:enumAirConJobMode
Used for the "currentJobMode" and "jobModes" data point of the "[airConJobMode](#5313-airconjobmode)" ModuleClass.

<mark>Editor note: The notes below refer to the deviceAirConditioner, but are actually for attributes of the ModuleClass</mark>


**Table 5.6.31: Interpretation of hd:enumAirConJobMode**

|Value |Interpretation |Note |
|-|-|-|
|1 |cool |This value is for deviceAirConditioner and indicates cool mode. |
|2 |airDry |This value is for deviceAirConditioner and indicates air dry mode. |
|3 |fan |This value is for deviceAirConditioner and indicates fan mode. |
|4 |AI |This value is for deviceAirConditioner and indicates artificial intelligence mode. |
|5 |heat |This value is for deviceAirConditioner and indicates heat mode. |
|6 |airClean |This value is for deviceAirConditioner and indicates air clean mode. |
|7 |ACO |This value is for deviceAirConditioner and indicates Auto Change Over mode. |
|8 |aroma |This value is for deviceAirConditioner and indicates aroma mode. |

NOTE: See clause [5.3.1.3 airConJobMode](#5313-airconjobmode). <mark>Negative values are reserved for vendor specific modes</mark>.




### 5.6.4 hd:enumAirPurifierJobMode
Used for the "currentJobMode" and "jobModes" data points of the "[airPurifierJobMode](#5315-airpurifierjobmode)" ModuleClass.


**Table 5.6.41: Interpretation of hd:enumAirPurifierJobMode**

|Value |Interpretation |Note |
|-|-|-|
|1 |normalClean |This indicates the normal mode that operates the basic function.  |
|2 |sleep |This indicates the sleep mode that turns the operating function off at the time set by a timer. |
|3 |silent |This indicates the silent mode that generates low noise |
|4 |wet |This indicates the wet mode that passes the air that's already filtered through water filter once again to provide the humidification effect |
|5 |circulate |This indicates the circulate mode that circulates the purified air by rotating the fan on top of the air purifier |
|6 |dual |This indicates the dual mode that operates both the upper and lower parts of the air purifier |
|7 |auto |This indicates the auto mode that first measures the pollution level (e.g., good, normal, bad, very bad) and then, triggers appropriate modes based on the measured level. In case of bad and very bad condition, the rotating fan on the upper side starts its operation |

NOTE: See clause [5.3.1.5 airPurifierJobMode](#5315-airpurifierjobmode). <mark>Negative values are reserved for vendor specific modes.</mark>




### 5.6.5 hd:enumAlertColourCode
Used for the "light" data point of the "[alarmSpeaker](#5317-alarmspeaker)" ModuleClass.


**Table 5.6.51: Interpretation of hd:enumAlertColourCode**

|Value |Interpretation |Note |
|-|-|-|
|1 |red |This colour indicates the alarm status. |
|2 |green |This colour indicates the alarm has been cleared. |

NOTE: See clause [5.3.1.7 alarmSpeaker](#5317-alarmspeaker).




### 5.6.6 hd:enumCallState
Used for the "callState" data point in the "[phoneCall](#53164-phonecall)" ModuleClass.


**Table 5.6.61: Interpretation of hd:enumCallState**

|Value |Interpretation |Note |
|-|-|-|
|1 |hangup | |
|2 |calling | |
|3 |ringing | |
|4 |busy | |
|5 |answered | |
|6 |noline | |
|7 |voicemail | |
|8 |redirected | |

NOTE: See clause [5.3.1.64 "phoneCall"](#53164-phonecall).




### 5.6.7 hd:enumClothesDryerJobMode
Used for the "currentJobMode" and "jobModes" data points of the "[clothesDryerJobMode](#53119-clothesdryerjobmode)" ModuleClass.

**Table 5.6.71: Interpretation of hd:enumClothesDryerJobMode**

|Value |Interpretation |Note |
|-|-|-|
|1 |normal |Normal cycle. |
|2 |quickDry |About half the length of a normal cycle, this setting uses high heat to dry a few items. |
|3 |permanentPress |Slow drying with low heat helps wrinkle-free garments live up to their name and keeps the hard creases out of things one typically irons. |
|4 |heavyDuty |Tumbling for an extended period with high heat for sturdy items (towels, sweats, jeans). |
|5 |delicates |A short, low-heat cycle for delicates and other items such as spandex workout gear, which loses its stretch when too much heat is used. |
|6 |airDry |A cool-air setting for items that can't take any heat, such as plastic tablecloths and rubber-backed rugs. |
|7 |extendedTumble |Periodically tumbles clothes without heats for a preset amount of time after they're dry to prevent wrinkles. |

NOTE: See clause [5.3.1.19 clothesDryerJobMode](#53119-clothesdryerjobmode). <mark>Negative values are reserved for vendor specific modes</mark>.




### 5.6.8 hd:enumClothesWasherDryerJobMode
Used for "currentJobModes" and "jobModes" data points of "[clothesWasherDryerJobMode](#53121-clotheswasherdryerjobmode)" ModuleClass. <mark>Manufacturers can define their own courses by setting this value to negative values.</mark>

**Table 5.6.81: Interpretation of hd:enumClothesWasherDryerJobMode**

|Value |Interpretation |Note |
|-|-|-|
|1 |normal | |
|2 |quick | |
|3 |auto | |
|4 |delicates | |
|5 |heavy duty | |

NOTE: See clause [5.3.1.21 "clothesWasherDryerJobMode"](#53121-clotheswasherdryerjobmode). <mark>Negative values are reserved for vendor specific modes.</mark>




### 5.6.9 hd:enumClothesWasherJobMode
Used for the "currentJobModes" and "jobModes " data points of the "[clothesWasherJobMode](#53120-clotheswasherjobmode)" ModuleClass. Washing options such as water temperature and spin speed are decided to pre-set values upon selected washing course. <mark>Manufacturers can define their own courses by setting this value to negative values</mark>.


**Table 5.6.91: Interpretation of hd:enumClothesWasherJobMode**

|Value |Interpretation |Note |
|-|-|-|
|1 |normal | |
|2 |smallLoad | |
|3 |delicate | |
|4 |comforter | |
|5 |expressWash | |
|6 |cleanWash | |
|7 |kidsWear | |
|8 |workoutWears | |

NOTE: See clause [5.3.1.20 "clothesWasherJobMode"](#53120-clotheswasherjobmode). <mark>Negative values are reserved for vendor specific modes</mark>.




### 5.6.10 hd:enumCookerHoodJobMode
Used for the "currentJobMode" and "jobModes" DataPoints of the "[cookerHoodJobMode](#53126-cookerhoodjobmode)" ModuleClass.

**Table 5.6.101: Interpretation of hd:enumCookerHoodJobMode**

|Value |Interpretation |Note |
|-|-|-|
|1 |Always-on |This value indicates the always-on mode which keeps running the fan for ventilation. |
|2 |Intensive |This value indicates the intensive mode used when a large volume of cooking fume is being produced. |
|3 |Sensor |This value indicates the sensor mode which changes fan speed depend on the volume and heat of cooking fume. |

NOTE: See clause [5.3.1.26 "cookerHoodJobMode"](#53126-cookerhoodjobmode). <mark>Negative values are reserved for vendor specific modes</mark>.




### 5.6.11 hd:enumDehumidifierJobMode
Used for "currentJobMode" and "jobModes" data points of the "[dehumidifierJobMode](#53128-dehumidifierjobmode)" ModuleClass.


**Table 5.6.111: Interpretation of hd:enumDehumidifierJobMode**

|Value |Interpretation |Note |
|-|-|-|
|1 |smart |This value indicates the smart mode that first gets the target humidity level from user input, next detects the correct relative humidity, then automatically change the de-humidity level to keep the target humidity level.  |
|2 |fast |This value indicates the fast mode that speeds the operating level up to quickly dehumidify when the humidity level is so high. It is a kind of turbo mode. |
|3 |silent |This value indicates the silent mode that can be used when a user sleeps. It reduces the noise. |
|4 |focus |This value indicates the focus mode that dehumidifies focusing on a particular part. |
|5 |clothes |This value indicates the clothes mode that dehumidifies adjusting the wind direction vertically. It is normally used to dehumidify clothes. |

NOTE: See clause [5.3.1.28 "dehumidifierJobMode"](#53128-dehumidifierjobmode). <mark>Negative values are reserved for vendor specific modes</mark>.




### 5.6.12 hd:enumDishWasherJobMode
Used for the "currentJobMode" and "jobModes" DataPoints of the "[dishWasherJobMode](#53129-dishwasherjobmode)" ModuleClass.


**Table 5.6.121: Interpretation of hd:enumDishWasherJobMode**

|Value |Interpretation |Note |
|-|-|-|
|1 |Normal wash | |
|2 |Intensive wash | |
|3 |Quick wash | |
|4 |Sensor wash | |
|5 |Eco wash | |
|6 |Quiet wash | |
|7 |Maintenance wash | |

NOTE: See clause [5.3.1.29 "dishWasherJobMode"](#53129-dishwasherjobmode). <mark>Negative values are reserved for vendor specific modes.</mark>




### 5.6.13 hd:enumDisplayOrder
Used for the "displayOrder" data point of the ["galleryMode"](#53137-gallerymode) ModuleClass.


**Table 5.6.13-1: Interpretation of hd:enumDisplayOrder**

|Value |Interpretation |Note |
|-|-|-|
|1 |fixed | |
|2 |sequence | |
|3 |loop | |
|4 |random | |




### 5.6.14 hd:enumDisplayOrientation
Used for the "displayOrientation" data point of the ["galleryMode"](#53137-gallerymode) ModuleClass.


**Table 5.6.14-1: Interpretation of hd:enumDisplayOrientation**

|Value |Interpretation |Note |
|-|-|-|
|1 |landscape | |
|2 |portrait | |




### 5.6.15 hd:enumDoorState
Used for the "doorState" DataPoint of ["doorStatus"](#53130-doorstatus) ModuleClass.

**Table 5.6.151: Interpretation of hd:enumDoorState**

|Value |Interpretation |Note |
|-|-|-|
|1 |closed |This indicates that door is closed.  |
|2 |open |This indicates that the door is open. |
|3 |opening |This indicates that the door is opening. |
|4 |closing |This indicates that the door is closing. |
|5 |stopped |This indicates that the door is in stationary state. |

NOTE: See clause [5.3.1.30 "doorStatus"](#53130-doorstatus).




### 5.6.16 hd:enumFoamStrength
Used for data points indicating the strength of a foam, for example, foaming milk from a coffee machine.


**Table 5.6.161: Interpretation of hd:enumFoamStrength**

|Value |Interpretation |Note |
|-|-|-|
|1 |zero | |
|2 |low | |
|3 |medium | |
|4 |high | |
|5 |maximum | |

NOTE: See clause [5.3.1.36 "foaming"](#53136-foaming).




### 5.6.17 hd:enumGeneralLevel
Used for the "soilLevel" data point of the "[clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption)" ModuleClass.


**Table 5.6.171: Interpretation of hd:enumGeneralLevel**

|Value |Interpretation |Note |
|-|-|-|
|1 |light | |
|2 |normal | |
|3 |heavy | |

NOTE: See clause [5.3.1.22 clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption).




### 5.6.18 hd:enumGeneralSpeed
Used for the "spinSpeed" data point of the "[clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption)" ModuleClass.


**Table 5.6.181: Interpretation of hd:enumGeneralSpeed**

|Value |Interpretation |Note |
|-|-|-|
|1 |low | |
|2 |medium | |
|3 |high | |
|4 |extraHigh | |

NOTE: See clause [5.3.1.22 clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption).




### 5.6.19 hd:enumGeneralTemperature
Used for the "washTemp" data point of the "[clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption)" ModuleClass.

**Table 5.6.191: Interpretation of hd:enumGeneralTemperature**

|Value |Interpretation |Note |
|-|-|-|
|1 |cold |The actual temperature is defined by the manufacturer. |
|2 |warm | |
|3 |hot | |

NOTE: See clause [5.3.1.22 clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption).




### 5.6.20 hd:enumGrainsLevel
Used for the "grainsRemaining" data point of the "[grinder](#53143-grinder)" ModuleClass.  This type specifies a level for supplies that have a grain-aspect, for example the level of remaining coffee beans in the grinder part of a coffee machine, or the desired level of coffee beans in this machine.

The values for the level of a liquid is covered by "[hd:enumLiquidLevel](#5624-hdenumliquidlevel)" (see clause [5.6.24](#5624-hdenumliquidlevel)).

**Table 5.6.201: Interpretation of hd:enumGrainsLevel**

|Value |Interpretation |Note |
|-|-|-|
|1 |zero | |
|2 |low | |
|3 |medium | |
|4 |high | |
|5 |maximum | |

  NOTE: See clause [5.3.1.43 "grinder"](#53143-grinder). 




### 5.6.21 hd:enumGrindCoarseness
Used for the coarseness data points of the "[grinder](#53143-grinder)" ModuleClass. This type specifies the level of coarseness of a solid after grinding, for example grinded coffee beans.


**Table 5.6.211: Interpretation of hd:enumGrindCoarseness**

|Value |Interpretation |Note |
|-|-|-|
|1 |ultrafine | |
|2 |fine | |
|3 |medium | |
|4 |coarse | |
|5 |coarsest | |

NOTE: See clause [5.3.1.43 "grinder"](#53143-grinder).




### 5.6.22 hd:enumHorizontalDirection
Used for the "horizontalDirection" and "supportedHorizontalDirection" of the "[airFlow](#5314-airflow)" ModuleClass, indicating horizontal directions.


**Table 5.6.221: Interpretation of hd:enumHorizontalDirection**

|Value |Interpretation |Note |
|-|-|-|
|1 |auto | |
|2 |center | |
|3 |left | |
|4 |right | |

  NOTE: See clause [5.3.1.4 airFlow](#5314-airflow). 




### 5.6.23 hd:enumJobState
Used for the "currentJobState" and "jobStates" data points of the "[printQueue](#53167-printqueue)" and "[runState](#53175-runstate)" ModuleClasses.


**Table 5.6.231: Interpretation of hd:enumJobState**

|Value |Interpretation |Note |
|-|-|-|
|1 |aborted | |
|2 |cancelled | |
|3 |completed | |
|4 |paused | |
|5 |pending | |
|6 |processing | |

NOTE: See clause [5.3.1.67 "printQueue"](#53167-printqueue) and [5.3.1.75 "runState"](#53175-runstate).




### 5.6.24 hd:enumLiquidLevel
Used for the "liquidLevel" and "liquidRemaining" data points in the  respective ["liquidLevel"](#53150-liquidlevel) and ["liquidRemaining"](#53151-liquidremaining) ModuleClasses.

**Table 5.6.241: Interpretation of hd:LiquidLevel**

|Value |Interpretation |Note |
|-|-|-|
|1 |zero | |
|2 |low | |
|3 |medium | |
|4 |high | |
|5 |maximum | |

NOTE: See clause  [5.3.1.50 "liquidLevel"](#53150-liquidlevel) and clause [5.3.1.51 "liquidRemaining"](#53151-liquidremaining).




### 5.6.25 hd:enumMachineState
Used for the "currentMachineState" and "machineStates" data points of the "[runState](#53175-runstate)" ModuleClass.

**Table 5.6.251: Interpretation of hd:enumMachineState**

|Value |Interpretation |Note |
|-|-|-|
|1 |idle |Machine is ready to operate |
|2 |preActive |Machine is operating its pre-functions (ex. pre-heat) |
|3 |active |Machine is operating its functions |
|4 |reserved |Reservation is made by user |
|5 |stopped |Operation is stopped/aborted by some other reasons |
|6 |error |Error has occurred  |
|7 |diagnostic |Machine reports diagnostic information to the server |
|8 |test |Particular functions run for test |
|9 |maintenance |Machine is needed to maintain |
|10 |clear |The result is not removed yet |
|11 |charging |Machine is being charged |

NOTE: See clause [5.3.1.75 "runState"](#53175-runstate).




### 5.6.26 hd:enumOzoneStatus
Used for the "ozoneStatus" property of the ["ozoneMeter"](#53160-ozonemeter) ModuleClass.

**Table 5.6.261: Interpretation of hd:enumOzoneStatus**

|Value |Interpretation |Note |
|-|-|-|
|1 |Good  |For example,  0 to 0.030 ppm. |
|2 |Normal |For example, 0.031 to 0.090 ppm. |
|3 |Bad |For example, 0.091 to 0.150ppm. |
|4 |Very bad |For example, 0.151 ppm or above. |

NOTE: See clause [5.3.1.60 "ozoneMeter"](#53160-ozonemeter).

The examples in the notes are references from the Korean Environmental Standard <a href="#_ref_i.7">[i.7]</a>.




### 5.6.27 hd:enumPlayerMode
Used for the "currentMode" and "supportedModes" data points in the "[playerControl](#53165-playercontrol)" ModuleClass.


**Table 5.6.271: Interpretation of hd:enumPlayerMode**

|Value |Interpretation |Note |
|-|-|-|
|1 |stop | |
|2 |play | |
|3 |pause | |
|4 |resume | |
|5 |record | |
|6 |rewind | |
|7 |fast-rewind | |
|8 |forward | |
|9 |fast-forward | |
|10 |searchPrevious | |
|11 |searchNext | |

NOTE: See clause [5.3.1.65 "playerControl"](#53165-playercontrol).




### 5.6.28 hd:enumRobotCleanerJobMode
Used for the "currentJobMode" and "jobModes" data points of the "[robotCleanerJobMode](#53174-robotcleanerjobmode)" ModuleClass.


**Table 5.6.281: Interpretation of hd:enumRobotCleanerJobMode**

|Value |Interpretation |Note |
|-|-|-|
|1 |zigzag |The machine moves forward by going at an angle first to one side then to the other. |
|2 |sectorBase |The machine first cleans a specific sector (for example, 1 x 1 m), then moves to another sector. |
|3 |spot |The machine cleans a targeted area of about specific spot. |

NOTE: See clause [5.3.1.74 "robotCleanerJobMode"](#53174-robotcleanerjobmode). <mark>Negative values are reserved for vendor specific modes.</mark>




### 5.6.29 hd:enumSecurityMode
Used for the "currentSecurityMode" and "securityModes" data points of the "[securityMode](#53176-securitymode)" ModuleClass. 


**Table 5.6.291: Interpretation of hd:enumSecurityMode**

|Value |Interpretation |Note |
|-|-|-|
|1 |active |Unit is active |
|2 |armedAway |Unit is armed for away |
|3 |armedInstant |Unit is armed instantly |
|4 |armedMaximum |Unit is armed at maximum level |
|5 |armedNightStay |Unit is armed in night stay |
|6 |armedStay |Unit is armed in stay mode |

NOTE: See clause [5.3.1.76 "securityMode"](#53176-securitymode).




### 5.6.30 hd:enumSpinLevelStrength
Used for the "spinLevelStrength" data points of the "[spinLevel](#53184-spinlevel)" ModuleClass, and used for the "spinSpeed"  data points of the "[blender](#531118-blender)" ModuleClass, indicating the strength of a spinLevel.


**Table 5.6.301: Interpretation of hd:enumSpinLevelStrength**

|Value |Interpretation |Note |
|-|-|-|
|1 |zero | |
|2 |sensitive | |
|3 |weak  | |
|4 |medium | |
|5 |strong | |
|6 |maximum | |

NOTE: See clause [5.3.1.84 "spinLevel"](#53184-spinlevel) and clause [5.3.1.118 "blender"](#531118-blender).




### 5.6.31 hd:enumSteamClosetJobMode
Used for "currentJobMode" and "jobModes" data points of the "[steamClosetJobMode](#53185-steamclosetjobmode)" ModuleClass.


**Table 5.6.311: Interpretation of hd:enumSteamClosetJobMode**

|Value |Interpretation |Note |
|-|-|-|
|1 |reduceOdor |Using pure water, the machine help remove the smells on clothes. |
|2 |steamWrinkle |The machine steams away wrinkles and also creates pant creases, as well as keep them crisp. |
|3 |helpClean |Using pure water without chemical additives, the machine sanitizes fabrics and items that are difficult to wash. |
|4 |gentleDry |The machine dries fragile garments without worrying about shrinkage or damage. |

NOTE:	See clause [5.3.1.85 "steamClosetJobMode"](#53185-steamclosetjobmode). <mark>Negative values are reserved for vendor specific modes</mark>.




### 5.6.32 hd:enumSupportedMediaSources
Used for the "supportedMediaSources" data point of the "[mediaSelect](#53153-mediaselect)" ModuleClass.


**Table 5.6.321: Interpretation of hd:enumSupportedMediaSources**

|Value |Interpretation |Note |
|-|-|-|
|1 |tuner | |
|2 |component | |
|3 |composite | |
|4 |svideo | |
|5 |rgb | |
|6 |dvi | |
|7 |hdmi | |
|8 |displayPort | |
|9 |scart | |
|10 |externalStorage | |
|11 |network | |

NOTE:	See clause [5.3.1.53 "mediaSelect"](#53153-mediaselect). <mark>Negative values are reserved for vendor specific sources</mark>.




### 5.6.33 hd:enumTasteStrength
Used for the "strength" data point of the "[brewing](#53116-brewing)" ModuleClass, indicating strength of a drink taste, for example coffee strength.


**Table 5.6.331: Interpretation of hd:enumTasteStrength**

|Value |Interpretation |Note |
|-|-|-|
|1 |zero | |
|2 |sensitive | |
|3 |medium | |
|4 |strong | |
|5 |maximum | |

NOTE:	See clause [5.3.1.16 "brewing"](#53116-brewing).




### 5.6.34 hd:enumTone
Used for the "tone" data point of the "[alarmSpeaker](#5317-alarmspeaker)" ModuleClass.


**Table 5.6.341: Interpretation of hd:enumTone**

|Value |Interpretation |Note |
|-|-|-|
|1 |fire | |
|2 |theft | |
|3 |emergency | |
|4 |doorbell | |
|5 |deviceFail | |

NOTE:	See clause [5.3.1.7 alarmSpeaker](#5317-alarmspeaker).




### 5.6.35 hd:enumUvStatus
Used for the "uvStatus" data point of the "[uvSensor](#53192-uvsensor)" ModuleClass.

**Table 5.6.351: Interpretation of hd:enumUvStatus**

|Value |Interpretation |Note |
|-|-|-|
|1 |Good | |
|2 |Normal | |
|3 |Bad | |
|4 |Very Bad | |
|5 |Danger | |

NOTE: See clause [5.3.1.92 "uvSensor"](#53192-uvsensor).




### 5.6.36 hd:enumVerticalDirection
Used for the "verticalDirection" and "supportedVerticalDirection" data points of the "[airFlow](#5314-airflow)" ModuleClass, indicating vertical direction.

**Table 5.6.361: Interpretation of hd:enumVerticalDirection**

|Value |Interpretation |Note |
|-|-|-|
|1 |auto | |
|2 |center | |
|3 |up | |
|4 |down | |

NOTE: See clause [5.3.1.4 airFlow](#5314-airflow).




### 5.6.37 hd:enumWaterFlowStrength
Used for the "waterLevelStrength" data point of the "[waterFlow](#53193-waterflow)" ModuleClass,  indicating the strength of a water flow.


**Table 5.6.371: Interpretation of hd:enumWaterFlowStrength**

|Value |Interpretation |Note |
|-|-|-|
|1 |zero | |
|2 |sensitive | |
|3 |weak  | |
|4 |medium | |
|5 |strong | |
|6 |maximum | |

NOTE: See clause [5.3.1.93 "waterFlow"](#53193-waterflow).




### 5.6.38 hd:enumBaliseSystemIndicator
Used for the "[baliseTransmissionModule](#5381-balisetransmissionmodule)" ModuleClass.

**Table 5.6.381: Interpretation of hd:enumBaliseSystemIndicator**

|Value |Interpretation |Note |
|-|-|-|
|1 |ATC |Korea <a href="#_ref_i.9">[i.9]</a> |
|2 |ATP |Korea <a href="#_ref_i.9">[i.9]</a> |
|3 |CTCS-3 |China <a href="#_ref_i.10">[i.10]</a> |

NOTE: The Note shows countries which are using a balise system which is indicated on left-hand side.




### 5.6.39 hd:enumWeightUnit
Used for the "unit" data point related to all ModuleClass which contains weight, indicating the units of the weight.


**Table 5.6.391: Interpretation of hd:enumWeight**

|Value |Interpretation |Note |
|-|-|-|
|1 |kg |kilogram |
|2 |lb |pound |
|3 |oz |ounce |

  NOTE: See clause [5.3.1.99 "weight"](#53199-weight). 




### 5.6.40 hd:enumTemperatureUnit
Used for the "unit" data point related to "[temperature](#53187-temperature)" and "[temperatureAlarm](#53188-temperaturealarm)" ModuleClasses which contains temperature,  indicating the units of the temperature.


**Table 5.6.401: Interpretation of hd:enumTemperatureUnit**

|Value |Interpretation |Note |
|-|-|-|
|1 |C |Celsius |
|2 |F |Fahrenheit |
|3 |K |Kelvin |

NOTE: See clause [5.3.1.87 "temperature"](#53187-temperature) and clause [5.3.1.88 "temperatureAlarm"](#53188-temperaturealarm).




### 5.6.41 hd:enumWaterFilterType
Used for the "filterType" data point of the "[waterFilterType](#531105-waterfiltertype)" ModuleClass.


**Table 5.6.411: Interpretation of hd:enumWaterFilterType**

|Value |Interpretation |Note |
|-|-|-|
|1 |RO |This value indicates the Reverse Osmosis type water filter. |
|2 |UV |This value indicates the Ultraviolet type water filter. |
|3 |UF |This value indicates the UltraFiltration type water filter. |
|4 |AC |This value indicates the Activate Carbon type water filter. |
|5 |SF |This value indicates the Sediment type water filter. |

NOTE: See clause [5.3.1.105 "waterFilterType"](#531105-waterfiltertype).




### 5.6.42 hd:enumDataModelType
Used for the "dataModelType" DataPoint of the "[dmDataModelIO](#584-dmdatamodelio)" ModuleClass.


**Table 5.6.42-1 Interpretation of hd:enumDataModelType**

|Value |Interpretation |Note |
|-|-|-|
|1 |unknown |To be used for a proprietary/unknown protocol |
|2 |OMA_DM_1.3 | |
|3 |OMA_DM_2.0 | |
|4 |OMA_LwM2M | |
|5 |BBF_TR-181_CWMP |Version of TR-181 <a href="#_ref_i.12">[i.12]</a> for TR-069 <a href="#_ref_i.11">[i.11]</a>. |
|6 |BBF_TR-181_USP |Version of TR-181 <a href="#_ref_i.12">[i.12]</a> for USP |
|7 |oneM2M |For native oneM2M devices |




### 5.6.43 hd:enumDmAgentState
Used for the "state" DataPoint of the "[dmAgent](#582-dmagent)" ModuleClass.

**Table 5.6.43-1 Interpretation of hd:enumDmAgentState**

|Value |Interpretation |Note |
|-|-|-|
|1 |ready |The device is ready for DM operations |
|2 |error |The device is known to be in an error state |
|3 |sleeping |The device is known to be in sleeping mode |
|4 |unreachable |The device is not accessible  |




### 5.6.44 hd:enumFirmwareState
Used for the "state" DataPoint of the "[dmFirmware](#585-dmfirmware)" ModuleClass.

**Table 5.6.44-1 Interpretation of hd:enumFirmwareState**

|Value |Interpretation |Note |
|-|-|-|
|1 |Active |The firmware is currently active |
|2 |Ready |The firmware is ready for installation/activation |
|3 |Downloading |The firmware is being downloaded |
|4 |Installing |The firmware in being installed |
|5 |Failure |The firmware installation/download has failed |
|6 |Archival |The firmware is an archival record that cannot be reactivated. |




### 5.6.45 hd:enumPowerState
Used for the "powerStatus" DataPoint of the "[dmAgent](#582-dmagent)" ModuleClass.

**Table 5.6.45-1 Interpretation of hd:enumPowerState**

|Value |Interpretation |Note |
|-|-|-|
|1 |normal | |
|2 |charging | |
|3 |chargingComplete | |
|4 |degraded | |
|5 |low | |
|6 |critical | |
|7 |notInstalled | |




### 5.6.46 hd:enumRebootType
Used for the "rebootType" argument of the "[reboot](#582-dmagent)" action of the "[dmAgent](#582-dmagent)" ModuleClass.


**Table 5.6.46-1 Interpretation of hd:enumRebootType**

|Value |Interpretation |Note |
|-|-|-|
|1 |reboot | |
|2 |rebootWhenReady |Reboot needed when the device is available for it |
|3 |factoryReset |"hard" reset |
|4 |softReset | |




### 5.6.47 hd:enumSoftwareState
Used for the "state" data point of the "[dmSoftware](#586-dmsoftware)" ModuleClass.


**Table 5.6.47-1 Interpretation of hd:enumSoftwareState**

|Value |Interpretation |Note |
|-|-|-|
|1 |Inactive | |
|2 |Activating | |
|3 |Active | |
|4 |Deactivating | |




### 5.6.48 hd:enumPackageState
Used for the "state" data point of the "[dmPackage](#588-dmpackage)" ModuleClass.

**Table 5.6.48-1 Interpretation of hd:enumPackageState**

|Value |Interpretation |Note |
|-|-|-|
|1 |NotInstalled | |
|2 |Downloaded | |
|3 |Installed | |
|4 |Downloading | |
|5 |Installing | |
|6 |Uninstalling | |



### 5.6.49 hd:enumPackageType

Used for the "type" data point of the "[dmPackage](#588-dmpackage)" ModuleClass.

**Table 5.6.49-1 Interpretation of hd:enumPackageType**

|Value |Interpretation |Note |
|-|-|-|
|1 |SoftwareModule |Software module image (executable) |
|2 |SoftwareLibrary |Software library file |
|3 |WebContent |Web document |
|4 |ConfigFile |Configuration file |
|5 |VendorFile |Vendor-specific document |
|6 |Undefined | |



### 5.6.50 hd:enumBatteryMaterial

Used for the "batteryMaterial" DataPoint of the "[battery](#53110-battery)" ModuleClass.


**Table 5.6.50-1 Interpretation of hd:enumBatteryMaterial**

|Value |Interpretation |Note |
|-|-|-|
|1 |Alkaline_battery |Primary cells or non-rechargeable |
|2 |Lithium_battery |Primary cells or non-rechargeable |
|3 |Magnesium_battery |Primary cells or non-rechargeable |
|4 |Mercury_battery |Primary cells or non-rechargeable |
|5 |Nickel_oxyhydroxide_battery |Primary cells or non-rechargeable |
|6 |Silver_oxide_battery |Primary cells or non-rechargeable |
|7 |Zinc_air |Primary cells or non-rechargeable |
|8 |Lead_acid_battery |Secondary cells or rechargeable |
|9 |Lithium_ion_battery |Li-ion, Secondary cells or rechargeable |
|10 |Lithium_ion_polymer_battery |LiPo, Secondary cells or rechargeable |
|11 |Nickel_cadmium_battery |Ni-Cd , Secondary cells or rechargeable |
|12 |Nickel_iron_battery |Secondary cells or rechargeable |
|13 |Nickel_metal_hydride_battery |NiMH, Secondary cells or rechargeable |
|14 |Nickel_zinc_battery |Secondary cells or rechargeable |
|15 |Rechargeable_alkaline_battery |Secondary cells or rechargeable |



### 5.6.51 hd:enumBatteryShape

Used for the "batteryShape" DataPoint of the "[battery](#53110-battery)" ModuleClass.

**Table 5.6.51-1 Interpretation of hd:enumBatteryShape**

|Value |Interpretation |Note |
|-|-|-|
|1 |AA |Cylinder-type AA battery |
|2 |AAA |Cylinder-type AAA battery |
|3 |AAAA |Cylinder-type AAAA battery |
|4 |C |Cylinder-type C battery |
|5 |D |Cylinder-type D battery |
|6 |N |Cylinder-type N battery |
|e |A23 |Cylinder-type A23 battery |
|8 |Coin_cell_4 |Coin-cell type 4,8 mm diameter battery |
|9 |Coin_cell_5 |Coin-cell type 5,8 mm diameter battery |
|10 |Coin_cell_6 |Coin-cell type 6,8 mm diameter battery |
|11 |Coin_cell_7 |Coin-cell type 7,9 mm diameter battery |
|12 |Coin_cell_9 |Coin-cell type 9,5 mm diameter battery |
|13 |Coin_cell_10 |Coin-cell type 10,0 mm diameter battery |
|14 |Coin_cell_11 |Coin-cell type 11,6 mm diameter battery |
|15 |Coin_cell_12 |Coin-cell type 12,5 mm diameter battery |
|16 |Coin_cell_16 |Coin-cell type 16,0 mm diameter battery |
|17 |Coin_cell_20 |Coin-cell type 20,0 mm diameter battery |
|18 |Coin_cell_23 |Coin-cell type 23,0 mm diameter battery |
|19 |Coin_cell_24 |Coin-cell type 24,5 mm diameter battery |
|20 |Coin_cell_44 |Coin-cell type 5,4 mm diameter battery |
|21 |Box_9V |Box type 9V battery |
|22 |Silver_Flat_Pack |Flat Box Pack type |
|23 |Car_battery |Box type 6-cell lead car battery |
|24 |Custom_made |Custom-made by manufacturer |




### 5.6.52 hd:enum3DDisplayType
Used for the "threeDDisplayType" DataPoint of the "[threeDDisplay](#531116-threeddisplay)" ModuleClass.

**Table 5.6.52-1 Interpretation of hd:enum3DDisplayType**

|Value |Interpretation |Note |
|-|-|-|
|1 |Stereoscopic_Display |Use "binocular disparity" method to implement 3D display. The technology uses 3D glasses to make the binocular disparity. |
|2 |Light_Field_Display |The technology build barriers or lenticular lens on a RGB panel to make binocular disparity effect. It does not need 3D glasses. |
|3 |Volumetric_Display |The technology uses the interference ray as the light source. The 3D image is formed as a set of pixels that the pixels are generated as a bright point in the position of constructive interference is made. This technology does not need 3D glasses. |
|4 |ETC | |




### 5.6.53 hd:enum3DScannerType
Used for the "threeDScannerType" DataPoint of the "[threeDScanner](#531117-threedscanner)" ModuleClass.

**Table 5.6.53-1 Interpretation of hd:enum3DScannerType**

|Value |Interpretation |Note |
|-|-|-|
|1 |TOF |Use "Time Of Flight" method to scan 3D object. The technology calculates time gap between shooting and return of the reflected laser light. |
|2 |Phase_Shift |The technology uses "Phase shift waveform analysis". It analyses the distance gap between two reflected laser beam phase which are shot from the scanner. |
|3 |Waveform |The technology uses "Triangulation method". Based on the triangulation method, it uses point beam or TOF method. |
|4 |MPT |The technology uses "Miniaturized Projection Technique" to scan. It projects specific pattern of White light, indicates the size and depth by analysis of the reflected pattern on the object. |
|5 |ETC |The other technology is used to scan an object. |




### 5.6.54 hd:enumShoesWasherJobMode
Used for the "currentJobMode" and "jobModes" DataPoints of the "[shoesWasherJobMode](#531119-shoeswasherjobmode)" ModuleClass.

**Table 5.6.54-1: Interpretation of hd:enumShoesWasherJobMode**

|Value |Interpretation |Note |
|-|-|-|
|1 |normalWash | |
|2 |intensiveWash | |
|3 |quickWash | |
|4 |maintenanceWash | |
|5 |antibacterialWash | |

NOTE:	See clause [5.3.1.119 "shoesWasherJobMode"](#531119-shoeswasherjobmode). <mark>Negative values are reserved for vendor specific modes</mark>.




### 5.6.55 hd:enumAlertStatus
The enumeration type, hd:enumAlertStatus, enables things to identify the alert status that describes whether a received public warning message as oneM2M based information is an actual alert issued by authorities or an alert for testing the public warning service over oneM2M system.

**Table 5.6.55-1: Interpretation of hd:enumAlertStatus**

|Value |Interpretation |Note |
|-|-|-|
|1 |Actual |Actionable by all targeted recipients |
|2 |Exercise |Actionable only by designated exercise participants  |
|3 |System |For messages that support alert network internal functions |
|4 |Test |Technical testing only, all recipients disregard |
|5 |Draft |A preliminary template or draft, not actionable in its current form |

NOTE:  Listed names for this enumeration are specified on the CAP 1.2 specification <a href="#_ref_22">[22]</a>.




### 5.6.56 hd:enumAlertMsgType
The enumeration type, hd:enumAlertMsgType, describes the message type of oneM2M based information transformed from CAP based information issued by authorities.


**Table 5.6.56-1: Interpretation of hd:enumAlertMsgType**

|Value |Interpretation |Note |
|-|-|-|
|1 |Alert |Initial information requiring attention by targeted recipients |
|2 |Update |Updates and supersedes the earlier message(s) |
|3 |Cancel |Cancels the earlier message(s) |

NOTE:  Listed names for this enumeration are specified on the CAP 1.2 specification <a href="#_ref_22">[22]</a>.




### 5.6.57 hd:enumUrgency
The enumeration type, hd:enumUrgency, describes the urgency of the event defined in oneM2M based information transformed from CAP based information issued by authorities.


**Table 5.6.57-1: Interpretation of hd:enumUrgency**

|Value |Interpretation |Note |
|-|-|-|
|1 |Immediate |Responsive action should be taken immediately |
|2 |Expected |Responsive action should be taken soon (within next hour) |
|3 |Future |Responsive action should be taken in the near future |
|4 |Past |Responsive action is no longer required |
|5 |Unknown |Urgency not known |

NOTE:  Listed names for this enumeration are specified on the CAP 1.2 specification <a href="#_ref_22">[22]</a>.




### 5.6.58 hd:enumSeverity
The enumeration type, hd:enumSeverity, describes the severity of the event defined in oneM2M based information transformed from CAP based information issued by authorities.


**Table 5.6.58-1: Interpretation of hd:enumSeverity**

|Value |Interpretation |Note |
|-|-|-|
|1 |Extreme |Extraordinary threat to life or property |
|2 |Severe |Significant threat to life or property |
|3 |Moderate |Possible threat to life or property |
|4 |Minor |Minimal to no known threat to life or property |
|5 |Unknown |Severity unknown |

NOTE:  Listed names for this enumeration are specified on the CAP 1.2 specification <a href="#_ref_22">[22]</a>.




### 5.6.59 hd:enumCertainty
The enumeration type, hd:enumCertainty, describes the certainty of the event defined in oneM2M based information transformed from CAP based information issued by authorities.


**Table 5.6.59-1: Interpretation of hd:enumCertainty**

|Value |Interpretation |Note |
|-|-|-|
|1 |Observed |Determined to have occurred or to be ongoing |
|2 |Likely |Likely (p > ~50 %) |
|3 |Possible |Possible but not likely (p <= ~50 %) |
|4 |Unlikely |Not expected to occur (p ~ 0) |
|5 |Unknown |Certainty unknown |

NOTE: Listed names for this enumeration are specified on the CAP 1.2 specification <a href="#_ref_22">[22]</a>.




## 5.7 Universal and Common Properties for Device models
Universal and common properties are defined either 


- As specialized custom attributes of a [dmDeviceInfo](#583-dmdeviceinfo) &lt;flexContainer> specialization, defined in [clause 5.8.3](#583-dmdeviceinfo), when the &lt;node> resource targeted by the nodeLink attribute of the Device model contains a [[flexNode](#581-flexnode)] child,
- Or as specialized object attributes of the [deviceInfo] &lt;mgmtObj> specialization, defined in Annex D.8 of TS-0001<a href="#_ref_3">[3]</a>, child of this &lt;node> resource, otherwise.

Some properties are mandatory for all device models and called "Universal Properties", since they are universally seen in typical device types and carry necessary information to identify each device instance. Others are optional for all device models and called "Common Properties", since they are commonly used in many device types but not always. 

Universal and common properties are applicable to all device models. They are not repeated in the property table of each device model in [clause 5.5](#55-device-models), where only device specific properties shall be specified. 

NOTE: The instantiated values of the universal properties might be empty in case of exceptional scenarios, e.g. interworking with non-oneM2M device models.

## 5.8 Device Management

### 5.8.0 Introduction

The entities that are specified in this clause allow performing classical Device Management (DM) functions: rebooting a device, upgrading it, reading / setting its configuration, monitoring its logs, checking its memory or battery status, managing its firmware or its software modules, etc. They belong to the "management" domain.

In the case of a NoDN, it is the IPE in charge of exposing the device to oneM2M that creates / implements these modules. It may rely on external Device Management techniques like e.g. LwM2M (from OMA) or USP (from BBF), or any other technique, proprietary or standardized, that allows performing at least some DM functions, for instance a reboot.

The architecture of IPE-based Device Management is presented in oneM2M TS-0001 <a href="#_ref_3">[3]</a> clause 6.2.4.1, and the details of CRUD operations on the resources defined here are defined in oneM2M TS-0033 <a href="#_ref_21">[21]</a> clause 8. A developer's guide on Device Management can be found in oneM2M TR-0035 <a href="#_ref_i.13">[i.13]</a>.

<mark>Editor note: Some attributes are missing from the short name tables in 6.3</mark>




### 5.8.1 flexNode
This flexContainer specialization is the root for SDT-based Device Management modules.

The containerDefinition attribute of this specialization shall be "org.onem2m.management.device.flexNode".

This resource is a &lt;flexContainer> child of the &lt;node> resource targeted by the nodeLink attribute of &lt;flexContainer> SDT devices (see in clause [6.2.2](#622-resource-mapping-for-device-model) the rule 1.7).

**Table 5.8.1-1: Child resources of [flexNode] resource**

|Child Resources of [flexNode] |Child Resource Type |Multiplicity |Description |
|-|-|-|-|
|dmAreaNwkInfo_&lt;i> |[[dmAreaNwkInfo]](#589-dmareanwkinfo)] |0..n |See clause [5.8.9](#589-dmareanwkinfo). |
|dmAgent |[[dmAgent]](#582-dmagent)	 |0..1 |See clause [5.8.2](#582-dmagent). |
|dmDeviceInfo	 |[[dmDeviceInfo]](#583-dmdeviceinfo) |1 |See clause [5.8.3](#583-dmdeviceinfo). |
|dmDataModelIO_&lt;i> |[[dmDataModelIO]](#584-dmdatamodelio) |0..N |See clause [5.8.4](#584-dmdatamodelio). |
|dmFirmware_&lt;i> |[[dmFirmware]](#585-dmfirmware) |1..N |See clause [5.8.5](#585-dmfirmware). |
|dmSoftware_&lt;i> |[[dmSoftware]](#586-dmsoftware) |0..N |See clause [5.8.6](#586-dmsoftware). |
|dmEventLog_&lt;i> |[[dmEventLog]](#587-dmeventlog) |0..N |See clause [5.8.7](#587-dmeventlog). |
|dmPackage_&lt;i> |[[dmPackage]](#588-dmpackage)] |0..N |See clause [5.8.8](#588-dmpackage), |
|battery_&lt;i> |[[battery]](#5310-battery) |0..N |See clause [5.3.1.10](#53110-battery). |
|dmCapability_&lt;i>	 |[[dmCapability]](#5811-dmcapability)] |0..N |See clause [5.8.11](#5811-dmcapability). |
|dmStorage_&lt;i> |[[dmStorage]](#5812-dmstorage)] |0..N |See clause [5.8.12](#5812-dmstorage). |

NOTE 1: The notation '&lt;i>' for child resources indicates that the resource name is the name of the child ModuleClass or SubDevice flexContainer, appended with an underscore '_' and an incrementing index so that it is unique in the [flexNode] children (e.g. "dmFirmware_0", "dmFirmware_1", etc.). The index shall not have leading 0's.

NOTE 2: The current list of modules for Device Management is not fixed and can evolve with new optional features.




### 5.8.2 dmAgent

This ModuleClass is the entry point module of *[flexNode]*; it provides capabilities to control and monitor the Device Management of the device.

**Table 5.8.2-1 Actions of dmAgent ModuleClass**

|Return Type |Name |Arguments |Optional |Description |
|-|-|-|-|-|
|none	 |reboot |rebootType: [hd:enumRebootType](#5646-hdenumreboottype) |false |Execute a reboot or a factory reset |
|M2MID |deployPackage |name: xs:string<br />version: xs:string<br />url: xs:url |true |Create a [dmPackage](#588-dmpackage).<br />Return the ID of the created package. |

The *deployPackage* action allows creating a new [[dmPackage](#588-dmpackage)] module class (see clause [5.8.8](#588-dmpackage)), child of this dmAgent's parent *flexNode*. The returned value is the ID of this created &lt;flexContainer>. The created [dmPackage](#588-dmpackage) is in *NotInstalled* state.
The DataPoints of dmAgent Module Class are as follows: 

- 'state' represents the state of the agent for DM purposes (ready, sleeping, etc.).
- some optional device properties which can be used for Device Management purpose. The dmAgent can be seen as a 'dashboard' that gathers common information such as battery level, memory or CPU usage, etc.

**Table 5.8.2-2 DataPoints of dmAgent ModuleClass**

|Name |Type |R/W |Optional |Unit |Description |
|-|-|-|-|-|-|
|state |[hd:enumDmAgentState](#5643-hdenumdmagentstate) |R |false | |The current state of the agent (ready, error, etc.) |
|storageAvailable |xs:integer |R |true |KB |The size of available storage memory. |
|storageTotal |xs:integer |R |true |KB |The size of total storage memory. |
|ramAvailable |xs:integer |R |true |KB |The size of available RAM memory. |
|ramTotal |xs:integer |R |true |KB |Total size of the RAM memory. |
|powerStatus |[hd:enumPowerState](#5645-hdenumpowerstate) |R |true | |The status of the electrical power. |
|cpuUsage |xs:integer |R |true |pct |Current CPU usage in percent. |
|systemTime |m2m:timestamp |RW |true | |Reference time for the device.  |



### 5.8.3 dmDeviceInfo
This ModuleClass is used to share static information regarding the device.

**Table 5.8.3-1 DataPoints of dmDeviceInfo ModuleClass**

|Name |Type |R/W |Optional |Unit |Description |
|-|-|-|-|-|-|
|serialNumber |xs:string |R |	true | |Unique device label assigned by the manufacturer. <br />The value of the data point typically exposes the device's serial number that is specific to a manufacturer.  |
|manufacturer |xs:string |R |true | |The name/identifier of the device manufacturer.  |
|manufacturerDetailsLink |xs:anyURI |RW |true | |URL to manufacturer's website.  |
|manufacturingDate |m2m:timestamp |R |true | |Manufacturing date of device.  |
|model |xs:string |R |true | |The name/identifier of the device model assigned by the manufacturer.  |
|subModel |xs:string |R |true | |Device sub-model name.  |
|hwVersion |xs:string |R |true | |The hardware version / revision of the device.  |
|osVersion	 |xs:string |R |true | |Version of the operating system (defined by manufacturer).  |
|country |m2m:countryCode |R |true | |Country code of the device. It could be manufacturing country, deployment country or procurement country.  |
|supportURL |xs:anyURI |RW |true | |URL that points to product support information of the device.  |
|presentationURL |xs:anyURI |RW |true | |To quote UpnP: "the control point can retrieve a page from this URL, load the page into a web browser, and depending on the capabilities of the page, allow a user to control the device and/or view device status. The degree to which each of these can be accomplished depends on the specific capabilities of the presentation page and device".  |
|friendlyName |xs:string |RW |true | |The device friendly name.  |
|description |xs:string |RW |true | |A human readable description of the device (e.g. Alice's cell phone, kitchen's fridge, etc.) |

NOTE:  Although all data points are optional, depending on the underlying DM technology, some data points should be filled, for instance *serialNumber*, *manufacturer* and *model* when this information is available.



### 5.8.4 dmDataModelIO

This ModuleClass provides capabilities to handle the device's Data Model for cases where the underlying Device Management technology supports APIs that are not directly reflected in the *flexNode* modules.

**Table 5.8.4-1 Actions of dmDataModelIO ModuleClass**

|Return Type |Name |Arguments |Optional |Description |
|-|-|-|-|-|
|xs:string |readIO |address: xs:string |true |Read the current values of parameters. Argument: the list of the parameter names. <br />Returns a JSON serialization of the parameters (see Rules 3-2 and 3-6 in clause [6.2.4](#624-resource-mapping-for-action)). |
|xs:string |writeIO |address: xs:string<br />payload: xs:string |true |Update the current values of parameters. Arguments: <br />'address': the list of the parameter names, <br />'payload': the list of the parameter values. <br />Returns the list of the modified parameter names. |



**Table 5.8.4-2 DataPoints of dmDataModelIO ModuleClass**

|Name |Type |R/W |Optional |Unit |Description |
|-|-|-|-|-|-|
|dataModelType |[hd:enumDataModelType](#5642-hdenumdatamodeltype) |R |false | |The type of the data model (OMA DM, OMA LwM2M, BBF TR-181, etc.). |



The *readIO* and *writeIO* actions are defined for handling parameters of the underlying Device Management protocol using the APIs defined by those technologies. The values used in the *address* argument are dependent on the value of the *dataModelType* data point of the [dmAgent](#582-dmagent) ModuleClass.

Example of *address* values could be ```'Device.WiFi.SSID.1' if dataModelType=6``` (BBF TR-181 USP) or ```'/9/1/1' if dataModelType=4``` (OMA LwM2M).

These *address* and *payload* argument can contain several values separated by a comma ','. The *payload* argument's value types are the valid JSON primitive types (string, number, boolean, null).

EXAMPLES:


```
readIO(address="Device.WiFi.SSID.SSID")
    -> {"Device.WiFi.SSID.SSID": "SSIDName"}

readIO(address="/3/0/1,/3/0/2")
    -> {"/3/0/1":"MyCompany","/3/0/2":"SN376575A86"}

writeIO(address="Device.DeviceInfo.FriendlyName,Device.WiFi.SSID.SSID", payload="my device,my ssid"}
    -> {"Device.DeviceInfo.FriendlyName,Device.WiFi.SSID.SSID"}

writeIO(address="/3/0/15", payload="[Europe/Paris](Europe/Paris)")
    -> {"/3/0/15"}
```

NOTE: Some data points of the [dmAgent](#582-dmagent) and [dmDeviceInfo](#583-dmdeviceinfo) ModuleClasses correspond to fixed parameters in OMA & BBF data models. The corresponding concepts in OMA DM / LwM2M data models (resp. BBF TR-181 <a href="#_ref_i.12">[i.12]</a>) are specified in oneM2M TS-0005 (resp. TS-0006 <a href="#_ref_i.1">[i.15]</a>). For instance the data point *memAvailable* corresponds to `'Device.DeviceInfo.MemoryStatus.Free'` in BBF TR-181 <a href="#_ref_i.12">[i.12]</a> (see oneM2M TS-0006 <a href="#_ref_i.15">[i.15]</a> clause 7.3) and to `'/3/0/10'` in LwM2M (oneM2M TS-0005 clause 6.3.4).



### 5.8.5 dmFirmware

This ModuleClass provides Device Management capabilities to control and monitor the firmware of a device.

The device can contain multiple components (a graphic card for instance) that can have individual firmwares, and they need to be managed separately. The *[flexNode]* allows one *[dmFirmware]* module per component plus one 'major' *[dmFirmware]* for the device itself. 

Individual firmwares are managed using the [dmFirmware] actions presented in Table 5.8.-1.

**Table 5.8.5-1 Actions of dmFirmware ModuleClass**

|Return Type |Name |Argument |Optional |Description |
|-|-|-|-|-|
|xs:string |updateFirmware |url: xs:url<br />version:  xs:string |true |Downloads a new firmware to the device / sub-component. In case of devices that do support toggling between multiple pre-installed firmware versions it also starts the firmware flashing/installation process.<br />The updateFirmware action as it results returns an AE/IPE message indicating if the action was successful or not. |
|xs:string |toggle |none |true |Toggles between the firmware versions installed on a device/sub-component. In case of devices that do not support such toggling, it triggers the firmware flashing/installation process.<br />The toggle action as it results returns an AE/IPE message indicating if the action was successful or not. |



The abstraction model used for [dmFirmware] manages the firmware through two images: a *primary* firmware image and a *secondary* one. Despite the naming both images are equivalent and a secondary image can be actively used by a device just like the primary one.

Using an abstraction model based on two firmware images it is possible to effectively manage firmware on devices with different firmware capabilities. The state machine for firmware management using two images is shown in Figure 5.8.5-1 for devices that do support toggling between multiple pre-installed firmware versions and in Figure 5.8.5-2 for devices that can have only one firmware version installed. 

**Table 5.8.5-2 DataPoints of dmFirmware ModuleClass**


|Name |Type |R/W |Optional |Unit |Description |
|-|-|-|-|-|-|
|multiFirmware |xs:boolean |R |false | |Indicates if the device/sub-component supports toggling between  multiple pre-installed firmware versions. |
|primaryState |[hd:enumFirmwareState](#5644-hdenumfirmwarestate) |R |false | |The current state of the primary firmware image (active, downloading, etc.). |
|primaryName	 |xs:string |R |false | |The name of the primary firmware image. |
|primaryVersion	 |xs:string |R |false | |The version of the primary firmware image. |
|primaryUrl |xs:url |R |true | |The URL from which the primary firmware image was downloaded. |
|secondaryState |[hd:enumFirmwareState](#5644-hdenumfirmwarestate) |R |true | |The current state of the secondary firmware image (active, downloading, etc.). Mandatory when *updateFirmware* is available. |
|secondaryName	 |xs:string |R |true | |The name of the secondary firmware image. |
|secondaryVersion	 |xs:string |R |true | |The version of the secondary firmware image. |
|secondaryUrl |xs:url |R |true | |The URL from which the secondary firmware image was downloaded. |
|component |xs:string |R |true | |Allows to identify the sub-component that uses this firmware. <br />This data point is mandatory if this is a sub-component firmware. |



NOTE 1: Both primary and secondary firmware image related dataPoints are mandatory when *updateFirmware* is available, however depending on the device capabilities one of the two state machines - the one presented in Figure 5.8.5-1 or the one shown in Figure 5.8.5-2 should be used.



![Lifecycle of a dmFirmware](media/lifecycle_of_a_dmfirmware_1.svg)

**Figure 5.8.5-1: Lifecycle of a dmFirmware for devices that support toggling between pre-installed firmware images**


For devices that support toggling between multiple pre-installed firmware images the following rules apply:


- There is always one firmware image that is in "Active" state.
- Toggling between firmware images is only possible if one image is in "Ready" state and the other image is in "Active" state. 
- *updateFirmware* action is always performed on the  image that  is in "Ready" or "Failure" state.

NOTE 2: It is the AE/IPE responsibility to provide the appropriate action result pointing if the action was triggered on the device or not (e.g. if the current firmware state did not allow it).



![Lifecycle of a dmFirmware](media/lifecycle_of_a_dmfirmware_2.svg)

**Figure 5.8.5-2: Lifecycle of a dmFirmware for devices that can have only one firmware version installed**


In case of a device that can have only one firmware version installed the additional firmware image is used differently. First of all it is treated as a temporary storage for the *updateFirmware* action that triggers the download process. When the download process is finished the status of the firmware image is changed to "Ready". It is important to note that in this case the installation/flashing process is started after the *toggle* action is issued, making it a "long toggle". At the very same moment the toggle is issued, the previously active firmware image is moved to "Archival" state, making it a historical record that cannot be restored. The reason why it cannot be restored is trivial - it was just overwritten by the flashing process.

For devices that can have only one firmware version installed the following rules apply:

- There is always no more than one firmware image that is in "Active" or "Installing" state.
- Toggling between firmware images is only possible if one image is in "Ready" state and the other image is in "Active" state. 
- The *toggle* action moves the image that was previously in "Active" state to the "Archival" state.
- The *toggle* action moves the image that was previously in "Ready" state to the "Installing" state.
- *updateFirmware* action is always performed on the  image that  is in "Archival" or "Failure" state.

If one image is in "Archival" state and the other is in "Failure" state the *updateFirmware* action is always performed on the image that is in "Archival" state.

NOTE 3: It is the AE/IPE responsibility to provide the appropriate action result pointing if the action was triggered on the device or not (e.g. if the current firmware state did not allow it).

### 5.8.6 dmSoftware

This ModuleClass provides DM capabilities to control and monitor software modules of the device.

An instance of this ModuleClass represents a software module hosted by the device.

A [dmSoftware] module is created on a Hosting CSE by the IPE in charge of the device, either at the initialization if it represents a software module that is pre-installed on the device, or after installation of one or more [[5.8.8 dmPackage]](#588-dmpackage) modules (see clause [5.8.8](#588-dmpackage)) that have been dynamically created (for instance a software image with associated configuration files and libraries).

The association between one or more [dmPackage](#588-dmpackage) modules and a dmSoftware module are under the responsibility of the IPE: dmSoftware modules are created, deleted or updated only by the IPE (for instance updating a [dmPackage](#588-dmpackage) can trigger the modification of the version data point of an associated dmSoftware).

From external applications, [dmSoftware] modules can only be discovered from the parent [flexNode], not created, and afterwards they can only be activated / deactivated. They can be seen as 'high level' information ("there is such software that is running on the device"), whereas [dmPackage](#588-dmpackage) are 'low level' information ("there is such executable file that is deployed on the device").

**Table 5.8.6-1 Actions of dmSoftware ModuleClass**

|Return Type |Name |Argument |Optional |Description |
|-|-|-|-|-|
|none |activate |none |true |Activate the software module. |
|none |deactivate |none |true |Deactivate the software module. |

**Table 5.8.6-2 DataPoints of dmSoftware ModuleClass**

|Name |Type |R/W |Optional |Unit |Description |
|-|-|-|-|-|-|
|state<br /> |[hd:enumSoftwareState](#5647-hdenumsoftwarestate) |R |false | |The current state of the software module (see clause [5.6.47](#5647-hdenumsoftwarestate)). |
|name |xs:string |R |true | |The name of the software module. |
|version |xs:string |R |true | |The version of the software module. |



### 5.8.7 dmEventLog

This ModuleClass provides DM capabilities to control and monitor event logs of the device.

**Table 5.8.7-1 Actions of dmEventLog ModuleClass**

|Return Type |Name |Arguments |Optional |Description |
|-|-|-|-|-|
|none	 |retrieveLog |start: xs:datetime<br />end: xs:datetime |true |Upload from the device the logging data between 'start' and 'end'.<br />'start' shall be a date before 'end', and is optional. The default is beginning of time.<br />'end' shall be a date after 'start' and is optional. The default is the timestamp of the last available log entry. |


This action, if provided, requests the IPE to read logging data on the device. This log is then stored in the 'data' data point. It is only valid when the 'enabled' data point is true. The *start* *and* end arguments are only indications of the time frame for the log retrieval. If a target device can deliver only partial logs for a given time frame, for example when the *start* argument is too far in the past and logs are not available for that time anymore, then the device shall deliver logs from the earliest available point in time on.

**Table 5.8.7-2 DataPoints of dmEventLog ModuleClass**

|Name |Type |R/W |Optional |Unit |Description |
|-|-|-|-|-|-|
|type	 |m2m:logTypeId |R |false | |The type of the log (e.g. security log, system log, etc). |
|data |xs:string |R |false | |Raw data of *last* event. No format specified. |
|status |m2m:logStatus |R |false | |The current status of the logging process (Started, Stopped, Error, etc.) |
|enabled |xs:boolean |RW |false | |Start / stop logging. |


For devices using the dmEventLog ModuleClass, the following rules apply:

- The actual logging process on the device (if any), and the retrieval of device logging data by the IPE, are out of scope of the present document.
- Instances of this module should only be created by the IPE (one per log type supported by the device for instance).
- The IPE can create a [dmEventLog] instance with *status* data point 'NotPresent' for a given log type, to indicate that this log type is not supported by the device. Otherwise *status* should have value 'Started' (resp. 'Stopped') if the *enabled* data point is set to *true* (resp. *false*). The *status* data point can be given 'Error' value if the log processing dysfunctions.
- The IPE should use the &lt;flexContainerInstance> history mechanism (see oneM2M TS-0001 clause 9.6.59) by setting on [dmEventLog] at least one attribute *maxNrOfInstances*, *maxByteSize* or *maxInstanceAge*. Then for each log event read by the IPE from the device, and if the *enabled* data point has value *true*, a &lt;flexContainerInstance> resource shall be created, child of this module &lt;flexContainer>. The [dmEventLog] module itself just contains the *last* logged event from the device for this log type.
- The [dmEventLog] &lt;flexContainer>, and therefore its &lt;flexContainerInstance> children resources, should have a *dataGenerationTime* custom attribute that indicates the time the event was logged on the device (see Rule 2-5 in clause 6.2.3).

When the *enabled* data point is set to *false*, the IPE shall set the *status* data point to 'Stopped' and shall not modify the *data* data point of the module, and therefore shall not create any *&lt;flexContainerInstance>* child resource.




### 5.8.8 dmPackage
This ModuleClass provides DM capabilities to deploy, control and monitor packages of the device. 

- These packages can be simple resource files such as software libraries, configuration files, etc. In this case the *softwares* data point will be empty.
- They also can correspond to software images, in which case their installation will trigger the creation by the IPE of one or more [[dmSoftware]](#586-dmsoftware) SDT modules classes that can be activated / deactivated (see clause [5.8.6](#586-dmsoftware)). In this case the *softwares* data point will contain the list of IDs of this(these) [dmSoftware](#586-dmsoftware) module(s).
- Instances of the dmPackage module class can be dynamically created by the "[deployPackage](#582-dmagent)" action of the [dmAgent](#582-dmagent) module class (see clause [5.8.2](#582-dmagent)).

**Table 5.8.8-1 Actions of dmPackage ModuleClass**

|Return Type |Name |Argument |Optional |Description |
|-|-|-|-|-|
|none	 |install |none |false |Download if needed and install the package. |
|none |uninstall |none |false |Uninstall the package. |
|none |update |version: xs:string<br />url: xs:string |false |Update the package. |

<mark>Editor's note: *update* is missing in Table 6.3.2-4</mark>

NOTE:

- The package can be pre-downloaded when the [dmPackage] resource is created.
- In the *update* action, the arguments version and url can be empty strings (case for instance of updating a package on a Linux-type system).
- When the [dmPackage] resource is deleted, the package shall be removed from the device.



**Table 5.8.8-2 DataPoints of dmPackage ModuleClass**

|Name |Type |R/W |Optional |Unit |Description |
|-|-|-|-|-|-|
|type |[hd:enumPackageType](#5649-hdenumpackagetype) |R |false | |The type of the package (software, library, config file, web content, etc. See clause [5.6.49](#5649-hdenumpackagetype)) |
|state |[hd:enumPackageState](#5648-hdenumpackagestate) |R |false | |The current state of the package (see clause [5.6.48](#5648-hdenumpackagestate)) |
|name	 |xs:string |R |true | |The name of the package. |
|version	 |xs:string |R |true | |The version of the package. |
|url |xs:url |R |true | |The URL from which the package can be downloaded |
|softwares |m2m:listOfM2MID |R |true | |The list of [dmSoftware](#586-dmsoftware) modules, if any, that are associated with this [dmPackage] module |

NOTE: 

- The [dmPackage] *name* and *version* data points are optional because they can be deduced from the downloaded resource. The *url* data point is optional because the package can be pre-installed or downloaded from a default repository (for instance a package on a Linux-type system).
- The possible dependencies between [dmPackage] modules (for instance the [dmPackage] of an executable software image depends on the deployment of other dmPackage that correspond to libraries needed by this software) is out of scope of the present document.

The control of the association between a dmPackage and an associated [dmSoftware](#586-dmsoftware) module, for instance updating a [dmPackage] when the [dmSoftware](#586-dmsoftware) is active, is out of scope of the present document.




### 5.8.9 dmAreaNwkInfo
A dmAreaNwkInfo is a SDT SubDevice entity, mapped as a &lt;flexContainer> resource that expresses the information about the devices in a M2M Area Network managed by the parent flexNode.

**Table 5.8.9-1: Properties of dmAreaNwkInfo model**

|Property Name |Property Type |Multiplicity |Description |
|-|-|-|-|
|propAreaNwkType |xs :string |1 |Indicates the type of M2M Area Network |



**Table 5.8.9-2: Modules of dmAreaNwkInfo model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|dmAreaNwkDeviceInfo |[dmAreaNwkDeviceInfo](#5810-dmareanwkdeviceinfo) |0..N |See clause [5.8.10](#5810-dmareanwkdeviceinfo). |



### 5.8.10 dmAreaNwkDeviceInfo

This ModuleClass is used to share information regarding the devices in the M2M Area Network.

**Table 5.8.10-1 DataPoints of dmAreaNwkDeviceInfo ModuleClass**

|Name |Type |R/W |Optional |Unit |Description |
|-|-|-|-|-|-|
|devId	 |xs:string |R |false | |Indicates the id of the device. It could be the id of the hardware or nodeId. |
|devType |xs:string |R |false | |Indicates the type of the device. The attribute also indicates the functions or services that are provided by the device. Examples include temperature sensor, actuator, IEEE 802.15.4 (tm) coordinator or router. |
|sleepInterval |xs:integer |R |true |seconds |The interval between two sleeps.  |
|sleepDuration |xs:integer |R |true |seconds |The time duration of each sleep. |
|status |xs:string |R |true | |The status of the device (sleeping or waked up). |



### 5.8.11 dmCapability

This ModuleClass is used to model the service capabilities of a managed device.

**Table 5.8.11-1: Actions of dmCapability ModuleClass**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|m2m:status |enable |none |true |The action that allows enabling the device capability.<br />Returns the status of the action. |
|m2m:status |disable |none |true |The action that allows disabling the device capability.<br />Returns the status of the action. |



**Table 5.8.11-2 DataPoints of dmCapability ModuleClass**

|Name |Type |R/W |Optional |Unit |Description |
|-|-|-|-|-|-|
|name |xs:string |R |false | |The name of the device capability. |
|attached |xs:boolean |R |false | |Indicates whether the capability is currently attached to the device or not. |
|currentState |xs:boolean |R |false | |Indicates the current state of the capability (e.g. enabled or disabled). |



### 5.8.12 dmStorage

This ModuleClass is used to model the storage on a managed device.

**Table 5.8.12-1: Actions of dmStorage ModuleClass**

|Return Type |Name |Argument |Optional |Documentation |
|-|-|-|-|-|
|none |format |none |true |The action that allows to format the mounted storage. |
|none |unmount |none |true |The action that allows to safety eject storage device. |



**Table 5.8.12-2 DataPoints of dmStorage ModuleClass**

|Name |Type |R/W |Optional |Unit |Description |
|-|-|-|-|-|-|
|UUID |xs:string |R |true | |The uuid of the storage device.  |
|type |xs:integer |R |true | |Indicates the type of storage. 0 indicates internal and 1 indicates external.  |
|name |xs:string |RW |true | |Indicates name of the mounted storage.  |
|writeSpeed |xs:integer |R |true | |Indicates the write speed of storage device.  |
|readSpeed |xs:integer |R |true | |Indicates the read speed of storage device.  |
|availStorage |xs:integer |R |false |MB |Indicates the current available amount of memory.  |
|totalStorage |xs:integer |R |false |MB |Indicates the total amount of memory available.  |
|presence |xs:integer |R |true | |Indicates current presence status of memory card. 0 indicates card is ejected, 1 indicates card is inserted.  |
|status |xs:integer |R |true | |Indicates current operation status of storage. 1 -indicates storage is ready, 0 indicates storage is busy.  |
|mounts |xs:integer |R |true | |Indicates number of successful mounts of the storage.  |
|forcedUnmounts |xs:integer |R |true | |Indicates number of forced unmounts of the storage.  |
|fileSystem |xs:string |RW |true | |Indicates the filesystem type used on the mounted storage.  |
|mountingPoint |xs:string |RW |true | |Indicates mounting point of the mounted storage.  |
|mountOptions |xs:string |R |true | |Indicates additional file system specific and file system independent mount options that indicate specific behaviours of the mount point as well as the capabilities of the underlying file system. |
|writeable |xs:boolean |R |false | |Indicates whether the storage volume is mounted as read/write ("TRUE") or read-only ("FALSE").  |




# 6 The Principle of Resource Mapping for Harmonized Information Model

## 6.1 Introduction
Harmonized information models which are defined in clause [5](#5-harmonised-information-model) need to be represented as resources in the oneM2M system. This clause defines the principle of resource mapping based on &lt;flexContainer>. The individual information mapping is provided in annexes [A](#annex-a-(informative)--resource-mapping-examples), [B](#annex-b-(informative)--introduction-of-external-organizations'-data-models), and [C](#annex-c-(informative)--mapping-to-content-attribute).


## 6.2 The Resource Mapping Rules

### 6.2.1 Introduction
The present clause specifies the rule to map the "Harmonized Information Model" to oneM2M resources.


### 6.2.2 Resource mapping for Device model
When the AE exposes a controlling interface for a device which is specified as an information model in clause [5.5](#55-device-models), a specialization of the &lt;flexContainer> resource shall be created as the mapping of the model following conversion rules:


- Rule 1-1: Each Device model defined in clause [5.5](#55-device-models) shall be mapped to a specialization of &lt;flexContainer>. The *containerDefinition* attribute shall be set according to clause [6.4.2](#642-device-models).

- Rule 1-2: Each entry in the 'Module' table shall be mapped to a child resource(s) which is mapped as a specialised &lt;flexContainer> following the rule in clause [6.2.3](#623-resource-mapping-for-moduleclass).

- Rule 1-3: The specialized &lt;flexContainer> resource of the Device model may contain an optional attribute *nodeLink* (as defined in oneM2M TS-0001<a href="#_ref_3">[3]</a> and in oneM2M TS-0004<a href="#_ref_4">[4]</a>). The value of *nodeLink* shall be set to the resource identifier of a &lt;node> resource described in Rule 1-5 below. See also clause Rule 1-8.

- Rule 1-4: XSD file for each Device model shall be named according to clause [6.5.2](#652-xsd-definitions-for-device-models).

- Rule 1-5:  A &lt;node> resource shall be created on the same hosting CSE as the &lt;flexContainer> representing this Device model. If the &lt;node> resource does not contain a [flexNode] child resource (see Rule 1.7), then it contains all the management information as specialized &lt;mgmtObj> resources (e.g. [firmware]) about the Device model instance for device management purposes. 

- Rule 1-6: Void.

- Rule 1-7:The &lt;node> resource targeted by the *nodeLink* attribute may have a [flexNode] child resource. This [flexNode] resource contains all the Device Management information as specialized &lt;flexContainer> resources defined in clause [5.8](#58-device-management) (e.g. [[dmFirmware](#585-dmfirmware)]) about the device model instance for Device Management purposes.

- Rule 1-8: Void.

- Rule 1-9: Each entry in the 'SubDevice' table shall be mapped to a child resource(s) which is mapped as a specialised &lt;flexContainer> following the rule in clause [6.2.7](#627-resource-mapping-for-subdevice-model).

- Rule 1-10: Each &lt;flexContainer> associated to a Device model may have as child resource any &lt;flexContainer> associated to a ModuleClass model of the Metadata domain defined in clause [5.3.9](#539-metadata-domain).

  In other words, all devices implicitly have the following lines in their modules table:

**Table 6.2.2-1: Modules of deviceXXX model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|&lt;any module in mdd domain> |&lt;any module in mdd domain> |0..N |See clause [5.3.9](#539-metadata-domain). |


### 6.2.3 Resource mapping for ModuleClass
The ModuleClass models shall be mapped to the specializations of a &lt;flexContainer> resource. The following rules shall be applied: 

When the Device or SubDevice models in clauses [5.4](#54-subdevice-models), [5.5](#55-device-models), [5.8.1](#581-flexnode) or [5.8.9](#589-dmareanwkinfo)  are mapped to the &lt;flexContainer> resource, and if the device or sub-device supports the functionality associated with a ModuleClass in the model, a &lt;flexContainer> resource which is mapped from ModuleClass definitions shall be created as a child resource:


- Rule 2-1: The *containerDefinition* attribute shall be set according to clause [6.4.3](#643-moduleclasses).
- Rule 2-2: Each entry of 'Action', 'Property', and 'DataPoint' in ModuleClass definitions shall be mapped following the resource mapping rules described in clauses [6.2.4](#624-resource-mapping-for-action) to [6.2.7 ](#627-resource-mapping-for-subdevice-model).
- Rule 2-3: XSD file for each ModuleClass shall be named according to clause [6.5.3](#653-xsd-definitions-for-moduleclass).
- Rule 2-4: The *resourceName* attribute for each module class that appears as a child of a Device or SubDevice model shall be CREATED    with the value set to "Module Instance Name". If the module class is contained in a list (multiplicity 0..N or 1..N), its *resourceName* attribute shall be set to "Module Instance Name" appended with an underscore '_' and an incrementing index so that it is unique in the parent's children (e.g. "firmware_0", "firmware_1", etc.). The index shall not have leading 0's.
- Rule 2-5: The specialized &lt;flexContainer> resource of the Module model may contain an optional [customAttribute] named *dataGenerationTime*. The value of *dataGenerationTime* contains the time when the data was generated by the device. The data type of this custom attribute is m2m:timestamp.

### 6.2.4 Resource mapping for Action

Actions defined as part of  a ModuleClass model shall be mapped to the specializations of a &lt;flexContainer> resource. The following rules shall be applied: 


- Rule 3-1: The *containerDefinition* attribute shall be set according to clause [6.4.](#644-actions).
- Rule 3-2: When the Action supports any 'Arguments', they are mapped to [customizedAttribute] with their variable names (short names are given in clause 6.3.4). When the Action supports a 'Return Type', it is mapped to a [customizedAttribute] named 'result' (short name 'resut'). The keyword 'result' is reserved and cannot be used as an Argument name.
- Rule 3-3: XSD file for each Action shall be named according to clause [6.5.4](#654-xsd-definitions-for-action).
- Rule 3-4: The Action shall be triggered:

  - by updating at least one of the Arguments custom attributes with any value, if the action has at least one argument; or
  - by updating the &lt;flexContainer> resource with empty content if it has no argument.

- Rule 3-5: The resourceName attribute for each Action model that appears as a child of a ModuleClass model shall be CREATED with the value set to "Action name".
- Rule 3-6: If an action returns a value that is of a complex data type, i.e. not one of the standard scalar types, then this value shall be encoded as a JSON structure and returned serialized in an xs:string.

### 6.2.5 Resource mapping for Property

When the Device model (in clause [5.5](#55-device-models)) or the ModuleClass model (in clause [5.3](#53-moduleclasses)) is mapped to the &lt;flexContainer> resource, and if the device supports a Property, the following rules shall be applied:


- Rule 4-1: Each entry of 'Property' table in ModuleClass model, shall be mapped to the [customAttribute] of &lt;flexContainer> resource which is mapped from associated ModuleClass model, with its Property name with prefix 'prop'.
- Rule 4-2: If the &lt;node> resource targeted by the nodeLink attribute of a Device model does not have a [flexNode] child resource, then each 'Property' of the Device model is mapped to a specialized [objectAttribute] of a [deviceInfo] &lt;mgmtObj> resource child of this &lt;node>, otherwise it is mapped to a [customAttribute] of a [[dmDeviceInfo](#583-dmdeviceinfo)] &lt;flexContainer> resource child of this [flexNode].
- Rule 4-3: Each entry of 'Property' table in SubDevice model, shall be mapped to the [customAttribute] of &lt;flexContainer> resource which is mapped from associated SubDevice model, with its Property name with prefix 'prop'.

### 6.2.6 Resource mapping for DataPoint

When the ModuleClass model (in clause [5.3](#53-moduleclasses)) is mapped to the &lt;flexContainer> resource, and if the ModuleClass supports a DataPoint, the following rules shall be applied:


- Rule 5-1: Each entry of DataPoint table in ModuleClass model, shall be mapped to [customAttribute] of &lt;flexContainer> resource which is mapped from associated ModuleClass model, with its DataPoint name.

### 6.2.7 Resource mapping for SubDevice model

The SubDevice models (in clause [5.4](#54-subdevice-models) or [5.8.9](#589-dmareanwkinfo)) shall be mapped to the specializations of a &lt;flexContainer> resource. The following rules shall be applied: 

- When the SubDevice model in clause [5.4](#54-subdevice-models) or [5.8.9](#589-dmareanwkinfo) is mapped to the &lt;flexContainer> resource, and if the device supports the functionality associated with a SubDevice in the model, a &lt;flexContainer> resource which is mapped from SubDevices definitions shall be created as a child resource.


  - Rule 7-1: The containerDefinition attribute shall be set according to clause [6.4.5](#645-subdevices).


  - Rule 7-1a: Each entry in the 'Module' table shall be mapped to a child resource(s) which is mapped as a specialised &lt;flexContainer> following the rule in clause [6.2.3](#623-resource-mapping-for-moduleclass).


  - Rule 7-2: The XSD file for each SubDevice model shall be named according to clause [6.5.5](#655-xsd-definitions-for-subdevices).


  - Rule 7-3: void


  - Rule 7-4: The resourceName attribute for each SubDevice that appears as a child of a Device or FlexNode model shall be created with the value set to "SubDevice Instance Name". If the SubDevice is contained in a list (multiplicity 0..N or 1..N), its resourceName attribute shall be set to "SubDevice Instance Name" appended with an underscore '_' and an incrementing index so that it is unique in the parent's children (e.g. "cuff_0", "cuff_1", etc.). The index shall not have leading 0's.


  - Rule 7-5: Each &lt;flexContainer> associated to a SubDevice model may have as child resource any &lt;flexContainer> associated to a ModuleClass model of the Metadata domain defined in clause [5.3.9](#539-metadata-domain).


  - In other words, all SubDevices implicitly have the following lines in their modules table:


**Table 6.2.7-1: Modules of subDeviceXXX model**

|Module Instance Name |Module Class Name |Multiplicity |Description |
|-|-|-|-|
|&lt;any module in mdd domain> |&lt;any module in mdd domain> |0..N |See clause [5.3.9](#539-metadata-domain). |


## 6.3 Short names

### 6.3.1 Introduction

XML and JSON representations require the explicit encoding of the names of resource attributes, (in the case of XML) and resource types. Whenever a protocol binding transfers such a name over a oneM2M reference point, it shall use a shortened form of that name. Short names enable payload reduction on involved telecommunication interfaces.

The mapping between the full names and their shortened form is given in the clauses that follow.


### 6.3.2 Resource types
In protocol bindings resource type names for device models shall be translated into short names of Table 6.3.2-1.



**Table 6.3.2-1: Specialization type short names (Device models)**

|Resource Type Name |Short Name |
|-|-|
|[device3DDisplay](#55118-device3ddisplay) |dTDDy |
|[device3DPrinter](#5511-device3dprinter) |dTDPr |
|[device3DScanner](#55119-device3dscanner)| dTDSr |
|[deviceAirConditioner](#5541-deviceairconditioner) |deACr |
|[deviceAirHeater](#55433-deviceairheater) |deAHr |
|[deviceAirPurifier](#5542-deviceairpurifier) |deAPr |
|[deviceAirQualityMonitor](#5512-deviceairqualitymonitor) |dAQMr |
|[deviceAudioReceiver](#5513-deviceaudioreceiver) |deARr |
|[deviceBloodPressureMonitor](#5531-devicebloodpressuremonitor) |dBPMr |
|[deviceCamera](#5514-devicecamera) |devCa |
|[deviceCardRechargingMachine](#5583-devicecardrechargingmachine) |dCRMe |
|[deviceClothesDryer](#5543-deviceclothesdryer) |deCDr |
|[deviceClothesWasher](#5544-deviceclotheswasher) |deCWr |
|[deviceClothesWasherDryer](#5545-deviceclotheswasherdryer) |dCWDr |
|[deviceCoffeeMachine](#5546-devicecoffeemachine) |deCMe |
|[deviceCookerHood](#5547-devicecookerhood) |deCHd |
|[deviceCooktop](#5548-devicecooktop) |devCp |
[[deviceCowActivityMonitor](#5571-devicecowactivitymonitor)] | dCAMr |
|[deviceDehumidifier](#5549-devicedehumidifier) |devDr |
|[deviceDigitalGallery](#55410-devicedigitalgallery) |deDGy |
|[deviceDishWasher](#55411-devicedishwasher) |deDWr |
|[deviceDoor](#5515-devicedoor) |devD0 |
|[deviceDoorLock](#5516-devicedoorlock) |deDLk |
|[deviceElectricMotorcycle](#5562-deviceelectricmotorcycle) |deEMe |
|[deviceElectricVehicleCharger](#5561-deviceelectricvehiclecharger) |dEVCr |
|[deviceFan](#55412-devicefan) |devFn |
|[deviceFoodProbe](#55413-devicefoodprobe) |deFPe |
|[deviceFreezer](#55414-devicefreezer) |devFr |
|[deviceGenericSensor](#55117-devicegenericsensor) |deGSr |
|[deviceGlucosemeter](#5532-deviceglucosemeter) |devGr |
|[deviceHandheldPTTTerminal](#5581-devicehandheldpttterminal) |dHPTl |
|[deviceHeartRateMonitor](#5533-deviceheartratemonitor) |dHRMr |
|[deviceHomeCCTV](#55415-devicehomecctv) |dHCCT |
|[deviceHumidifier](#55416-devicehumidifier) |devHr |
|[deviceJuicer](#55434-devicejuicer) |devJr |
|[deviceKettle](#55417-devicekettle) |devKe |
|[deviceLight](#5517-devicelight) |devLt |
|[deviceMagneticParkingMonitor](#5522-devicemagneticparkingmonitor) | dMPMr |
|[deviceMicrogeneration](#55418-devicemicrogeneration) |devMn |
|[deviceMultiFunctionPrinter](#5518-devicemultifunctionprinter) |dMFPr |
|[deviceOutdoorLamp](#5521-deviceoutdoorlamp) |deOLp |
|[deviceOven](#55419-deviceoven) |devOn |
|[devicePrinter](#5519-deviceprinter) |devPr |
|[devicePulseOximeter](#5534-devicepulseoximeter) |dePOr |
|[devicePWSCenter](#5591-devicepwscenter) |dPWSr |
|[devicePWSEquipment](#5592-devicepwsequipment)| dPWSt
|[deviceRefrigerator](#55420-devicerefrigerator) |devRr |
|[deviceRiceCooker](#55421-devicericecooker) |deRCr |
|[deviceRobotCleaner](#55422-devicerobotcleaner) |deRCr |
|[deviceScanner](#55110-devicescanner) |devSr |
|[deviceSecurityPanel](#55423-devicesecuritypanel) |deSPl |
|[deviceServiceButton](#55116-deviceservicebutton) |deSBn |
|[deviceSetTopBox](#55424-devicesettopbox) |dSTBx |
|[deviceShoesWasher](#55435-deviceshoeswasher) |deSWr |
|[deviceSmartElectricMeter](#5523-devicesmartelectricmeter) |dSEMr |
|[deviceSmartGasMeter](#5524-devicesmartgasmeter) | dSGMr |
|[deviceSmartGate](#5584-devicesmartgate) |deSGe |
|[deviceSmartPlug](#55111-devicesmartplug) |deSPg |
|[deviceSmartScreenDoor](#5585-devicesmartscreendoor) |dSSDr |
|[deviceSmartWaterMeter](#5525-devicesmartwatermeter) |dSWMr |
|[deviceSteamCloset](#55425-devicesteamcloset) |deSCt |
|[deviceStorageBattery](#55426-devicestoragebattery) |deSBy |
|[deviceStreetLightController](#5526-devicestreetlightcontroller) |dSLCr |
|[deviceSwitch](#55112-deviceswitch) |devSh |
|[deviceTelevision](#55427-devicetelevision) |devTn |
|[deviceThermometer](#55113-devicethermometer) |devTr |
|[deviceThermostat](#55114-devicethermostat) |devTt |
|[deviceTrainborneTerminal](#5582-devicetrainborneterminal) | deTTl |
|[deviceWaterHeater](#55428-devicewaterheater) |deWHr |
|[deviceWaterValve](#55115-devicewatervalve) |deWVe |
|[deviceWeightScaleAndBodyCompositionAnalyser](#5535-deviceweightscaleandbodycompositionanalyser) |dWSAB |
|[deviceWindowShade](#55429-devicewindowshade) |deWSe |
|[deviceBottleWarmer](#55430-devicebottlewarmer) |deBWr |
|[deviceGarbageDisposal](#55431-devicegarbagedisposal) |deGDp |
|[deviceWaterPurifier](#55432-devicewaterpurifier) |deWPr |
|[deviceWaterQualityMonitor](#5527-devicewaterqualitymonitor) | dWQMr |
|[deviceWeatherStation](#5528-deviceweatherstation) | deWSt |
|[flexNode](#581-flexnode) |fleNe |

In protocol bindings resource type names for SubDevice model shall be translated into short names of Table 6.3.2-2.

**Table 6.3.2-2: Specialization type short names (SubDevice models)**

|Resource Type Name |Short Name |
|-|-|
|[cuff](#5431-subdevicecuff) |cuff |
|[powerOutlet](#5412-subdevicepoweroutlet) |powOt |
|[subDeviceCuff](#5431-subdevicecuff) |suDCf |
|[subDeviceCuff](#5431-subdevicecuff) |sDPOt |
|[dmAreaNwkInfo](#589-dmareanwkinfo) |dANIo |

NOTE: see clause [6.2.7](#627-resource-mapping-for-subdevice-model), rule 7-4.

In protocol bindings resource type names for module classes shall be translated into short names of Table 6.3.2-3.

**Table 6.3.2-3: Specialization type short names (ModuleClasses and Module Instances)**

|Resource Type Name |Short Name |
|-|-|
|[threeDprinter](#5311-threedprinter) |thDPr |
|[acousticSensor](#5312-acousticsensor) |acoSr |
|[airCleanOperationMode](#53157-operationmode) |aCOM0 |
|[airConJobMode](#5313-airconjobmode) |aCJMe |
|[airConOperationMode](#53157-operationmode) |aCOMe |
|[airFlow](#5314-airflow) |airFw |
|[airPurifierJobMode](#5315-airpurifierjobmode) |aPJMe |
| [airPurifierOperationMode](#53157-operationmode) |aPOMe |
|[airQualitySensor](#5316-airqualitysensor) |aiQSr |
|[alarmSpeaker](#5317-alarmspeaker) |alaSr |
|[audioVolume](#5318-audiovolume) |audVe |
|[autoDocumentFeeder](#5319-autodocumentfeeder) |auDFr |
|[battery](#53110-battery) |bat |
|[binaryObject](#53111-binaryobject) |binOt |
|[binarySwitch](#53112-binaryswitch) |binSh |
|[bioElectricalImpedanceAnalysis](#53113-bioelectricalimpedanceanalysis) |bEIAs |
|[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |boCAr |
|[boiler](#53115-boiler) |boilr |
|[boilingSwitch](#53112-binaryswitch) |boiSh |
|[brewing](#53116-brewing) |brewg |
|[brewingSwitch](#53112-binaryswitch) |breSh |
|[brightness](#53117-brightness) |brigs |
|channel <mark>Editor's note: undefined</mark> |chanl |
|[clock](#53118-clock) |clock |
|[clothesDryerJobMode](#53119-clothesdryerjobmode) |cDJMe |
|[clothesDryerOperationMode](#53157-operationmode) |cDOMe |
|[clothesWasherDryerJobMode](#53121-clotheswasherdryerjobmode) |cWDJM |
|[clothesWasherDryerOperationMode](#53157-operationmode) |cWDOM |
|[clothesWasherJobMode](#53120-clotheswasherjobmode) |cWJMe |
|[clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption) |cWJMO |
|[clothesWasherOperationMode](#53157-operationmode) |cWOMe |
|[colour](#53123-colour) |color |
|[colourSaturation](#53124-coloursaturation) |colSn |
|[controlPanelLock](#53152-lock) |coPLk |
|[cookerHoodJobMode](#53126-cookerhoodjobmode) |cHJMe |
|[credentials](#53127-credentials) |creds |
|[customTemperature](#53187-temperature) |cusTe |
|dataGenerationTime |dgt |
|[dehumidifierJobMode](#53128-dehumidifierjobmode) |deJMe |
|[dehumidifierOperationMode](#53157-operationmode) |deOMe |
|[dishWasherJobMode](#53129-dishwasherjobmode) |dWJMe |
|[dmAgent](#582-dmagent) |dmAgt |
|[dmAreaNwkDeviceInfo](#5810-dmareanwkdeviceinfo) |dANDo |
|[dmCapability](#5811-dmcapability) |dmCay |
|[dmDataModelIO](#584-dmdatamodelio) |dDMIO |
|[dmDeviceInfo](#583-dmdeviceinfo) |dmDIo |
|[dmEventLog](#587-dmeventlog) |dmELg |
|[dmFirmware](#585-dmfirmware) |dmFie |
|[dmPackage](#588-dmpackage) |dmPae |
|[dmSoftware](#586-dmsoftware) |dmSoe |
|[dmStorage](#5812-dmstorage) |dmSte |
|[doorLock](#53152-lock) |dooLk |
|[doorStatus](#53130-doorstatus) |dooSs |
|[electricVehicleConnector](#53131-electricvehicleconnector) |elVCr |
|[energyConsumption](#53132-energyconsumption) |eneCn |
|[energyGeneration](#53133-energygeneration) |eneGn |
|[faultDetection](#53134-faultdetection) |fauDn |
|[features](#5391-features) |feats |
|[filterInfo](#53135-filterinfo) |filIo |
|[foaming](#53136-foaming) |foamg |
|[fridgeTemperature](#53187-temperature) |friTe |
|[frozenTemperature](#53187-temperature) |froTe |
|[geoLocation](#53141-geolocation) |geoLn |
|[glucometer](#53142-glucometer) |glucr |
|[grinder](#53143-grinder) |grinr |
|[heatingZone](#53144-heatingzone) |heaZe |
|[height](#53145-height) |heigt |
|[hotWaterSupply](#53146-hotwatersupply) |hoWSy |
|[impactSensor](#53147-impactsensor) |impSr |
|[keepWarm](#53148-keepwarm) |keeWm |
|[keypad](#53149-keypad) |keypd |
|[liquidLevel](#53150-liquidlevel) |liqLl |
|[liquidRemaining](#53151-liquidremaining) |liqRg |
|[location](#5392-location) |locan |
|[localization](#5393-localization) |loca0 |
|[lock](#53152-lock) |lock |
|[mediaInput](#53153-mediaselect) |medIt |
|[mediaOutput](#53153-mediaselect) |medOt |
|[mediaSelect](#53153-mediaselect) |medSt |
|[milkFoaming](#53136-foaming) |milFg |
|[milkQuantity](#53150-liquidlevel) |milQy |
|[milkStatus](#53151-liquidremaining) |milSs |
|[motionSensor](#53154-motionsensor) |motSr |
|[numberValue](#53155-numbervalue) |numVe |
|[openLevel](#53156-openlevel) |opeLl |
|[operationMode](#53157-operationmode) |opeMe |
|[origin](#5394-origin) |orign |
|[overcurrentSensor](#53158-overcurrentsensor) |oveSr |
|[oximeter](#53159-oximeter) |oximr |
|[ozoneMeter](#53160-ozonemeter) |ozoMr |
|[phoneCall](#53164-phonecall) |phoCl |
|[playerControl](#53165-playercontrol) |plaCl |
|[powerSave](#53166-powersave) |powS0 |
|[printerRunState](#53175-runstate) |prRSe |
|[printQueue](#53167-printqueue) |priQe |
|[pulsemeter](#53168-pulsemeter) |pulsr |
|[pushButton](#53169-pushbutton) |pusBn |
|[recorder](#53170-recorder) |recor |
|[refrigeration](#53171-refrigeration) |refrn |
|[relativeHumidity](#53172-relativehumidity) |relHy |
|[remoteControlEnable](#53173-remotecontrolenable) |reCEe |
|[robotCleanerJobMode](#53174-robotcleanerjobmode) |rCJMe |
|[robotCleanerOperationMode](#53157-operationmode) |rCOMe |
|[runState](#53175-runstate) |runSe |
|[scannerRunState](#53175-runstate) |scRSe |
|[securityMode](#53176-securitymode) |secMe |
|[sessionDescription](#53177-sessiondescription) |sesDn |
|[signalStrength](#53178-signalstrength) |sigSh |
|[sleepTimer](#53190-timer) |sleTr |
|[smokeSensor](#53182-smokesensor) |smoSr |
|[sphygmomanometer](#53183-sphygmomanometer) |sphyr |
|[spinLevel](#53184-spinlevel) |spiLl |
|[steamClosetJobMode](#53185-steamclosetjobmode) |sCJMe |
|[steamClosetOperationMode](#53157-operationmode) |sCOMe |
|[televisionChannel](#53186-televisionchannel) |telCl |
|[temperature](#53187-temperature) |tempe |
|[temperatureAlarm](#53188-temperaturealarm) |temAm |
|[textMessage](#53189-textmessage) |texMe |
|[timer](#53190-timer) |timer |
|[turbo](#53191-turbo) |turbo |
|[uvSensor](#53192-uvsensor) |uveSr |
|[waterFilterInfo](#53135-filterinfo) |waFIo |
|[waterFlow](#53193-waterflow) |watFw |
|[waterSensor](#53197-watersensor) |watSr |
|[waterStatus](#53151-liquidremaining) |watSs |
|[weight](#53199-weight) |weigt |



In protocol bindings resource type names for actions shall be translated into short names of Table 6.3.2-4.

**Table 6.3.2-4: Specialization type short names (Actions)**

|Resource Type Name |Short Name |
|-|-|
|[activate](#586-dmsoftware) |actie |
|[activateClockTimer](#53190-timer) |acCTr |
|[answer](#53164-phonecall) |answr |
|[call](#53164-phonecall) |call |
|[cancel](#53101-disseminator) |cancl |
|[close](#53156-openlevel) |close |
|[deactivate](#586-dmsoftware) |deace |
|[deactivateClockTimer](#53190-timer) |deCTr |
|[decrementNumberValue](#53155-numbervalue) |deNVe |
|[deployPackage](#582-dmagent) |depPe |
|[disable](#5811-dmcapability) |disae |
|[downChannel](#53186-televisionchannel) |dowCl |
|[downVolume](#5318-audiovolume) |dowVe |
|[enable](#5811-dmcapability) |enabe |
|[format](#5812-dmstorage) |formt |
|[hangup](#53164-phonecall) |hangp |
|[incrementNumberValue](#53155-numbervalue) |inNVe |
|[install](#588-dmpackage) |instl |
|[nextTrack](#53165-playercontrol) |nexTk |
|[open](#53156-openlevel) |open |
|[previousTrack](#53165-playercontrol) |preTk |
|[reboot](#582-dmagent) |rebot |
|[readIO](#584-dmdatamodelio) |reaIO |
|[resetGauge](#531102-raingauge)|resGe |
|[resetNumberValue](#53155-numbervalue) |reNVe |
|[resetTextMessage](#53189-textmessage) |reTMe |
|[start3Dprint](#5311-threedprinter) |staDt |
|[stop3Dprint](#5311-threedprinter) |stoDt |
|[toggle](#585-dmfirmware) |togge |
|[uninstall](#588-dmpackage) |uninl |
|[unmount](#5812-dmstorage) |unmot |
|[upChannel](#53186-televisionchannel) |uphCl |
|[updateFirmware](#585-dmfirmware) |updFe |
|[upVolume](#5318-audiovolume) |upoVe |
|[writeIO](#584-dmdatamodelio) |wriIO |




### 6.3.3 Resource attributes for properties and data points
In protocol bindings resource attributes names for properties of module classes shall be translated into short names of Table 6.3.3-1.

**Table 6.3.3-1: Resource attribute short names (ModuleClass properties)**

|Attribute Name |Occurs in |Short Name |
|-|-|-|
|chargingCapacity | [electricVehicleConnector](#53131-electricvehicleconnector) | chaCy |
| dischargingCapacity | [5.3.1.31 electricVehicleConnector](#53131-electricvehicleconnector) | disCy |
| electricEnergy | [battery](#53110-battery) | eleEy |
| material | [battery](#53110-battery) | matel |
| voltage | [battery](#53110-battery) | volte |



In protocol bindings resource attributes names for data points of module classes shall be translated into short names of Table 6.3.3-2.

**Table 6.3.3-2: Resource attribute short names (ModuleClass data points)**

|Attribute Name |Occurs in |Short Name |
|-|-|-|
|absoluteEnergyConsumption |[energyConsumption](#53132-energyconsumption) |abECn |
|absoluteStartTime |[timer](#53190-timer) |abSTe |
|absoluteStopTime |[timer](#53190-timer) |abST0 |
|acousticStatus |[acousticSensor](#5312-acousticsensor) |acoSs |
|adfStates |[autoDocumentFeeder](#5319-autodocumentfeeder) |adfSs |
|airPressure |[airQualitySensor](#5316-airqualitysensor) |airPe |
|alarm |[barometer](#531101-barometer), [motionSensor](#53154-motionsensor), [smokeSensor](#53182-smokesensor), [temperatureAlarm](#53188-temperaturealarm), [waterSensor](#53197-watersensor) |alarm |
|alarmStatus |[alarmSpeaker](#5317-alarmspeaker) |alaSs |
|alarmTimestamp | [temperatureAlarm](#53188-temperaturealarm) | alaTp |
|algae |[waterQualityMonitor](#53198-waterqualitymonitor) |algae |
|altitude |[geoLocation](#53141-geolocation) |altie |
|anionics |[waterQualityMonitor](#53198-waterqualitymonitor) |anios |
|areaLatitude |[disseminator](#53101-disseminator), [emergencyHandler](#53102-emergencyhandler) |areLe |
|areaLongitude |[disseminator](#53101-disseminator), [emergencyHandler](#53102-emergencyhandler) |areL0 |
|areaRadius |[disseminator](#53101-disseminator), [emergencyHandler](#53102-emergencyhandler) |areRs |
|aroh |[waterQualityMonitor](#53198-waterqualitymonitor) |aroh |
|as |[waterQualityMonitor](#53198-waterqualitymonitor) |as |
|atmosphericPressure |[barometer](#531101-barometer) |atmPe |
|automode |[airFlow](#5314-airflow) |autoe |
|availableChannels |[televisionChannel](#53186-televisionchannel) |avaCs |
|backoffTime |[periodicalReportConfig](#53163-periodicalreportconfig) |bacTe |
|balance |[billDeposit](#531108-billdeposit), [billWithdrawal](#531109-billwithdrawal), [cashDispenser](#531111-cashdispenser), [coinDeposit](#531110-coindeposit), [prePaidCardReader](#531107-prepaidcardreader) |balae |
|baliseSystemId |[baliseTransmissionModule](#5381-balisetransmissionmodule) |baSId |
|barrierDefault |[crossingBarrier](#531115-crossingbarrier) |barDt |
|barrierStatus |[crossingBarrier](#531115-crossingbarrier) |barSs |
|basalMetabolism |[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |basMm |
|bath |[hotWaterSupply](#53146-hotwatersupply) |bath |
|batteryThreshold |[battery](#53110-battery) |batTd |
|billingNumber |[gasChargingControl](#53138-gaschargingcontrol) |bilNr |
|biotoxicity |[waterQualityMonitor](#53198-waterqualitymonitor) |bioty |
|blue |[colour](#53123-colour) |blue |
|bmi |[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |bmi |
|bodyLength |[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |bodLh |
|bone |[bioElectricalImpedanceAnalysis](#53113-bioelectricalimpedanceanalysis) |bone |
|brightness |[brightness](#53117-brightness) |brigs |
|buttonFault |[waterMeterAlarm](#53194-watermeteralarm)|butFt |
|callerID |[phoneCall](#53164-phonecall) |calID |
|callState |[phoneCall](#53164-phonecall) |calSe |
|capacity |[battery](#53110-battery) |capay |
|cd |[waterQualityMonitor](#53198-waterqualitymonitor) |cd |
|cellID |[connectivity](#53125-connectivity) |celID |
|certainty |[disseminator](#53101-disseminator), [emergencyHandler](#53102-emergencyhandler) |certy |
|ch2o |[airQualitySensor](#5316-airqualitysensor) |ch2o |
|channelId |[televisionChannel](#53186-televisionchannel) |chaId |
|channelName |[televisionChannel](#53186-televisionchannel) |chaNe |
|cardInfo |[cardScanner](#531112-cardscanner), [prePaidCardReader](#531107-prepaidcardreader) |carIo |
|charging |[battery](#53110-battery) |charg |
|chargingCapacity |[electricVehicleConnector](#53131-electricvehicleconnector) |chaCy |
|chlorophyll_a |[waterQualityMonitor](#53198-waterqualitymonitor) |chloa |
|cn |[waterQualityMonitor](#53198-waterqualitymonitor) |cn |
|co |[airQualitySensor](#5316-airqualitysensor) |co |
|co2 |[airQualitySensor](#5316-airqualitysensor) |co2 |
|coarseness |[grinder](#53143-grinder) |coars |
|cod |[waterQualityMonitor](#53198-waterqualitymonitor) |cod |
|code |[faultDetection](#53134-faultdetection), [filterInfo](#53135-filterinfo) |code |
|coldWash |[clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption) |colWh |
|colourSaturation |[colourSaturation](#53124-coloursaturation) |colSn |
|colourTemperature |[slcReportInfo](#53181-slcreportinfo) |colTe |
|commFreqValue |[connectivity](#53125-connectivity) |coFVe |
|communicationAlarm |[waterMeterAlarm](#53194-watermeteralarm)|comAm |
|component |[dmFirmware](#585-dmfirmware) |compt |
|concentration |[glucometer](#53142-glucometer) |concn |
|conductivity |[waterQualityMonitor](#53198-waterqualitymonitor) |condy |
|contextCarbohydratesAmount |[glucometer](#53142-glucometer) |coCAt |
|contextCarbohydratesSource |[glucometer](#53142-glucometer) |coCSe |
|contextExercise |[glucometer](#53142-glucometer) |conEe |
|contextHealth |[glucometer](#53142-glucometer) |conHh |
|contextLocation |[glucometer](#53142-glucometer) |conLn |
|contextMeal |[glucometer](#53142-glucometer) |conMl |
|contextMedication |[glucometer](#53142-glucometer) |conMn |
|contextTester |[glucometer](#53142-glucometer) |conTr |
|count |[billDeposit](#531108-billdeposit), [billWithdrawal](#531109-billwithdrawal), [cashDispenser](#531111-cashdispenser), [coinDeposit](#531110-coindeposit) |count |
|country |[dmDeviceInfo](#583-dmdeviceinfo) |couny |
|cpuUsage |[dmAgent](#582-dmagent) |cpuUe |
|cr6 |[waterQualityMonitor](#53198-waterqualitymonitor) |cr6 |
|cu |[waterQualityMonitor](#53198-waterqualitymonitor) |cu |
|cumulativeFlowDaily |[waterMeterReportInfo](#53195-watermeterreportinfo) |cuFDy |
|cupsNumber |[brewing](#53116-brewing) |cupNr |
|currency |[billDeposit](#531108-billdeposit), [cashDispenser](#531111-cashdispenser), [coinDeposit](#531110-coindeposit), [prePaidCardReader](#531107-prepaidcardreader) |curry |
|current |[energyConsumption](#53132-energyconsumption) |currt |
|currentAdfState |[autoDocumentFeeder](#5319-autodocumentfeeder) |cuASe |
|currentCycleTransmissionErrors |[connectivity](#53125-connectivity) |cCTEs |
|currentCycleVolume |[connectivity](#53125-connectivity) |cuCVe |
|currentDate |[clock](#53118-clock) |curDe |
|currentJobMode |[airConJobMode](#5313-airconjobmode), [airPurifierJobMode](#5315-airpurifierjobmode), [clothesDryerJobMode](#53119-clothesdryerjobmode), [clothesWasherDryerJobMode](#53121-clotheswasherdryerjobmode), [clothesWasherJobMode](#53120-clotheswasherjobmode), [cookerHoodJobMode](#53126-cookerhoodjobmode), [dehumidifierJobMode](#53128-dehumidifierjobmode), [dishWasherJobMode](#53129-dishwasherjobmode), [robotCleanerJobMode](#53174-robotcleanerjobmode), [shoesWasherJobMode](#531119-shoeswasherjobmode), [steamClosetJobMode](#53185-steamclosetjobmode) |cuJMe |
|currentJobModeName |[airConJobMode](#5313-airconjobmode), [airPurifierJobMode](#5315-airpurifierjobmode), [clothesDryerJobMode](#53119-clothesdryerjobmode), [clothesWasherDryerJobMode](#53121-clotheswasherdryerjobmode), [clothesWasherJobMode](#53120-clotheswasherjobmode), [cookerHoodJobMode](#53126-cookerhoodjobmode), [dehumidifierJobMode](#53128-dehumidifierjobmode), [dishWasherJobMode](#53129-dishwasherjobmode), [robotCleanerJobMode](#53174-robotcleanerjobmode), [shoesWasherJobMode](#531119-shoeswasherjobmode), [steamClosetJobMode](#53185-steamclosetjobmode) |cJMNe |
|currentJobState |[runState](#53175-runstate) |cuJSe |
|currentMachineState |[runState](#53175-runstate) |cuMSe |
|currentPlayerMode |[playerControl](#53165-playercontrol) |cuPMe |
|currentPlayerModeName |[playerControl](#53165-playercontrol) |cPMNe |
|currentSecurityMode |[securityMode](#53176-securitymode) |cuSMe |
|currentTemperature |[temperature](#53187-temperature) |curT0 |
|currentTime |[clock](#53118-clock) |curTe |
|currentTimeZone |[clock](#53118-clock) |cuTZe |
|currentValue |[smokeSensor](#53182-smokesensor) |crv |
|dailyActivityTime |[connectivity](#53125-connectivity) |daATe |
|dailyNumberOfConnections |[connectivity](#53125-connectivity) |dNOCs |
|data		 |[dmEventLog](#587-dmeventlog) |data |
|dataModelType |[dmDataModelIO](#584-dmdatamodelio) |daMTe |
|dataSourceID |[origin](#5394-origin) |daSID |
|dataType |[origin](#5394-origin) |datTe |
|dailyUseWaterTime |[waterMeterReportInfo](#53195-watermeterreportinfo) |dUWTe |
|defaultValue |[numberValue](#53155-numbervalue), [textMessage](#53189-textmessage) |defVe |
|defrost |[refrigeration](#53171-refrigeration) |defrt |
|demolitionAlarm |[waterMeterAlarm](#53194-watermeteralarm)|demAm |
|depositStatus |[billDeposit](#531108-billdeposit), [coinDeposit](#531110-coindeposit) |depSs |
|description |[faultDetection](#53134-faultdetection), [dmDeviceInfo](#583-dmdeviceinfo), [localization](#5393-localization) |dc |
|desiredHumidity |[relativeHumidity](#53172-relativehumidity) |desHy |
|detectedTime |[infraredSensor](#531103-infraredsensor), [overcurrentSensor](#53158-overcurrentsensor), [smokeSensor](#53182-smokesensor) |detTe |
|detectedValue |[infraredSensor](#531103-infraredsensor) |detVe |
|detectionInterval |[magneticSensorParameters](#53161-magneticsensorparameters)|detIl |
|diastolicPressure |[sphygmomanometer](#53183-sphygmomanometer) |diaPe |
|discharging |[battery](#53110-battery) |discg |
|dischargingCapacity |[electricVehicleConnector](#53131-electricvehicleconnector) |disCy |
|dispenseStatus |[cashDispenser](#531111-cashdispenser) |disSs |
|displayInterval |[galleryMode](#53137-gallerymode) |disIl |
|displayOrder |[galleryMode](#53137-gallerymode) |disOr |
|displayOrientation |[galleryMode](#53137-gallerymode) |disOn |
|disposalStatus |[disposal](#531104-disposal) |disSs |
|do |[waterQualityMonitor](#53198-waterqualitymonitor) |do |
|doorState |[doorStatus](#53130-doorstatus) |dooSe |
|duration |[overcurrentSensor](#53158-overcurrentsensor), [recorder](#53170-recorder) |dur |
|effective |[disseminator](#53101-disseminator), [emergencyHandler](#53102-emergencyhandler) |effee |
|electricEnergy |[battery](#53110-battery) |eleEy |
|emergencyMode |[emergencyHandler](#53102-emergencyhandler) |emeMe |
|enabled |[dmEventLog](#587-dmeventlog) |enabd |
|energy |[pulsemeter](#53168-pulsemeter) |enery |
|estimatedTimeToEnd |[timer](#53190-timer) |eTTEd |
|eventCodes |[disseminator](#53101-disseminator), [emergencyHandler](#53102-emergencyhandler) |eveCs |
|expires |[disseminator](#53101-disseminator), [emergencyHandler](#53102-emergencyhandler) |expis |
|extraRinse |[clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption) |extRe |
|f |[waterQualityMonitor](#53198-waterqualitymonitor) |f |
|fakeStatus |[billDeposit](#531108-billdeposit), [coinDeposit](#531110-coindeposit) |fakSs |
|fat |[bioElectricalImpedanceAnalysis](#53113-bioelectricalimpedanceanalysis) |fat |
|fatFreeMass |[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |faFMs |
|fe |[waterQualityMonitor](#53198-waterqualitymonitor) |fe |
|filterLifetime |[filterInfo](#53135-filterinfo) |filLe |
|filterType |[waterFilterType](#531105-waterfiltertype) |filTe |
|flowInterval |[waterMeterSetting](#53196-watermetersetting) |floIl |
|foamingStrength |[foaming](#53136-foaming) |foaSh |
|frequency |[energyConsumption](#53132-energyconsumption) |freqy |
|friendlyName |[dmDeviceInfo](#583-dmdeviceinfo), [localization](#5393-localization) |friNe |
|friendlyLocation |[location](#5392-location), [localization](#5393-localization) |friLn |
|ftu |[waterQualityMonitor](#53198-waterqualitymonitor) |ftu |
|fwVersion |[dmDeviceInfo](#583-dmdeviceinfo)	 |fweVn |
|gaugeHeight |[rainGauge](#531102-raingauge) |gauHt |
|generationSource |[energyGeneration](#53133-energygeneration) |genSe |
|geoJSON |[location](#5392-location) |geoJN |
|grainsRemaining |[grinder](#53143-grinder) |graRg |
|green |[colour](#53123-colour) |green |
|hash |[binaryObject](#53111-binaryobject) |hash |
|hba1c |[glucometer](#53142-glucometer) |hba1c |
|heading |[geoLocation](#53141-geolocation), [headingSensor](#531113-headingsensor) |headg |
|headingAccuracy |[geoLocation](#53141-geolocation), [headingSensor](#531113-headingsensor) |heaAy |
|heatingLevel |[heatingZone](#53144-heatingzone) |heaLl |
|height |[height](#53145-height) |heigt |
|hg |[waterQualityMonitor](#53198-waterqualitymonitor) |hg |
|highMagneticAlarm |[magneticSensorParameters](#53161-magneticsensorparameters)|hiMAm |
|highFlowAlarm |[waterMeterAlarm](#53194-watermeteralarm)|hiFAm |
|highFlowAlarmThreshold |[waterMeterAlarm](#53194-watermeteralarm)|hFATd |
|highFlowDuration |[waterMeterAlarm](#53194-watermeteralarm)|hiFDn |
|highPressureAlarm |[waterMeterAlarm](#53194-watermeteralarm)|hiPAm |
|highPressureAlarmThreshold |[waterMeterAlarm](#53194-watermeteralarm)|hPATd |
|highTemperatureAlarm |temperatureAlarm](#53188-temperaturealarm), [waterMeterAlarm](#53194-watermeteralarm)|hiTAm |
|highTemperatureAlarmThreshold |[temperatureAlarm](#53188-temperaturealarm), [waterMeterAlarm](#53194-watermeteralarm)|hTATh |
|highTemperatureInnerAlarmThreshold |[waterMeterAlarm](#53194-watermeteralarm)|hTIAd |
|historyStepCounts |[cowActivityMonitor](#5371-cowactivitymonitor) |hiSCs |
|horizontalAccuracy |[geoLocation](#53141-geolocation) |horAy |
|horizontalDirection |[airFlow](#5314-airflow) |horDn |
|humidity |[airQualitySensor](#5316-airqualitysensor) |humiy |
|hwVersion |[dmDeviceInfo](#583-dmdeviceinfo)|hweVn |
|identifier |[disseminator](#53101-disseminator), [emergencyHandler](#53102-emergencyhandler) |idenr |
|impactDirectionHorizontal |[impactSensor](#53147-impactsensor) |imDHl |
|impactDirectionVertical |[impactSensor](#53147-impactsensor) |imDVl |
|impactLevel |[impactSensor](#53147-impactsensor) |impLl |
|impactStatus |[impactSensor](#53147-impactsensor) |impSs |
|impedance |[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |impee |
|impulseFault |[waterMeterAlarm](#53194-watermeteralarm)|impFt |
|initialMagnetic |[magneticSensorParameters](#53161-magneticsensorparameters)|iniMc |
|innerErrorAlarm |[waterMeterAlarm](#53194-watermeteralarm)|inEAm |
|innerHighInternalTemperatureAlarm |[waterMeterAlarm](#53194-watermeteralarm)|iHITm |
|innerTemperatureSensorFault |[waterMeterAlarm](#53194-watermeteralarm)|iTSFt |
|intensiveReportInterval |[waterMeterSetting](#53196-watermetersetting) |inRIl |
|intensiveReportStartTime |[waterMeterSetting](#53196-watermetersetting) |iRSTe |
|intensiveSampleInterval |[waterMeterSetting](#53196-watermetersetting) |inSIl |
|intervalFlow |[waterMeterReportInfo](#53195-watermeterreportinfo) |intFw |
|jobModes |[airConJobMode](#5313-airconjobmode), [airPurifierJobMode](#5315-airpurifierjobmode), [clothesWasherDryerJobMode](#53121-clotheswasherdryerjobmode), [clothesWasherJobMode](#53120-clotheswasherjobmode), [cookerHoodJobMode](#53126-cookerhoodjobmode), [dehumidifierJobMode](#53128-dehumidifierjobmode), [dishWasherJobMode](#53129-dishwasherjobmode), [robotCleanerJobMode](#53174-robotcleanerjobmode), [shoesWasherJobMode](#531119-shoeswasherjobmode), [steamClosetJobMode](#53185-steamclosetjobmode),  |jobMs |
|jobStates |[runState](#53175-runstate) |jobSs |
|kcal |[bioElectricalImpedanceAnalysis](#53113-bioelectricalimpedanceanalysis) |kcal |
|keyNumber |[keypad](#53149-keypad) |keyNr |
|kmno4 |[waterQualityMonitor](#53198-waterqualitymonitor) |kmno4 |
|lampTechnology |[slcReportInfo](#53181-slcreportinfo) |lamTy |
|largeFlowAlarm |[gasMeterAlarm](#53139-gasmeteralarm) |LaFAm |
|latitude |[geoLocation](#53141-geolocation) |latie |
|leakageAlarm |[gasMeterAlarm](#53139-gasmeteralarm) |leaAm |
|level |[battery](#53110-battery) |lvl |
|light |[alarmSpeaker](#5317-alarmspeaker) |light |
|lightActivePower |[slcReportInfo](#53181-slcreportinfo) |LiAPr |
|lightCount |[slcParameterSetting](#53180-slcparametersetting) |ligCt |
|lightCurrent |[slcReportInfo](#53181-slcreportinfo) |ligC0 |
|lightApparentPower |[slcReportInfo](#53181-slcreportinfo) |liAPr |
|lightDimmingValue |[slcReportInfo](#53181-slcreportinfo) |liDVe |
|lightPolarizationAxis |[slcReportInfo](#53181-slcreportinfo) |liPAs |
|lightPowerFactor |[slcReportInfo](#53181-slcreportinfo) |liPFr |
|lightReactivePower |[slcReportInfo](#53181-slcreportinfo) |LiRPr |
|lightVoltage |[slcReportInfo](#53181-slcreportinfo) |ligVe |
|liquidLevel |[liquidLevel](#53150-liquidlevel) |liqLl |
|liquidRemaining |[liquidRemaining](#53151-liquidremaining) |liqRg |
|locale |[location](#5392-location) |locae |
|lock |[lock](#53152-lock) |lock |
|lockedDownAlarm |[gasMeterAlarm](#53139-gasmeteralarm) |loDAm |
|loginName |[credentials](#53127-credentials) |logNe |
|longitude |[geoLocation](#53141-geolocation) |longe |
|loudness |[acousticSensor](#5312-acousticsensor) |louds |
|lowBattery |[battery](#53110-battery) |lowBy |
|lowCreditAlarm |[gasMeterAlarm](#53139-gasmeteralarm) |loCAm |
|lowFlowAlarm |[waterMeterAlarm](#53194-watermeteralarm)|loFAm |
|lowFlowAlarmThreshold |[waterMeterAlarm](#53194-watermeteralarm)|lFATd |
|lowFlowDuration |[waterMeterAlarm](#53194-watermeteralarm)|loFDn |
|lowestFlowRate |[waterMeterReportInfo](#53195-watermeterreportinfo) |loFRe |
|lowestFlowRateTime |[waterMeterReportInfo](#53195-watermeterreportinfo) |lFRTe |
|lowestReverseFlowRate |[waterMeterReportInfo](#53195-watermeterreportinfo) |lRFRe |
|lowestReverseFlowRateTime |[waterMeterReportInfo](#53195-watermeterreportinfo) |lRFR0 |
|lowGasAlarm |[gasMeterAlarm](#53139-gasmeteralarm) |loGAm |
|lowPressureAlarm |[waterMeterAlarm](#53194-watermeteralarm)|LoPAm |
|lowPressureAlarmThreshold |[waterMeterAlarm](#53194-watermeteralarm)|lPATd |
|lowTemperatureAlarm |[temperatureAlarm](#53188-temperaturealarm), [waterMeterAlarm](#53194-watermeteralarm)|loTAm |
|lowTemperatureAlarmThreshold |[temperatureAlarm](#53188-temperaturealarm), [waterMeterAlarm](#53194-watermeteralarm)|LTATd |
|lqi |[signalStrength](#53178-signalstrength) |lqi |
|machineStates |[runState](#53175-runstate) |macSs |
|magneticDisturb |[gasMeterAlarm](#53139-gasmeteralarm) |magDb |
|magneticSensitivityLevel |[magneticSensorParameters](#53161-magneticsensorparameters)|maSLl |
|magneticInterference |[waterMeterAlarm](#53194-watermeteralarm)|magIe |
|manufacturer |[dmDeviceInfo](#583-dmdeviceinfo) |manur |
|manufacturerDetailsLink |[dmDeviceInfo](#583-dmdeviceinfo) |maDLk |
|manufacturingDate |[dmDeviceInfo](#583-dmdeviceinfo) |manDe |
|material |[battery](#53110-battery) |matel |
|maxHeatingLevel |[heatingZone](#53144-heatingzone) |maHLl |
|maxLength |[textMessage](#53189-textmessage) |maxLh |
|maxLevel |[openLevel](#53156-openlevel) |maxLl |
|maxPressureThreshold |[barometer](#531101-barometer) |maPTd |
|maxSizeX |[threeDScanner](#531117-threedscanner) |maxSX |
|maxSizeY |[threeDScanner](#531117-threedscanner) |maxSX |
|maxSizeZ |[threeDScanner](#531117-threedscanner) |maxSZ |
|maxSpeed |[airFlow](#5314-airflow) |maxSd |
|maxValue |[audioVolume](#5318-audiovolume), [numberValue](#53155-numbervalue), [ozoneMeter](#53160-ozonemeter), [temperature](#53187-temperature) |maxVe |
|meanPressure |[sphygmomanometer](#53183-sphygmomanometer) |meaPe |
|measuringScope |[energyConsumption](#53132-energyconsumption) |meaSe |
|mediaID |[mediaSelect](#53153-mediaselect) |medID |
|mediaName |[mediaSelect](#53153-mediaselect) |medNe |
|mediaType |[mediaSelect](#53153-mediaselect) |medTe |
|memorySize |[threeDprinter](#5311-threedprinter) |memSe |
|messageEncoding |[textMessage](#53189-textmessage) |mesEg |
|metadata |[features](#5391-features) |metaa |
|minimumCommunicationLatency |[connectivity](#53125-connectivity) |miCLy |
|minLength |[textMessage](#53189-textmessage) |minLh |
|minLevel |[openLevel](#53156-openlevel) |minLl |
|minPressureThreshold |[barometer](#531101-barometer) |miPTd |
|minSpeed |[airFlow](#5314-airflow) |minSd |
|minValue |[numberValue](#53155-numbervalue), [temperature](#53187-temperature) |minVe |
|modality |[pulsemeter](#53168-pulsemeter) |moday |
|model |[dmDeviceInfo](#583-dmdeviceinfo) |model |
|monitoringEnabled |[airQualitySensor](#5316-airqualitysensor) |monEd |
|msgType |[disseminator](#53101-disseminator), [emergencyHandler](#53102-emergencyhandler) |msgTe |
|multiFirmware |[dmFirmware](#585-dmfirmware) |mulFe |
|multiplyingFactors |[energyConsumption](#53132-energyconsumption), [energyGeneration](#53133-energygeneration) |mulFs |
|muscle |[bioElectricalImpedanceAnalysis](#53113-bioelectricalimpedanceanalysis) |musce |
|muscleMass |[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |musMs |
|muteEnabled |[audioVolume](#5318-audiovolume) |mutEd |
|name |[dmPackage](#588-dmpackage), [dmSoftware](#586-dmsoftware) |name |
|network |[threeDprinter](#5311-threedprinter) |netwk |
|negativeCumulativeFlow |[waterMeterReportInfo](#53195-watermeterreportinfo) |neCFw |
|nh3nh4 |[waterQualityMonitor](#53198-waterqualitymonitor) |nh3n4 |
|no2 |[airQualitySensor](#5316-airqualitysensor) |no2 |
|no3n |[waterQualityMonitor](#53198-waterqualitymonitor) |no3n |
|noise |[airQualitySensor](#5316-airqualitysensor) |noise |
|numberValue |[numberValue](#53155-numbervalue) |numVe |
|o3 |[airQualitySensor](#5316-airqualitysensor) |o3 |
|object |[binaryObject](#53111-binaryobject) |objet |
|objectType |[binaryObject](#53111-binaryobject) |objTe |
|odor |[airQualitySensor](#5316-airqualitysensor) |odor |
|oil |[waterQualityMonitor](#53198-waterqualitymonitor) |oil |
|onlineStatus |[slcReportInfo](#53181-slcreportinfo) |onlSs |
|onset |[disseminator](#53101-disseminator), [emergencyHandler](#53102-emergencyhandler) |onset |
|openAlarm |[doorStatus](#53130-doorstatus) |opeAm |
|openDuration |[doorStatus](#53130-doorstatus) |opeDn |
|openLevel |[openLevel](#53156-openlevel) |opeLl |
|optoutStatus |[settings](#53103-settings) |optSs |
|originID |[origin](#5394-origin) |oriID |
|osVersion |[dmDeviceInfo](#583-dmdeviceinfo) |oseVn |
|overCurrentAlarm |[slcAlarm](#53179-slcalarm) |ovCAm |
|overCurrentDuration |[slcAlarm](#53179-slcalarm) |ovCDn |
|overcurrentStatus |[overcurrentSensor](#53158-overcurrentsensor) |oveSs |
|overCurrentThreshold |[slcAlarm](#53179-slcalarm) |ovCTd |
|overVoltageAlarm |[slcAlarm](#53179-slcalarm) |ovVAm |
|overVoltageDuration |[slcAlarm](#53179-slcalarm) |ovVDn |
|overVoltagePercent |[slcAlarm](#53179-slcalarm) |ovVPt |
|overVoltageThreshold |[slcAlarm](#53179-slcalarm) |ovVTd |
|oxygenSaturation |[oximeter](#53159-oximeter) |oxySn |
|ozoneStatus |[ozoneMeter](#53160-ozonemeter) |ozoSs |
|ozoneValueMG |[ozoneMeter](#53160-ozonemeter) |ozVMG |
|ozoneValuePPM |[ozoneMeter](#53160-ozonemeter) |oVPPM |
|parkingStatus |[parkingStatus](#53162-parkingstatus) |parSs |
|password |[credentials](#53127-credentials) |pwd |
|pb |[waterQualityMonitor](#53198-waterqualitymonitor) |pb |
|pci |[connectivity](#53125-connectivity) |pci |
|peakFlowRate |[waterMeterReportInfo](#53195-watermeterreportinfo) |peFRe |
|peakFlowRateTime |[waterMeterReportInfo](#53195-watermeterreportinfo) |pFRTe |
|peakReverseFlowRate |[waterMeterReportInfo](#53195-watermeterreportinfo) |pRFRe |
|peakReverseFlowRateTime |[waterMeterReportInfo](#53195-watermeterreportinfo) |pRFR0 |
|period |[periodicalReportConfig](#53163-periodicalreportconfig) |perid |
|ph |[waterQualityMonitor](#53198-waterqualitymonitor) |ph |
|pm1 |[airQualitySensor](#5316-airqualitysensor) | pm1 |
|pm10 |[airQualitySensor](#5316-airqualitysensor) |pm10 |
|pm25 |[airQualitySensor](#5316-airqualitysensor) | pm25 |
|positiveCumulativeFlow |[waterMeterReportInfo](#53195-watermeterreportinfo) |poCFw |
|positionX |[touchScreen](#531106-touchscreen) | posiX |
|positionY |[touchScreen](#531106-touchscreen) | posiY |
|postalAddress |[location](#5392-location) |posAs |
|power |[energyConsumption](#53132-energyconsumption) |power |
|powerGenerationData |[energyGeneration](#53133-energygeneration) |poGDa |
|powerSaveEnabled |[powerSave](#53166-powersave) |poSEd |
|powerStatus |[dmAgent](#582-dmagent) |powSs |
|precision |[features](#5391-features) |precn |
|presentationURL |[dmDeviceInfo](#583-dmdeviceinfo) |prURL |
|pressureSensorFault |[waterMeterAlarm](#53194-watermeteralarm)|prSFt |
|previousChannel |[televisionChannel](#53186-televisionchannel) |preCl |
|preWash |[clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption) |preWh |
|primaryName |[dmFirmware](#585-dmfirmware) |priNe |
|primaryState |[dmFirmware](#585-dmfirmware) |priSe |
|primaryUrl |[dmFirmware](#585-dmfirmware) |priUl |
|primaryVersion |[dmFirmware](#585-dmfirmware) |priVn |
|printingState |[printQueue](#53167-printqueue) |priS0 |
|printSizeX |[threeDprinter](#5311-threedprinter) |priSX |
|printSizeY |[threeDprinter](#5311-threedprinter) |priSY |
|printSizeZ |[[5.3.1.1 threeDprinter](#5311-threedprinter)threeDprinter](#5311-threedprinter) |priSZ |
|printType |[threeDprinter](#5311-threedprinter) |priTe |
|progressPercentage |[runState](#53175-runstate) |proPe |
|pulseRate |[pulsemeter](#53168-pulsemeter) |pulRe |
|pushed |[pushButton](#53169-pushbutton), [touchScreen](#531106-touchscreen) |pushd |
|ramAvailable |[dmAgent](#582-dmagent) |ramAe |
|ramTotal |[dmAgent](#582-dmagent) |ramTl |
|rapidCool |[refrigeration](#53171-refrigeration) |rapCl |
|rapidFreeze |[refrigeration](#53171-refrigeration) |rapFe |
|readStatus |[prePaidCardReader](#531107-prepaidcardreader) |reaSs |
|rechargeCredit |[gasChargingControl](#53138-gaschargingcontrol) |recCt |
|rechargeGas |[gasChargingControl](#53138-gaschargingcontrol) |recGs |
|recipientID |[phoneCall](#53164-phonecall) |recID |
|red |[colour](#53123-colour) |red |
|references |[emergencyHandler](#53102-emergencyhandler) |refes |
|referenceTimer |[timer](#53190-timer) |refTr |
|references |[disseminator](#53101-disseminator) |refes |
|relativeHumidity |[relativeHumidity](#53172-relativehumidity) |relHy |
|reliability |[features](#5391-features) |reliy |
|remoteControlEnabled |[remoteControlEnable](#53173-remotecontrolenable) |reCEd |
|repetitionCount |[disseminator](#53101-disseminator) |repCt |
|repetitionPeriod |[disseminator](#53101-disseminator) |repPd |
|resistance |[bioElectricalImpedanceAnalysis](#53113-bioelectricalimpedanceanalysis) |resie |
|retryInterval |[periodicalReportConfig](#53163-periodicalreportconfig) |retIl |
|retryTimes |[periodicalReportConfig](#53163-periodicalreportconfig) |retTs |
|reverseFlowAlarm |[waterMeterAlarm](#53194-watermeteralarm)|reFAm |
|reverseFlowAlarmThreshold |[waterMeterAlarm](#53194-watermeteralarm)|rFATd |
|reverseFlowDuration |[waterMeterAlarm](#53194-watermeteralarm)|reFDn |
|reverseFlowInterval |[waterMeterSetting](#53196-watermetersetting) |reFIl |
|reverseIntervalFlow |[waterMeterReportInfo](#53195-watermeterreportinfo) |reIFw |
|room |[location](#5392-location) |room |
|roundingEnergyConsumption |[energyConsumption](#53132-energyconsumption) |roECn |
|roundingEnergyGeneration |[energyGeneration](#53133-energygeneration) |roEGn |
|rr |[pulsemeter](#53168-pulsemeter) |r0 |
|rsrp |[connectivity](#53125-connectivity) |rsrp |
|rsrq |[connectivity](#53125-connectivity) |rsrq |
|rssi |[connectivity](#53125-connectivity), [signalStrength](#53178-signalstrength) |rssi |
|runningTime |[timer](#53190-timer) |runTe |
|scanStatus |[cardScanner](#531112-cardscanner) |scaSs |
|sdp |[sessionDescription](#53177-sessiondescription) |sdp |
|secondaryName |[dmFirmware](#585-dmfirmware) |secNe |
|secondaryState |[dmFirmware](#585-dmfirmware) |secSe |
|secondaryUrl |[dmFirmware](#585-dmfirmware) |secUl |
|secondaryVersion |[dmFirmware](#585-dmfirmware) |secVn |
|securityModes |[securityMode](#53176-securitymode) |secMs |
|sender |[disseminator](#53101-disseminator), [emergencyHandler](#53102-emergencyhandler) |sendr |
|sensitivity |[motionSensor](#53154-motionsensor), [emergencyHandler](#53102-emergencyhandler) |sensy |
|sent |[disseminator](#53101-disseminator), [emergencyHandler](#53102-emergencyhandler) |sent |
|serialNumber |[dmDeviceInfo](#583-dmdeviceinfo), [emergencyHandler](#53102-emergencyhandler) |serNr |
|severity |[disseminator](#53101-disseminator), [emergencyHandler](#53102-emergencyhandler) |sevey |
|signal |[signalPanel](#531114-signalpanel) |signl |
|signalECL |[connectivity](#53125-connectivity) |siECL |
|significantDigits |[energyConsumption](#53132-energyconsumption), [energyGeneration](#53133-energygeneration) |sigDs |
|silentTime |[motionSensor](#53154-motionsensor) |silTe |
|singleCountAlarm |[gasMeterAlarm](#53139-gasmeteralarm) |siCAm |
|sinr |[connectivity](#53125-connectivity) |sinr |
|size |[binaryObject](#53111-binaryobject), [features](#5391-features) |size |
|smokeThreshold |[smokeSensor](#53182-smokesensor) |smoTd |
|so2 |[airQualitySensor](#5316-airqualitysensor) |so2 |
|softLeanMass |[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |soLMs |
|soilLevel |[clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption) |soiLl |
|speed |[airFlow](#5314-airflow) |speed |
|speedFactor |[playerControl](#53165-playercontrol) |speFr |
|speedWash |[clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption) |speWh |
|spinLevelStrength |[spinLevel](#53184-spinlevel) |spLSh |
|spinSpeed |[blender](#531118-blender), [clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption) |spiSd |
|standardreferenceVoltage |[slcAlarm](#53179-slcalarm) |staVe |
|startPause |[operationMode](#53157-operationmode) |staPe |
|state |[dmAgent](#582-dmagent), [dmPackage](#588-dmpackage), [dmFirmware](#585-dmfirmware), [binarySwitch](#53112-binaryswitch) |state |
|status |[boiler](#53115-boiler), [disseminator](#53101-disseminator), [dmEventLog](#587-dmeventlog), [electricVehicleConnector](#53131-electricvehicleconnector), [emergencyHandler](#53102-emergencyhandler), [faultDetection](#53134-faultdetection), filterInf <mark>editor note: correct reference</mark>, [mediaSelect](#53153-mediaselect) |sus |
|steamTreat |[clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption) |steTt |
|step |[numberValue](#53155-numbervalue) |step |
|stepsPerPeriod |[cowActivityMonitor](#5371-cowactivitymonitor) |stPPd |
|stepValue |[audioVolume](#5318-audiovolume), [openLevel](#53156-openlevel), [temperature](#53187-temperature) |steVe |
|storageAvailable |[dmAgent](#582-dmagent) |stoAe |
|storageFault |[waterMeterAlarm](#53194-watermeteralarm)|stoFt |
|storageTotal |[dmAgent](#582-dmagent) |stoTl |
|strength |[brewing](#53116-brewing) |streh |
|subModel |[dmDeviceInfo](#583-dmdeviceinfo) |subMl |
|sulfide |[waterQualityMonitor](#53198-waterqualitymonitor) |sulfide |
|supportedHorizontalDirection |[airFlow](#5314-airflow) |suHDn |
|supportedMediaSources |[mediaSelect](#53153-mediaselect) |suMSs |
|supportedMessageValues |[textMessage](#53189-textmessage) |suMVs |
|supportedPlayerModes |[playerControl](#53165-playercontrol) |suPMs |
|supportedVerticalDirection |[airFlow](#5314-airflow) |suVDn |
|supportURL |[dmDeviceInfo](#583-dmdeviceinfo) |suURL |
|surplusCredit |[gasChargingControl](#53138-gaschargingcontrol) |surCt |
|surplusGas |[gasChargingControl](#53138-gaschargingcontrol) |surGs |
|switchStatus |[slcReportInfo](#53181-slcreportinfo) |swiSs |
|swVersion |[dmDeviceInfo](#583-dmdeviceinfo) |sweVn |
|systemTime |[dmAgent](#582-dmagent) |sysTe |
|systolicPressure |[sphygmomanometer](#53183-sphygmomanometer) |sysPe |
|tamperAlarm |[waterMeterAlarm](#53194-watermeteralarm)|tamAm |
|targetAltitude |[geoLocation](#53141-geolocation) |tarAe |
|targetDuration |[timer](#53190-timer) |tarDn |
|targetLatitude |[geoLocation](#53141-geolocation) |tarLe |
|targetLongitude |[geoLocation](#53141-geolocation) |tarL0 |
|targetTemperature |[temperature](#53187-temperature) |tarTe |
|targetTimeToStart |[timer](#53190-timer) |tTTSt |
|targetTimeToStop |[timer](#53190-timer) |tTTSp |
|telegramMessage |[baliseTransmissionModule](#5381-balisetransmissionmodule) |telMe |
|temperature |[airQualitySensor](#5316-airqualitysensor), [temperatureAlarm](#53188-temperaturealarm), [waterQualityMonitor](#53198-waterqualitymonitor) |tempe |
|temperatureThreshold <mark>This data point has been changed to two different data points</mark> |[temperatureAlarm](#53188-temperaturealarm) |temTd |
|textMessage |[textMessage](#53189-textmessage) |texMe |
|threeDDisplayResolutionX |[threeDDisplay](#531116-threeddisplay) |tDDRX |
|threeDDisplayResolutionY |[threeDDisplay](#531116-threeddisplay) |tDDRY |
|threeDDisplayType |[threeDDisplay](#531116-threeddisplay) |tDDTe |
|threeDDisplayViewAngle |[threeDDisplay](#531116-threeddisplay) |tDDVe |
|threeDGlasses |[threeDDisplay](#531116-threeddisplay) |thDGs |
|threeDScannerType |[threeDScanner](#531117-threedscanner) |tDSTe |
|threeDScanResolution |[threeDScanner](#531117-threedscanner) |tDSRn |
|time |[keepWarm](#53148-keepwarm) |time |
|timePlanStatus |[slcParameterSetting](#53180-slcparametersetting) |tiPSs |
|timer |[crossingBarrier](#531115-crossingbarrier) |timer |
|timeRange |[slcParameterSetting](#53180-slcparametersetting) |timRe |
|timeRangeCount |[slcParameterSetting](#53180-slcparametersetting) |tiRCt |
|timeRangeLightDimmingValue |[slcParameterSetting](#53180-slcparametersetting) |tRLDV |
|tn |[waterQualityMonitor](#53198-waterqualitymonitor) |tn |
|token |[credentials](#53127-credentials) |tk |
|tone |[alarmSpeaker](#5317-alarmspeaker) |tone |
|totalUseValue |[gasMeterReportInfo](#53140-gasmeterreportinfo) |toUVe |
|tp |[waterQualityMonitor](#53198-waterqualitymonitor) |tp |
|tsp |[airQualitySensor](#5316-airqualitysensor) |tsp |
|turboEnabled |[turbo](#53191-turbo) |turEd |
|type |[dmEventLog](#587-dmeventlog) |type |
|underCurrentAlarm |[slcAlarm](#53179-slcalarm) |unCAm |
|underCurrentDuration |[slcAlarm](#53179-slcalarm) |unCDn |
|underCurrentThreshold |[slcAlarm](#53179-slcalarm) |unCTd |
|underVoltageAlarm |[slcAlarm](#53179-slcalarm) |unVAm |
|underVoltageDuration |[slcAlarm](#53179-slcalarm) |unVDn |
|underVoltagePercent |[slcAlarm](#53179-slcalarm) |unVPt |
|underVoltageThreshold |[slcAlarm](#53179-slcalarm) |unVTd |
|unit |[temperature](#53187-temperature), [temperatureAlarm](#53188-temperaturealarm) |unit |
|updateTime |[cowActivityMonitor](#5371-cowactivitymonitor) |updTe |
|urgency |[disseminator](#53101-disseminator), [emergencyHandler](#53102-emergencyhandler) |urgey |
|urgencyButtonPush |[waterMeterAlarm](#53194-watermeteralarm)|urBPh |
|uri |[printQueue](#53167-printqueue) |ur0 |
|url |[sessionDescription](#53177-sessiondescription), [dmPackage](#588-dmpackage), [dmSoftware](#586-dmsoftware) |url |
|useBlender |[blender](#531118-blender)|useBr |
|useGrinder |[grinder](#53143-grinder) |useGr |
|uvStatus |[uvSensor](#53192-uvsensor) |uvtSs |
|uvValue |[uvSensor](#53192-uvsensor) |uvaVe |
|valveStatus |[gasMeterReportInfo](#53140-gasmeterreportinfo) |valSs |
|version |[dmPackage](#588-dmpackage), [dmSoftware](#586-dmsoftware) |versn |
|verticalAccuracy |[geoLocation](#53141-geolocation) |verAy |
|verticalDirection |[airFlow](#5314-airflow) |verDn |
|vibrationSensorFault |[waterMeterAlarm](#53194-watermeteralarm)|viSFt |
|visceraFat |[bioElectricalImpedanceAnalysis](#53113-bioelectricalimpedanceanalysis) |visFt |
|voc |[airQualitySensor](#5316-airqualitysensor) |voc |
|voltage |[battery](#53110-battery) |volte |
|voltage |[energyConsumption](#53132-energyconsumption) |volte |
|voltageFrequency |[slcReportInfo](#53181-slcreportinfo) |volFy |
|volumePercentage |[audioVolume](#5318-audiovolume) |volPe |
|washTemp |[clothesWasherJobModeOption](#53122-clotheswasherjobmodeoption) |wasTp |
|water |[bioElectricalImpedanceAnalysis](#53113-bioelectricalimpedanceanalysis) |water |
|waterFlowStrength |[waterFlow](#53193-waterflow) |waFSh |
|waterIntervalPressure |[waterMeterReportInfo](#53195-watermeterreportinfo) |waIPe |
|waterIntervalTemperature |[waterMeterReportInfo](#53195-watermeterreportinfo) |waITe |
|waterPressureInterval |[waterMeterSetting](#53196-watermetersetting) |waPIl |
|waterTemperatureInterval |[waterMeterSetting](#53196-watermetersetting) |waTIl |
|waterTemperatureSensorFault |[waterMeterAlarm](#53194-watermeteralarm)|wTSFt |
|weight |[weight](#53199-weight) |weigt |
|windDirection |[airQualitySensor](#5316-airqualitysensor) |winDn |
|windSpeed |[airQualitySensor](#5316-airqualitysensor), [anemometer](#531100-anemometer) |winSd |
|withdrawalStatus |[billWithdrawal](#531109-billwithdrawal) |witSs |
|zn |[waterQualityMonitor](#53198-waterqualitymonitor) |zn |



In protocol bindings resource attributes names for properties of sub-devices shall be translated into short names of Table 6.3.3-3.


**Table 6.3.3-3: Resource attribute short names (SubDevice properties)**

|		Attribute Name |Occurs in |Short Name |
|-|-|-|
|propAreaNwkType |[dmAreaNwkInfo](#589-dmareanwkinfo) |pANTe |




### 6.3.4 Resource attributes for actions arguments
In protocol bindings resource attributes names for arguments of actions shall be translated into short names of Table 6.3.4-1.

**Table 6.3.4-1: Resource attribute short names (Action arguments)**

|Argument Name |Occurs in |Short Name |
|-|-|-|
|address |[readIO](#584-dmdatamodelio), [writeIO](#584-dmdatamodelio) |addrs |
|name |[deployPackage](#582-dmagent) |name |
|payload |[writeIO](#584-dmdatamodelio) |payld |
|rebootType |[reboot](#582-dmagent) |rebTe |
|url |[deployPackage](#582-dmagent), [updateFirmware](#585-dmfirmware), [update](#588-dmpackage) |url |
|warningIdentifier | [disseminator](#53101-disseminator) |warIr |
|version |[deployPackage](#582-dmagent), [updateFirmware](#585-dmfirmware), [update](#588-dmpackage) |versn |




## 6.4 containerDefinition values

### 6.4.1 Introduction
Each specialization has a *containerDefinition* attribute which can be used as a unique identifier and contains the information of the resource. In this clause, the detailed values of *containerDefinition* attributes in every specializations for the harmonized information model are given.  

The full list of domains is:

"agriculture", "city", "common", "health", "home", "industry", "management", "metadata", "publicsafety", "railway" and "vehicular". 


### 6.4.2 Device models
Depending on the domain, the *containerDefinition* attribute of specializations for device models shall have the values that comply with the following rule.  

- Rule: "org.onem2m.[domain].device.[device name]", where [domain] is one of the domain names defined in [6.4.1](#641-introduction). The name is chosen according to the domain in which the device is defined.

For example, the *containerDefinition* attribute of the specialization for the "[deviceAirConditioner](#5541-deviceairconditioner)" device of the "home" domain shall be "org.onem2m.home.device.deviceAirConditioner".


### 6.4.3 ModuleClasses
Depending on the domain, the *containerDefinition* attribute of specializations for module classes shall have the values that comply with the following rule.  

- Rule: "org.onem2m.[domain].moduleclass.[moduleclass name]", where [domain] is one of the domain names defined in [6.4.1](#641-introduction). The name is chosen according to the domain in which the module class is defined.

For example, the *containerDefinition* attribute of the specialization for the "[alarmSpeaker](#5317-alarmspeaker)" module class of the "common" domain shall be "org.onem2m.common.moduleclass.alarmSpeaker", the *containerDefinition* attribute of the specialization for the "[dmAgent](#582-dmagent)" module class of the "management" domain shall be "org.onem2m.management.moduleclass.dmAgent".


### 6.4.4 Actions
Depending on the domain, the *containerDefinition* attribute of specializations for actions shall have the values that comply with the following rule:

- Rule: "org.onem2m.[domain].action.[action name]", where [domain] is one of the domain names defined in [6.4.1](#641-introduction). The name is chosen according to the domain in which the action is defined.

For example, the *containerDefinition* attribute of the specialization for "[activateClockTimer](#53190-timer)" action in the "[timer](#53190-timer)" module class of the "common" domain shall be "org.onem2m.common.action.activateClockTimer", the *containerDefinition* attribute of the specialization for the "[activate](#586-dmsoftware)" action of the "[dmSoftware](#586-dmsoftware)" ModuleClass of the "management" domain shall be "org.onem2m.management.action.activate".


### 6.4.5 SubDevices
Depending on the domain, the *containerDefinition* attribute of specializations for sub-devices shall have the values that comply with the following rule:

-    Rule: "org.onem2m.[domain].subdevice.[subDevice name]", where [domain] is one of the following names: "agriculture", "city", "common", "health", "home", "industry", "railway", "vehicular" and "management". The name is chosen according to the domain in which the sub-device is defined.

For example, the *containerDefinition* attribute of specialization for "subDevicePowerOutlet" of the "common" domain shall be "org.onem2m.common.subdevice.subDevicePowerOutlet", the *containerDefinition* attribute of the specialization for the "[dmAreaNwkInfo](#589-dmareanwkinfo)" for the "management" domain shall be "org.onem2m. management.subdevice.dmAreaNwkInfo".




## 6.5 XSD definitions

### 6.5.1 Introduction
The present clause specifies how to name the files which define data types in XSD for Device and SubDevice models, ModuleClasses, Actions and enumerated types.

Seven SDT domains correspond to different vertical, economic domains (Agriculture, Smart City, Health, Home, Industry, Public Safety, Railway, Vehicular), they contain devices and modules that are specific to these domains.

Management domain contains transversal, Device Management modules, Metadata domain contains transversal, meta-information modules, Horizontal is only for enumerated types and Common is the domain that gathers devices and modules that do not pertain to a specific domain but are re-usable anywhere.

The following table defines the short names for XML name spaces and file name prefix.

**Table 6.5.1-1: Short names for the XML name spaces**


|Domain |XML Name Space |Domain Prefix |URI |
|-|-|-|-|
|Agriculture |xmlns:agd |AGD |http://www.onem2m.org/xml/protocols/agriculturedomain |
|City |xmlns:cid |CID |http://www.onem2m.org/xml/protocols/citydomain |
|Common |xmlns:cod |COD |http://www.onem2m.org/xml/protocols/commondomain |
|Health |xmlns:hed |HED |http://www.onem2m.org/xml/protocols/healthdomain |
|Home |xmlns:hod |HOD |http://www.onem2m.org/xml/protocols/homedomain |
|Horizontal |xmlns:hd |HD |http://www.onem2m.org/xml/protocols/horizontaldomain |
|Industry |xmlns:ind |IND |http://www.onem2m.org/xml/protocols/industrydomain |
|Management |xmlns:mad |MAD |http://www.onem2m.org/xml/protocols/managementdomain |
|Metadata |xmlns:mdd |MDD |http://www.onem2m.org/xml/protocols/metadatadomain |
|PublicSafety |xmlns:psd |PSD |http://www.onem2m.org/xml/protocols/publicsafetydomain |
|Railway |xmlns:rad |RAD |http://www.onem2m.org/xml/protocols/railwaydomain |
|Vehicular |xmlns:ved |VED |http://www.onem2m.org/xml/protocols/vehiculardomain |




### 6.5.2 XSD definitions for Device models
The XSD definitions for Device models are specified upon the following rule:

- Rule: [Domain Prefix]-[device name]-v&lt;TS-version>.xsd where the string '&lt;TS-version>' shall be interpreted as the version of the present document.

For example, the XSD definition for "[deviceAirConditioner](#5541-deviceairconditioner)" specified in TS-0023 v4.3.0 shall be "HOD-deviceAirConditioner-v4_3_0.xsd".


### 6.5.3 XSD definitions for ModuleClass
The XSD definitions for ModuleClass are specified upon the following rule:

- Rule: [Domain Prefix]-mod-[ModuleClass name]-v&lt;TS-version>.xsd where the string '&lt;TS-version>' shall be interpreted as the version of the present document. 

For example, the XSD definition for "[alarmSpeaker](#5317-alarmspeaker)" specified in TS-0023 v4.3.0 shall be "COD-mod-alarmSpeaker-v4_3_0.xsd".


### 6.5.4 XSD definitions for Action
The XSD definitions for Actions are specified upon the following rule:

- Rule: [Domain Prefix]-act-[action name]-v&lt;TS-version>.xsd where the string '&lt;TS-version>' shall be interpreted as the version of the present document.

For example, the XSD definition for "[activateClockTimer](#53190-timer)" specified in TS-0023 v4.3.0 shall be "HOD-act- activateClockTimer -v4_3_0.xsd".


### 6.5.5 XSD definitions for SubDevices
The XSD definitions for SubDevices are specified upon the following rule:

- Rule: [Domain Prefix]-[SubDevice name]-v&lt;TS-version>.xsd where the string '&lt;TS-version>' shall be interpreted as the version of the present document.

For example, the XSD definition for "subDeviceCuff" specified in TS-0023 v4.3.0 shall be "COD-subDeviceCuff-v4_3_0.xsd".


### 6.5.6 XSD definitions for Enumerated Types
The XSD definitions for enumerated types are specified upon the following rule:

- Rule: HD-enumerationTypes-v&lt;TS-version>.xsd where the string '&lt;TS-version>' shall be interpreted as the version of the present document.

This file contains the definitions of all enumerated types, and nothing else.



# 7 Mapping with Other Information Models from External Organizations

## 7.0 Introduction

This clause specifies how the Harmonized Information Model (HIM) defined in the clause [5](#5-harmonised-information-model) of the present document can be mapped with existing external models from , OCF, ECHONET, OMA GotAPI etc. and introduction of these models is written in annex B. The mapping shall be  to enable the interworking between the oneM2M system and external technologies at the information model level. This means a oneM2M native application which understand only the oneM2M HIM shall be able to interact with non-oneM2M appliances of different technologies in a consistent way without knowing the technology specific details. An IPE shall be responsible for translating the HIM to/from technology specific information model bidirectionally following the mapping specification in this clause. Using HIM as a bridge, appliances and applications of different technologies shall be able to  also interact with each other via the oneM2M system (with IPEs).


## 7.1 OMA GotAPI(DWAPI)

### 7.1.1 Introduction
The following clauses are intended to specify the mapping relationship between HAIM and OMA DWAPI with tables.

OMA Device Web Application Programming Interface (DWAPI)) <a href="#_ref_7">[7]</a> is based on OMA Generic Open Terminal Application Programming Interface (GotAPI) <a href="#_ref_19">[19]</a>  and supports Personal Healthcare Devices (DWAPI-PCH) and 3D printer (DWAPI-3DP).

OMA DWAPI has no concept  that corresponds to ModuleClass in oneM2M. The mappings of DataPoints to data objects of OMA DWAPI are expressed in following clauses.


### 7.1.2 Device Models

#### 7.1.2.1 device3Dprinter
The [device3DPrinter](#5511-device3dprinter) of HAIM shall be mapped to 3D printer of OMA DWAPI-3DP on the basis of Table 7.1.2.1-1.

**Table 7.1.2.1-1: Map of device3Dprinter of oneM2M HAIM to OMA DWAPI-3DP**

|ModuleClass |Data Points of oneM2M HAIM |data objects of OMA DWAPI-3DP |Description |
|-|-|-|-|
|[binarySwitch](#53112-binaryswitch) |state |- |See clause [5.3.1.12](#53112-binaryswitch).<br />The "state" is not supported in OMA DWAPI-3DP data object. The power state is assumed power-on in OMA DWAPI-3DP. |
|[faultDetection](#53134-faultdetection) |code |operatingStatus |See clause [5.3.1.34](#53134-faultdetection).<br />It shall be the integer type at HAIM, but shall be the string type at OMA DWAPI-3DP. See the Table 7.1.2-2 . |
|[threeDprinter](#5311-threedprinter) |printType |printType |See clause [5.3.1.1](#5311-threedprinter). |
|[threeDprinter](#5311-threedprinter) |printSizeX |printSizeX |See clause [5.3.1.1](#5311-threedprinter). |
|[threeDprinter](#5311-threedprinter) |printSizeY |printSizeY |See clause [5.3.1.1](#5311-threedprinter). |
|[threeDprinter](#5311-threedprinter) |printSizeZ |printSizeZ |See clause [5.3.1.1](#5311-threedprinter). |
|[threeDprinter](#5311-threedprinter) |network |network |See clause [5.3.1.1](#5311-threedprinter). |
|[threeDprinter](#5311-threedprinter) |memorySize |memorySize |See clause [5.3.1.1](#5311-threedprinter). |
|[runState](#53175-runstate) |currentMachineState |operatingStatus |See clause [5.3.1.75](#53175-runstate).<br />This value represents the machineState of the 3D printer itself.  This value SHALL be interpreted by using hd:enumMachineState and generated operatingStatus as a string.<br />See the Table 7.1.2-2 .  |
|[temperature](#53187-temperature) |currentTemperature |nozzleTemp |See clause [5.3.1.87](#53187-temperature).<br />This value represents the temperature of the nozzle. This value SHALL be a float number in a range from 0,0 to 1 000,0.<br />The unit is C. |
|[printQueue](#53167-printqueue) |uri |uri |See clause [5.3.1.67](#53167-printqueue). |
|[printQueue](#53167-printqueue) |printingState |msg |See clause [5.3.1.67](#53167-printqueue).<br />This value represents the machineState of the queued printing job. This value shall be interpreted by using hd:enumMachineState and generated msg as a string.<br />See the Table 7.1.2-3.  |



**Table 7.1.2.1-2: Map of hd:enumMachineState of oneM2M HAIM to operatingStatus of OMA DWAPI-3DP**

|Value |Interpretation |operatingStatus of OMA DWAPI-3DP |Note |
|-|-|-|-|
|1 |idle |RDY |Ready to use |
|2 |preActive | |Not available |
|3 |active |RUN |Under printing operation |
|4 |reserved | |Not available |
|5 |stopped | |Not available |
|6 |error |MAN |Maintenance needed |
|7 |diagnostic | |Not available |
|8 |test | |Not available |
|9 |maintenance |MAN |Maintenance needed |
|10 |clear |CLR |Printing completed but the result is not removed yet |
|11 |charging | |Not available |



**Table 7.1.2-1-3: Map of hd:enumJobState of oneM2M HAIM to msg of OMA DWAPI-3DP**

|Value |Interpretation |msg of OMA DWAPI-3DP |Note |
|-|-|-|-|
|1 |aborted | |Not available |
|2 |cancelled | |Not available |
|3 |completed |Completed | |
|4 |paused |Waiting | |
|5 |pending |Waiting | |
|6 |processing |Good Start | |




#### 7.1.2.2 deviceBloodPressureMonitor
DeviceBloodPressureMonitor of HAIM shall be mapped to Blood Pressure Monitor of OMA DWAPI-PCH on the basis of Table 7.1.2.2-1. 

**Table 7.1.2-2-1: Map of deviceBloodPressureMonitor of oneM2M HAIM to OMA DWAPI-PCH**

|ModuleClass |DataPoints of oneM2M HAIM |data objects of OMA DWAPI-PCH |Description |
|-|-|-|-|
|[sphygmomanometer](#53183-sphygmomanometer) |diastolicPressure  |diastolic |See clause [5.3.1.83](#53183-sphygmomanometer). |
|[sphygmomanometer](#53183-sphygmomanometer) |systolicPressure |systolic |See clause [5.3.1.83](#53183-sphygmomanometer). |
|[sphygmomanometer](#53183-sphygmomanometer) |meanPressure |mean |See clause [5.3.1.83](#53183-sphygmomanometer). |
|[pulsemeter](#53168-pulsemeter) |pulseRate |pulse |See clause [5.3.1.68](#53168-pulsemeter). |
|[battery](#53110-battery) |level |batteryLevel |See clause [5.3.1.10](#53110-battery).<br />It shall be the integer type at HAIM, but shall be the float type at OMA DWAPI-PCH.<br />It shall be the rounded percentage of the current level of battery in the range of [0, 100] at HAIM, but shall be a float number in the range of [0,0, 1,0] atOMA DWAPI-PCH. |


#### 7.1.2.3 deviceGlucosemeter
DeviceGlucometer of HAIM shall be mapped to Glucometer of OMA DWAPI-PCH on the basis of Table 7.1.2.3-1. 

**Table 7.1.2.3-1: Map of deviceGlucometer of oneM2M HAIM to OMA DWAPI-PCH**

|ModuleClass |DataPoints of oneM2M HAIM |data objects of OMA DWAPI-PCH |Description |
|-|-|-|-|
|[glucometer](#53142-glucometer) |concentration |concentration |See clause [5.3.1.42](#53142-glucometer). |
|[glucometer](#53142-glucometer) |hba1c |hba1c |See clause [5.3.1.42](#53142-glucometer). |
|[glucometer](#53142-glucometer) |contextExercise |contextExercise |See clause [5.3.1.42](#53142-glucometer). |
|[glucometer](#53142-glucometer) |contextMedication |contextMedication |See clause [5.3.1.42](#53142-glucometer). |
|[glucometer](#53142-glucometer) |contextCarbohydratesAmount |contextCarbohydrates |See clause [5.3.1.42](#53142-glucometer). |
|[glucometer](#53142-glucometer) |contextCarbohydratesSource |contextCarbohydrates |See clause [5.3.1.42](#53142-glucometer). |
|[glucometer](#53142-glucometer) |contextMeal |contextMeal |See clause [5.3.1.42](#53142-glucometer). |
|[glucometer](#53142-glucometer) |contextLocation |contextLocation |See clause [5.3.1.42](#53142-glucometer). |
|[glucometer](#53142-glucometer) |contextTester |contextTester |See clause [5.3.1.42](#53142-glucometer). |
|[glucometer](#53142-glucometer) |contextHealth |contextHealth |See clause [5.3.1.42](#53142-glucometer). |
|[battery](#53110-battery) |level |batteryLevel |See clause [5.3.1.10](#53110-battery).<br />It shall be the integer type at HAIM, but shall be the float type at OMA DWAPI-PCH.<br />It shall be the rounded percentage of the current level of battery in the range of [0, 100] at HAIM, but shall be a float number in the range of [0,0, 1,0] atOMA DWAPI-PCH. |




#### 7.1.2.4 devicePulseOximeter
DevicePulseOximeter of HAIM shall be mapped to Pulse Oximeter of OMA DWAPI-PCH on the basis of Table 7.1.2.4-1. 

**Table 7.1.2.4-1: Map of devicePulseOximeter of oneM2M HAIM to OMA DWAPI-PCH**

|ModuleClass |DataPoints of oneM2M HAIM |data objects of OMA DWAPI-PCH |Description |
|-|-|-|-|
|[pulsemeter](#53168-pulsemeter) |modality |spo2, pulse |See clause [5.3.1.68](#53168-pulsemeter).<br />When "[oximeter](#53159-oximeter)" module does not exist, "[pulsemeter](#53168-pulsemeter)" module is mandatory. |
|[oximeter](#53159-oximeter) |modality |spo2, pulse |See clause [5.3.1.59](#53159-oximeter).<br />When "[pulsemeter](#53168-pulsemeter)" module does not exist, ""[oximeter](#53159-oximeter)" module is mandatory. |
|[battery](#53110-battery) |level |batteryLevel |See clause [5.3.1.10](#53110-battery).<br />It shall be the integer type at HAIM, but shall be the float type at OMA DWAPI-PCH.<br />It shall be the rounded percentage of the current level of battery in the range of [0, 100] at HAIM, but shall be a float number in the range of [0,0, 1,0] atOMA DWAPI-PCH. |




#### 7.1.2.5 deviceThermometer
DeviceThermometer of HAIM shall be mapped to Thermometer of OMA DWAPI-PCH on the basis of Table 7.1.2.5-1. 

**Table 7.1.2.5-1: Map of deviceThermometer of oneM2M HAIM to OMA DWAPI-PCH**

|ModuleClass |Data Points of oneM2M HAIM |data objects of OMA DWAPI-PCH |Description |
|-|-|-|-|
|[temperature](#53187-temperature) |unit |temperature |See clause [5.3.1.87](#53187-temperature). |
|[battery](#53110-battery) |level |batteryLevel |See clause [5.3.1.10](#53110-battery).<br />It shall be the integer type at HAIM, but shall be the float type at OMA DWAPI-PCH.<br />It shall be the rounded percentage of the current level of battery in the range of [0, 100] at HAIM, but shall be a float number in the range of [0,0, 1,0] atOMA DWAPI-PCH. |




#### 7.1.2.6 deviceWeightScaleAndBodyCompositionAnalyser
DeviceWeightScaleAdBodyCompositionAnalyser of HAIM shall be mapped to Weight Scale Body Composition Analyser of OMA DWAPI-PCH on the basis of Table . 

**Table 7.1.2.6-1: Map of deviceWeightScaleAdBodyCompositionAnalyser of oneM2M HAIM to OMA DWAPI-PCH**

|ModuleClass |DataPoints of oneM2M HAIM |data objects of OMA DWAPI-PCH |Description |
|-|-|-|-|
|[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |bodyLength |bodyLength |See clause [5.3.1.14](#53114-bodycompositionanalyser). |
|[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |Bmi |bmi |See clause [5.3.1.14](#53114-bodycompositionanalyser). |
|[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |fatFreeMass |fatFreeMass |See clause [5.3.1.14](#53114-bodycompositionanalyser). |
|[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |softLeanMass |softLeanMass |See clause [5.3.1.14](#53114-bodycompositionanalyser). |
|[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |muscleMass |muscleMass |See clause [5.3.1.14](#53114-bodycompositionanalyser). |
|[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |basalMetabolism |basalMetabolism |See clause [5.3.1.14](#53114-bodycompositionanalyser). |
|[bodyCompositionAnalyser](#53114-bodycompositionanalyser) |impedance |impedance |See clause [5.3.1.14](#53114-bodycompositionanalyser). |
|[weight](#53199-weight) |weight |bodyMass |See clause [5.3.1.99](#53199-weight). |
|[bioElectricalImpedanceAnalysis](#53113-bioelectricalimpedanceanalysis) |water |bodyWater |See clause [5.3.1.13](#53113-bioelectricalimpedanceanalysis). |
|[bioElectricalImpedanceAnalysis](#53113-bioelectricalimpedanceanalysis) |fat |bodyFat |See clause [5.3.1.13](#53113-bioelectricalimpedanceanalysis). |
|[bioElectricalImpedanceAnalysis](#53113-bioelectricalimpedanceanalysis) |muscle |musclePercentage |See clause [5.3.1.13](#53113-bioelectricalimpedanceanalysis). |
|[battery](#53110-battery) |level |batteryLevel |See clause [5.3.1.10](#53110-battery).<br />It shall be the integer type at HAIM, but shall be the float type at OMA DWAPI-PCH.<br />It shall be the rounded percentage of the current level of battery in the range of [0, 100] at HAIM, but shall be a float number in the range of [0,0, 1,0] at OMA DWAPI-PCH. |




#### 7.1.2.7 deviceHeartRateMonitor
DeviceHeartRateMonitor of HAIM shall be mapped to Heart Rate Monitor of OMA DWAPI-PCH on the basis of Table 7.1.2.7-1. 

**Table 7.1.2.7-1: Map of deviceHeartRateMonitor of oneM2M HAIM to OMA DWAPI-PCH**

|ModuleClass |DataPoints of oneM2M HAIM |data objects of OMA DWAPI-PCH |Description |
|-|-|-|-|
|[pulsemeter](#53168-pulsemeter) |pulseRate |rate |See clause [5.3.1.68](#53168-pulsemeter). |
|[pulsemeter](#53168-pulsemeter) |rr |rr |See clause [5.3.1.68](#53168-pulsemeter). |
|[pulsemeter](#53168-pulsemeter) |energy |energy |See clause [5.3.1.68](#53168-pulsemeter). |
|[battery](#53110-battery) |level |batteryLevel |See clause [5.3.1.10](#53110-battery).<br />It shall be the integer type at HAIM, but shall be the float type at OMA DWAPI-PCH.<br />It shall be the rounded percentage of the current level of battery in the range of [0, 100] at HAIM, but shall be a float number in the range of [0,0, 1,0] atOMA DWAPI-PCH. |




### 7.1.3 Data Types
Data types of oneM2M HAIM and OMA DWAPI-PCH shall be mapped each other on the basis of Table 7.1.3-1.

**Table 7.1.3-1: Map of data types between oneM2M and OMA DWAPI-PCH**

|oneM2M data type |Mapping to data type in OMA DWAPI |Description |
|-|-|-|
|xs:integer |int, number, string |Data type for 32-bit signed integer.<br /><br />For indicating 3D printerState, the integer value should be interpreted into string by referring the tables in clause [7.1.2.1](#7121-device3dprinter) .  |
|xs:string |string, array |Data type for text. The length limitation should be considered for the mapping. |
|xs:float |float |Data type for a single precision 32-bit floating point type as defined in XML Schema 1.0 <a href="#_ref_14">[14]</a> as the float primitive type. |
|xs:boolean |boolean |Data type for Boolean. |




# 8 Ontology for the Harmonized Information Model aligned with oneM2M Base Ontology
The following table shows a mapping of the Harmonized Information Model (HIM) to the oneM2M Base Ontology in oneM2M TS-0012 <a href="#_ref_i.5">[i.5]</a>. 

Table 8-1 only shows mapping of SDT concepts that are used to classify all concepts in the HIM. Therefore, since any concept in the HIM can be classified according to a specific SDT concept it also (transitively) maps to the related class of the oneM2M Base Ontology.

**Table 8-1: Mapping between SDT concepts in the Harmonized Information Model <br />and the oneM2M Base Ontology**

|SDT Concept in the Harmonized Information Model |Mapping relationship | Class in Base Ontology |Property in Base Ontology |Comment |
|-|-|-|-|-|
|SDT: Device |sub-class of |Device | | |
|SDT: SubDevice |sub-class of |Device | |The base ontology allows a Device to consist of (sub-) Devices |
|SDT: Action |sub-class of |Operation | | |
|SDT: Args (of an Action) |sub-class of |OperationInput | | |
|SDT: ReturnType (of an Action) |sub-class of |OperationOutput | | |
|SDT: Event |sub-class of |Operation | | |
|SDT: Data (of an Event) |sub-class of |OutputDataPoint | | |
|SDT: Module |sub-class of |Service | |The base ontology allows a Service to have subServices. Each SDT:Module implements one SDT:ModuleClass. <br />Therefore  SDT:Module can be considered a subclass of SDT:ModuleClass and therefore subclass of oneM2M:Service.<br />See note.  |
|SDT: ModuleClass |sub-class of |Service | |See note  |
|SDT: UnitOfMeasure |sub-class of |MetaData | | |
|SDT: DataPoint |sub-class of |InputDataPoint | |If  SDT:DataPoint is writeable |
|SDT: DataPoint |sub-class of |OutputDataPoint | |If  SDT:DataPoint is readable  |
|SDT: Property (of a Device) |sub-class of |ThingProperty | | |
|SDT: Property (of a ModuleClass) |sub-class of |Aspect  | |Aspect  (of the Functionality) |
|SDT: SimpleType |sub-property of | |hasDataType |The base ontology's SimpleTypeVariable class has data properties: <br />hasDataType<br />hasDataRestriction |
|SDT: Constraint |sub-property of | |hasDataRestriction | |



NOTE: In RESTful technologies the Service (i.e. the electronic representation of a Functionality in a network) is implicitly bound to its Functionality by the naming of the used resources (e.g. the Functionality of ModuleClass "[audioVolume](#5318-audiovolume)" is implemented as a Service through CRUD operations on a [audioVolume] &lt;flexContainer> specialization).




# Annex A (informative):  Resource Mapping Examples

## A.1 Introduction
The AE may construct oneM2M resource tree on hosting CSE as the mapping of associated device, and each XSD definition for the device information models is generated following 'Resource Mapping Rule' in clause [6.2](#62-the-resource-mapping-rules).

The present clause explains how to use the oneM2M resource tree to map Device model for each device (see clause [5.5](#55-device-models)).


## A.2 Example for Device model 'deviceAirConditioner'
The present clause explains the creation process for the device typed '[deviceAirConditioner](#5541-deviceairconditioner)' (see clause [5.5.4.1](#5541-deviceairconditioner) for device model definition of 'deviceAirConditioner').

Using the definition, '[deviceAirConditioner](#5541-deviceairconditioner)' model is mapped to [deviceAirConditioner] resource which is a specialization of &lt;flexContainer> resource (see Figure A.2-1).



![deviceAirConditioner](media/deviceAirConditioner.svg)

**Figure A.2-1: Structure of [deviceAirConditioner] resource**


The AE creates the [[deviceAirConditioner](#5541-deviceairconditioner)] specialization of &lt;flexContainer> resource for the Device model [[deviceAirConditioner](#5541-deviceairconditioner)] resource.

The [[deviceAirConditioner](#5541-deviceairconditioner)] resource contains the child resource specified in Table A.2-1.

**Table A.2-1: Child resources of [deviceAirConditioner] resource**

|Child Resources of [deviceAirConditioner] |Child Resource Type |Multiplicity |Description |
|-|-|-|-|
|[variable] |&lt;flexContainer> as defined in the specialization [[binarySwitch](#53112-binaryswitch)] |0..1 |This resource is used to map 'binarySwitch' ModuleClass defined in clause [5.3.1.12](#53112-binaryswitch). |
|[variable] |&lt;flexContainer> as defined in the specialization [[runState](#53175-runstate)] |0..1 |This resource is used to map 'runState' ModuleClass defined in clause [5.3.1.75](#53175-runstate). |
|[variable] |&lt;flexContainer> as defined in the specialization [[airConJobMode](#5313-airconjobmode)] |0..1 |This resource is used to map '[airConJobMode](#5313-airconjobmode)' ModuleClass defined in clause [5.3.1.3](#5313-airconjobmode). |
|[variable] |&lt;flexContainer> as defined in the specialization [[airConOperationMode](#53157-operationmode)] |0..1 |This resource is used to map '[airConOperationMode](#53157-operationmode)' ModuleClass defined in clause [5.3.1.57](#53157-operationmode). |
|[variable] |&lt;flexContainer> as defined in the specialization [[airCleanOperationMode](#53157-operationmode)] |0..1 |This resource is used to map '[airCleanOperationMode](#53157-operationmode)' ModuleClass defined in clause [5.3.1.57](#53157-operationmode). |
|[variable] |&lt;flexContainer> as defined in the specialization [[temperature](#53187-temperature)] |0..1 |This resource is used to map 'temperature' ModuleClass defined in clause [5.3.1.87](#53187-temperature). |
|[variable] |&lt;flexContainer> as defined in the specialization [[timer](#53190-timer)] |0..1 |This resource is used to map '[timer](#53190-timer)' ModuleClass defined in clause [5.3.1.90](#53190-timer). |
|[variable] |&lt;flexContainer> as defined in the specialization [[sleepTimer](#53190-timer)] |0..1 |This resource is used to map '[sleepTimer](#53190-timer)' ModuleClass defined in clause [5.3.1.90](#53190-timer). |
|[variable] |&lt;flexContainer> as defined in the specialization [[turbo](#53191-turbo)] |0..1 |This resource is used to map 'turbo' ModuleClass defined in clause [5.3.1.91](#53191-turbo). |
|[variable] |&lt;flexContainer> as defined in the specialization [[airFlow](#5314-airflow)] |0..1 |This resource is used to map 'airFlow' ModuleClass defined in clause [5.3.1.4](#5314-airflow). |
|[variable] |&lt;flexContainer> as defined in the specialization [[powerSave](#53166-powersave)] |0..1 |This resource is used to map 'powerSave' ModuleClass defined in clause [5.3.1.66](#53166-powersave). |
|[variable] |&lt;flexContainer> as defined in the specialization [[airQualitySensor](#5316-airqualitysensor)] |0..1 |This resource is used to map 'airQualitySensor' ModuleClass defined in clause [5.3.1.6](#5316-airqualitysensor). |
|[variable] |&lt;flexContainer> as defined in the specialization [[filterInfo](#53135-filterinfo)] |0..1 |This resource is used to map 'filterInfo' ModuleClass defined in clause [5.3.1.35](#53135-filterinfo). |
|[variable] |&lt;subscription> |0..n |See clause 9.6.8 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a> |

The [[deviceAirConditioner](#5541-deviceairconditioner)] resource contains the attributes specified in Table A.2-2.


**Table A.2-2: Attributes of [deviceAirConditioner] resource**

|Attributes of [deviceAirConditioner] |Multiplicity |RW/RO/WO |Description |
|-|-|-|-|
|resourceType |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|resourceID |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|resourceName |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|parentID |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|expirationTime |1 |RW |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|accessControlPolicyIDs |0..1 (L) |RW |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|creationTime |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|lastModifiedTime |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|labels |0..1 |RW |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|dynamicAuthorizationConsultationIDs |0..1 (L) |RW |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>. |
|stateTag |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3].</a> |
|creator |0..1 |RW |See clause 9.6.35 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>. |
|containerDefinition |1 |WO |The value is "org.onem2m.home.device.airconditioner". |
|ontologyRef |0..1 |RW |See clause 9.6.35 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>. |
|contentSize |1 |RO |See clause 9.6.35 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>. |
|nodeLink |0..1 |RO |nodeLink attribute links to a &lt;node> resource that is hosted on the same hosting CSE of the &lt;flexContainer>. See clause 6.2.2 and 6.2.5 for more details. |




## A.3 Example of ModuleClass 'binarySwitch'
The [[binarySwitch](#53112-binaryswitch)] resource is used to share information regarding the modelled binary switch module as a ModuleClass. The [binarySwitch] resource is a specialization of the &lt;flexContainer> resource.



![binarySwitch](media/binarySwitch.svg)

**Figure A.3-1: Structure of [binarySwitch] resource**


The [[binarySwitch](#53112-binaryswitch)] resource contains the child resource specified in Table A.3-1.

**Table A.3-1: Child resources of [binarySwitch] resource**

|Child Resources of [binarySwitch] |Child Resource Type |Multiplicity |Description |
|-|-|-|-|
|[variable] |&lt;flexContainer> as defined in the specialization [[toggle](#53112-binaryswitch)] |0..1 |This resource is used to map 'toggle' Action defined in clause [5.3.1.12](#53112-binaryswitch). |
|[variable] |&lt;subscription> |0..n |See clause 9.6.8 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>. |



The [[binarySwitch](#53112-binaryswitch)] resource contains the attributes specified in Table A.3-2.

**Table A.3-2: Attributes of [binarySwitch] resource**

|Attributes of [binarySwitch] |Multiplicity |RW/RO/WO |Description |
|-|-|-|-|
|resourceType |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|resourceID |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|resourceName |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3].</a>  |
|parentID |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|expirationTime |1 |RW |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|accessControlPolicyIDs |0..1 (L) |RW |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3].</a>  |
|creationTime |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|lastModifiedTime |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3].</a>  |
|labels |0..1 |RW |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3].</a>  |
|dynamicAuthorizationConsultationIDs |0..1 (L) |RW |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3].</a> |
|stateTag |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3].</a> |
|creator |0..1 |RW |See clause 9.6.35 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>. |
|containerDefinition |1 |WO |The value is "org.onem2m.home.moduleclass.binaryswitch" |
|ontologyRef |0..1 |RW |See clause 9.6.35 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a> |
|contentSize |1 |RO |See clause 9.6.35 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>. |
|nodeLink |0..1 |RW |Not applicable to a ModuleClass specialization. This attribute is not present in an instantiation of this resource. |
|dataGenerationTime |0..1 |RO |See clause [6.2.3](#623-resource-mapping-for-moduleclass). |
|state |1 |RW |See clause [5.3.1.12](#53112-binaryswitch). |




## A.4 Example of Action 'toggle'
The [[toggle](#53112-binaryswitch)] resource is used to share information regarding the modelled toggle as an Action. The [[toggle](#53112-binaryswitch)] resource is a specialization of the &lt;flexContainer> resource.



![toggle](media/toggle.svg)

**Figure A.4-1: Structure of [toggle] resource**


The [[toggle](#53112-binaryswitch)] resource contains the child resource specified in Table A.4-1.

**Table A.4-1: Child resources of [toggle] resource**

|Child Resources of [toggle] |Child Resource Type |Multiplicity |Description |
|-|-|-|-|
|[variable] |&lt;subscription> |0..n |See clause 9.6.8 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a> |



The [[toggle](#53112-binaryswitch)] resource contains the attributes specified in Table A.4-2.

**Table A.4-2: Attributes of [toggle] resource**

|Attributes of [toggle] |Multiplicity |RW/RO/WO |Description |
|-|-|-|-|
|resourceType |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|resourceID |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|resourceName |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3].</a>  |
|parentID |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|expirationTime |1 |RW |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|accessControlPolicyIDs |0..1 (L) |RW |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3].</a>  |
|creationTime |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|lastModifiedTime |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>.  |
|labels |0..1 |RW |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3].</a>  |
|dynamicAuthorizationConsultationIDs |0..1 (L) |RW |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>. |
|stateTag |1 |RO |See clause 9.6.1.3 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3].</a> |
|creator |0..1 |RW |See clause 9.6.35 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3].</a> |
|containerDefinition |1 |WO |The value is "org.onem2m.home.moduleclass.binaryswitch.toggle". |
|ontologyRef |0..1 |RW |See clause 9.6.35 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3].</a> |
|contentSize |1 |RO |See clause 9.6.35 in oneM2M TS-0001 <a href="#_ref_i.3">[i.3]</a>. |
|nodeLink |0..1 |RW |Not applicable to an Action specialization. This attribute is not present in an instantiation of this resource. |




# Annex B (informative):  Introduction of External Organizations' Data Models

## B.1 OMA Got API (DWAPI-PCH)
OMA GotAPI(OMA Generic Open Terminal API Framework) provides the framework to enable applications and multi-type devices through GotAPI Servers and Extension Plug-Ins <a href="#_ref_6">[6]</a>. When APIs are implemented in Extension Plug-Ins under the GotAPI framework, these APIs are called as OMA Device WebAPIs Enabler. In case of healthcare devices, these APIs are called as OMA Device WebAPIs for Personal Connected Healthcare (DWAPI-PCH).

Healthcare devices can be a one of the smart home devices so OMA DWWAPI-PCH can have relationship with oneM2M SDT. 


## B.2 OCF
### B.2.1 Introduction

OCF specifications provide a common, open connectivity framework for embedded developers that enables a common device discovery and interaction model, common data model and a robust security framework whilst abstracting away the physical connectivity hardware (and related protocols).

OCF Device Specification <a href="#_ref_i.8">[i.8]</a> defines list of smart home devices. Each smart home device contains a unique identifier and list of mandatory/optional resources. Each resource definition contains a unique identifier, identification of the default interface and other supported interfaces, list of supported methods, list of allowed actions and list of the mandatory/optional property(-ies) the resource exposes.

This clause specifies the mapping relationship between oneM2M and OCF Devices.


### B.2.2 Device Type Mapping
Table B.2.2-1 captures the equivalency mapping between OCF defined Device Types and oneM2M defined Devices. The minimum module sets for each oneM2M device is provided in the present document. The minimum resource sets for each OCF Device is provided in the OCF Device Specification <a href="#_ref_i.8">[i.8]</a>. 

**Table B.2.2-1: OCF to oneM2M Device Type Mapping** 


|OCF Device Name |OCF Device Type |oneM2M Device |
|-|-|-|
|Active Speaker |oic.d.speaker |N/A |
|Air Conditioner |oic.d.airconditioner |[deviceAirConditioner](#5541-deviceairconditioner) |
|Air Purifier |oic.d.airpurifier |[deviceAirPurifier](#5542-deviceairpurifier) |
|Air Quality Monitor |oic.d.airqualitymonitor |[deviceAirQualityMonitor](#5512-deviceairqualitymonitor) |
|Battery |oic.d.battery |[deviceStorageBattery](#55426-devicestoragebattery) |
|Blind |oic.d.blind |[deviceWindowShade](#55429-devicewindowshade) |
|Camera |oic.d.camera |[deviceCamera](#5514-devicecamera) |
|Clothes Washer Dryer |oic.d.washerdryer |[deviceClothesWasherDryer](#5545-deviceclotheswasherdryer) |
|Coffee Machine |oic.d.coffeemachine |[deviceCoffeeMachine](#5546-devicecoffeemachine) |
|Cooker Hood |oic.d.cookerhood |[deviceCookerHood](#5547-devicecookerhood) |
|Cooktop |oic.d.cooktop |[deviceCooktop](#5548-devicecooktop) |
|Dehumidifier |oic.d.dehumidifier |[deviceDehumidifier](#5549-devicedehumidifier) |
|Dishwasher |oic.d.dishwasher |[deviceDishWasher](#55411-devicedishwasher) |
|Door |oic.d.door |[deviceDoor](#5515-devicedoor) |
|Dryer (Laundry) |oic.d.dryer |[deviceClothesDryer](#5543-deviceclothesdryer) |
|Electric Vehicle Charger |oic.d.electricvehiclecharger |[deviceElectricVehicleCharger](#5561-deviceelectricvehiclecharger) |
|Electric Meter |oic.d.electricmeter |[deviceSmartElectricMeter](#5523-devicesmartelectricmeter) |
|Energy Generator |oic.d.energygenerator |[deviceMicrogeneration](#55418-devicemicrogeneration) |
|Fan |oic.d.fan |[deviceFan](#55412-devicefan) |
|Food Probe |oic.d.foodprobe |[deviceFoodProbe](#55413-devicefoodprobe) |
|Freezer |oic.d.freezer |[deviceFreezer](#55414-devicefreezer) |
|Garage Door |oic.d.garagedoor |[deviceDoor](#5515-devicedoor) |
|Generic Sensor |oic.d.sensor |N/A |
|Grinder |oic.d.grinder |N/A |
|Humidifier |oic.d.humidifier |[deviceHumidifier](#55416-devicehumidifier) |
|Light |oic.d.light |[deviceLight](#5517-devicelight) |
|Oven |oic.d.oven |[deviceOven](#55419-deviceoven) |
|Printer |oic.d.printer |[devicePrinter](#5519-deviceprinter) |
|Printer Multi-Function |oic.d.multifunctionprinter |[deviceMultiFunctionPrinter](#5518-devicemultifunctionprinter) |
|Receiver |oic.d.receiver |[deviceAudioReceiver](#5513-deviceaudioreceiver) |
|Refrigerator |oic.d.refrigerator |[deviceRefrigerator](#55420-devicerefrigerator) |
|Robot Cleaner |oic.d.robotcleaner |[deviceRobotCleaner](#55422-devicerobotcleaner) |
|Scanner |oic.d.scanner |[deviceScanner](#55110-devicescanner) |
|Security Panel |oic.d.securitypanel |[deviceSecurityPanel](#55423-devicesecuritypanel) |
|Set Top Box |oic.d.stb |[deviceSetTopBox](#55424-devicesettopbox) |
|Smart Lock |oic.d.smartlock |[deviceDoorLock](#5516-devicedoorlock) |
|Smart Plug |oic.d.smartplug |[deviceSmartPlug](#55111-devicesmartplug) |
|Switch |oic.d.switch |[deviceSwitch](#55112-deviceswitch) |
|Television |oic.d.tv |[deviceTelevision](#55427-devicetelevision) |
|Thermostat |oic.d.thermostat |[deviceThermostat](#55114-devicethermostat) |
|Washer (Laundry) |oic.d.washer |[deviceClothesWasher](#5544-deviceclotheswasher) |
|Water Heater |oic.d.waterheater |[deviceWaterHeater](#55428-devicewaterheater) |
|Water Valve |oic.d.watervalve |[deviceWaterValve](#55115-devicewatervalve) |
|Window |oic.d.window |N/A |




# Annex C (informative):  Mapping to Content Attribute

## C.1 Introduction
Current SDT models are used only in form of &lt;flexContainer>s, and how to design content attribute of &lt;contentInstance> and &lt;timeSeriesInstance> is left to developers. There is no rule for design of content attribute, it means interoperability of content attribute is low. Then SDT can become one of the rules for design of content attribute, and the low interoperability problem will be solved.

The present clause explains how to use SDT as one of the rules for design of content attribute.

There are several benefits of using SDT in content attribute.

First, the resource architecture can be simpler than the one using &lt;flexContainer>s. When using &lt;flexContainer>s, universal attributes are mapped either into attributes of [deviceInfo] under a &lt;node> besides &lt;flexContainer>s, or into custom attributes of [[dmDeviceInfo]](#583-dmdeviceinfo) under a [[flexNode](#581-flexnode)] (see Rule 1-8 in clause [6.2.2](#622-resource-mapping-for-device-model)). Moreover, Action Class and DataPoint Class are the same layer in SDT, but Action Class is mapped to &lt;flexContainer> itself and DataPoint Class is mapped to attributes of &lt;flexContainer> expressing Module class. On the other hand, Using SDT in content attribute means using only one &lt;contentInstance> or &lt;timeSeriesInstance> so the resource architecture is simple.

Relating this benefit, it becomes easy to understand where to write information.

Second, &lt;contentInstance> and &lt;timeSeriesInstance> becomes more interoperable. How to write SDT in content attribute is able to become one of designs of content attribute and the low interoperability of &lt;contentInstance> and &lt;timeSeriesInstance> will be solved.

Third, If useful libraries are prepared, content attribute is able to be expressed in XML/JSON/CBOR with small changes on program.

In addition, tools can generate validator of the data and converter among the supported formats.


## C.2 XML representation of SDT instances.
ModuleClasses, SubDevice models and DeviceClass models written in clause 5 are expressed another way with using each class names as the tag. This clause introduces this way.

Normative work for defining the mapping rules from SDT to XML/ JSON instance are defined by SDT4.0.


### C.2.1 Mapping Rules of XML representation
Mapping from SDT instance into XML representation is following. Inclusion relationship of SDT instances are directly expressed as inclusion relationship of XML tags. Tag name is the same as each classes.

```XML
<DeviceClass Class Name>
    <SubDevice Class Name>
        <ModuleClass Class Name>
             <DataPoint Class Name>value</DataPoint Class Name>
             <Property Class Name>value</Property Class Name>
        </ModuleClass Class Name>
    </SubDevice Class Name>
</DeviceClass Class Name>
```

Action Class can not have any value and it only lengthen the message so it is omitted.

When a certain device does not have any SubDevice, the tags about SubDevices don't appear and tags about ModuleClass are placed under the DeviceClass directly.


### C.2.2 Example of XML representation
Below is the example for deviceThreeDPrinter:

```XML
<deviceThreeDPrinter>
    <binarySwitch>
        <state>True</state>
        <toggle></toggle>
    </binarySwitch>
    <faultDetection>
        <status>False</status>
        <code></code>
        <description></description>
    </faultDetection>
    <3Dprinter>
        <printType>2</printType>
        <printSizeX>70</printSizeX>
        <printSizeY>80</printSizeY>
        <printSizeZ>90</printSizeZ>
        <network>True</network>
        <memorySize>100</memorySize>
    </3Dprinter>
    <runState>
        <currentMachineState>1</currentMachineState>
        <machineStates>1,2,3</machineStates>
        <currentJobState>1</currentJobState>
        <jobStates>1,2,3</jobStates>
        <progressPercentage>60</progressPercentage>
    </runState>
    <temperature>
            <currentTemperature>20</currentTemperature>
            <targetTemperature>23</targetTemperature>
            <unit>celsius</unit>
            <minValue>15</minValue>
            <maxValue>28</maxValue>
            <stepValue>0.1</stepValue>
    </temperature>
    <printQueue>
            <uri> file://www.example.com/file.extension</uri>
            <printingState>1</printingState>
    </printQueue>
</deviceThreeDPrinter>
```

## C.3 JSON representation of SDT instances

### C.3.1 Mapping Rules of JSON representation
This clause explains how to represent SDT instances inJSON format

Inclusion relationship of SDT instances are directly expressed as inclusion relationship of JSON hash({}). Key name is same as each class name of SDT. Value types are written in various types depending on SDT definition.

```JSON
{
    "Device Class Name": {
        "SubDevice Class Name": {
            "Module Class Name": {
                "DataPointClassName": value ( by specified types in SDT)
            }
        }
    }
}
```

Action Class can not have any value and it only lengthen the message so it is omitted.

When a certain device does not any SubDevice Class, the tags about SubDevices Class do not appear and tags about Module Class are placed under the Device Class directly.


### C.3.2 Example of JSON representation
Below is the example for deviceThreeDPrinter:

```JSON
{
    "deviceThreeDPrinter": {
        "binarySwitch": {
            "state": true
        },
        "faultDetection": {
            "status": false,
            "code": "",
            "description": ""
        },
        "3Dprinter": {
            "printType": 2,
            "printSizeX": 70,
            "printSizeY": 80,
            "printSizeZ": 90,
            "network": true,
            "memorySize": 100
        },
        "runState": {
            "currentMachineState": 1,
            "machineStates": [1, 2, 3],
            "currentJobState": 1,
            "jobState": [1, 2, 3],
            "progressPercentage": 60,
        },
        "temperature": {
            "currentTemperature": 20,
            "targetTemperature": 23,
            "unit": "celsius",
            "minValue": 15,
            "maxValue": 28,
            "stepValue": 0.1
        },
        "printQueue":{
            "uri": "file://www.example.com/file.extension",
            "printingState": 1
        }
    }
}
```


## C.4 How to write into content attribute
Any size of the SDT class cluster may be mapped to content attribute. For example, from only the DataPoint class to DataPoint, Action, Module, SubDevice and Device classes may be mapped to one content attribute at once.



![Mapping SDT to content attribute](media/Mapping_SDT_to_content_attribute.png)

**Figure C.4-1: Image of Mapping SDT to content attribute**
An example that expresses a CREATE request for &lt;contentInstance> serialized into an XML document is shown below. This example is for the Module class and DataPoint class mapping and only content attribute and contentInfo attribute are shown as content parameter (pc).

```XML
<?xml version="1.0" encoding="UTF-8"?>
<m2m:rqp xmlns:m2m="http://www.onem2m.org/xml/protocols">
    <op>1</op>
    <to>//example.net/myCSE/-/Cont1</to>
    <fr>/myCSE/C2345</fr>
    <rqi>0002bf63</rqi>
    <ty>4</ty>
    <pc>
        <m2m:cin>
            <cnf>SDT:org.onem2m.home.device/module/temperature</cnf>
            <con>
                <tempe>
                    <curT0>5</curT0>
                    <tarTe>3</tarTe>
                </tempe>
            </con>
        </m2m:cin>
    </pc>
</m2m:rqp>
```

In content attribute, a value of DataPoint may be written between tags named the certain DataPoint name.

contentInfo attribute is able to be omitted because content attribute has tags named the certain Module class name (&lt;temp>&lt;/temp>).



An example for only DataPoint class mapping is shown below.:

```XML
<?xml version="1.0" encoding="UTF-8"?>
<m2m:rqp xmlns:m2m="http://www.onem2m.org/xml/protocols">
    <op>1</op>
    <to>//example.net/myCSE/-/Cont1</to>
    <fr>/myCSE/C2345</fr>
    <rqi>0002bf63</rqi>
    <ty>4</ty>
    <pc>
        <m2m:cin>
            <cnf>SDT:org.onem2m.home.device/datapoint/temperature/currentTemperature</cnf>
            <con>5</con>
        </m2m:cin>
    </pc>
</m2m:rqp>
```

In this case, contentInfo attribute can NOT be omitted because we cannot understand which data point is written in content attribute without contentInfo attribute.

If a contentInfo attribute is not used, content attribute may change as follows:

```XML
<con>
    <curT0>5</curT0>
</con>
```



# Annex D (informative) Bibliography

- oneM2M TS-0001: "Functional Architecture"
- Open Mobile Alliance, OMA-TS-Blood-Pressure-Monitor-APIs-V1-0-20160419-C: "Blood Pressure Monitor APIs".

	> NOTE: Available at [http://www.openmobilealliance.org/release/DWAPI/V1_0-20160419-C/OMA-TS-Blood_Pressure_Monitor_APIs-V1_0-20160419-C.pdf](http://www.openmobilealliance.org/release/DWAPI/V1_0-20160419-C/OMA-TS-Blood_Pressure_Monitor_APIs-V1_0-20160419-C.pdf)

- Open Mobile Alliance, OMA-TS-Glucometer-APIs-V1-0-20160419-C: "Glucometer APIs ".

	> NOTE: Available at [http://www.openmobilealliance.org/release/DWAPI/V1_0-20160419-C/OMA-TS-Glucometer_APIs-V1_0-20160419-C.pdf](http://www.openmobilealliance.org/release/DWAPI/V1_0-20160419-C/OMA-TS-Glucometer_APIs-V1_0-20160419-C.pdf)

- Open Mobile Alliance, OMA-TS-Heart-Rate-Monitor-APIs-V1-0-20160419-C: " Heart Rate Monitor APIs".

	> NOTE: Available at [http://www.openmobilealliance.org/release/DWAPI/V1_0-20160419-C/OMA-TS-Heart_Rate_Monitor_APIs-V1_0-20160419-C.pdf](http://www.openmobilealliance.org/release/DWAPI/V1_0-20160419-C/OMA-TS-Heart_Rate_Monitor_APIs-V1_0-20160419-C.pdf)

- Open Mobile Alliance, OMA-TS-Pulse-Oximeter-APIs-V1-0-20160419-C: " Pulse Oximeter APIs".

	> NOTE: Available at [http://www.openmobilealliance.org/release/DWAPI/V1_0-20160419-C/OMA-TS-Pulse_Oximeter_APIs-V1_0-20160419-C.pdf](http://www.openmobilealliance.org/release/DWAPI/V1_0-20160419-C/OMA-TS-Pulse_Oximeter_APIs-V1_0-20160419-C.pdf)

- Open Mobile Alliance, OMA-TS-Thermometer-APIs-V1-0-20160419-C: " Thermometer APIs".

	> NOTE: Available at [http://www.openmobilealliance.org/release/DWAPI/V1_0-20160419-C/OMA-TS-Thermometer_APIs-V1_0-20160419-C.pdf](http://www.openmobilealliance.org/release/DWAPI/V1_0-20160419-C/OMA-TS-Thermometer_APIs-V1_0-20160419-C.pdf)

- Open Mobile Alliance, OMA-TS-Weight-Scale-Body-Composition-Analyzer-APIs-V1-0-20160419-C: "Weight Scale / Body Composition Analyzer APIs".

	> NOTE: Available at [http://www.openmobilealliance.org/release/DWAPI/V1_0-20160419-C/OMA-TS-Weight_Scale_Body_Composition_Analyzer_APIs-V1_0-20160419-C.pdf](http://www.openmobilealliance.org/release/DWAPI/V1_0-20160419-C/OMA-TS-Weight_Scale_Body_Composition_Analyzer_APIs-V1_0-20160419-C.pdf)



# History

**Publication history**

| Version | Date       | Description             |
|-|-|-|
|V2.0.0 |2016-08-30 |Release 2 - Publication |
| V4.8.0 | December 2023 | Partners pre-processing done by **editHelp!<br />e-mail: [edithelp@etsi.org](mailto:edithelp@etsi.org) |
| | | |
| | | |
| | | |



**Draft history (to be removed on publication)**


| Version | Date       | Description                                                  |
| ------- | ---------- | ------------------------------------------------------------ |
| V 5.0.0 | 2021-04-06 | TS-0023 adaptation to Release 5 (v4.8.0  v5.0.0)             |
| V5.1.0  | 2021-12-02 | RDM-2021-0067-TS-0023_Metadata<br />RDM-2021-0093-SDT-issues-identified_in_TDE_R5 |
| V5.2.0  | 2022-07-15 | Reflecting comments from issues tracker. see link https://git.onem2m.org/issues/issues/-/issues?scope=all&utf8=%E2%9C%93&state=opened&search=rdm |
| V5.3.0  | 2022-09-28 | RDM-2022-0017R03-Proposed_changes_to_TS-0023_for_WI_0109<br />RDM-2022-0031R01-Adding_a_heater_device_to_TS-0023<br />RDM-2022-0045R01-TS-0023_PropertyNames_rel-5<br />RDM-2022-0051-Adding_the_remoteControlEnable_Module_to_the_deviceRobotCleaner_Device<br />RDM-2022-0052R01-Adding_a_new_Device_model_deviceJuicer_to_TS-0023<br />RDM-2022-0053R01-Adding_a_new_Device_model_deviceShoesWasher_to_TS-0023<br />RDM-2022-0055-Adding_an_electric motorcycle_device_to_TS-0023 |
| V5.4.0  | 2022-11-28 | RDM-2022-0062-TS-0023_v5_1_0_add_Public_Safety_Domain_clause<br />RDM-2022-0070R01-Updating_an_electric_motorcycle_device_information_model<br />RDM-2022-0075-TS-0023_v5_2_0_add_SDT_definitions_for_Public_Safety_Domain |
| V5.5.0  | 2023-04-20 | RDM-2023-0020-TS-0023_Moving_SubDeviceCuff_to_health_domain_(R5)<br />RDM-2023-0021-Adding_rule_for_FlexContainerInstance_specialization_naming_(R5)<br />RDM-2023-0022-TS-0023_Clarification_for_naming_elements_(R5)<br />RDM-2023-0023-TS-0023_Correcting_units_of_measure_(R5) |
| V5.6.0  | 2024-06-27 | RDM-2024-0014-Initial_conversion_of_TS-0023_to_markdown |
| Vx.x.x  | yyyy-mm-dd | [RDM-2024-0029-Editorial_changes](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/4), <br /> [RDM-2024-0030-Attribute_spelling_corrections](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/5),<br /> [RDM-2024-0031-TS-0023_-_Correcting_old_binarySwitch_powerState_references](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/6),<br /> [RDM-2024-0036-Correcting_UoM_of_MemorySize_in_threeDprinter_ModuleClass](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/7), <br />[RDM-2024-0036-Correcting_UoM_of_MemorySize_in_threeDprinter_ModuleClass](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/8), <br />[RDM-2024-0038-Adding_short_names_for_connectivity_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/9),<br /> [RDM-2024-0039-Adding_short_names_for_galleryMode_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/10),<br /> [RDM-2024-0040-Adding_short_names_for_gasChargingControl_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/11),<br /> [RDM-2024-0041-Adding_short_names_for_gasMeterAlarm_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/12),<br /> [RDM-2024-0042R01-Adding_short_names_for_gasMeterReportInfo_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/13),<br /> [RDM-2024-0043-Adding_short_names_for_magneticSensorParameters_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/14),<br /> [RDM-2024-0044-Adding_short_names_for_parkingStatus_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/15),<br /> [RDM-2024-0045-Adding_short_names_for_periodicalReportConfig_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/16), <br />[RDM-2024-0046-Adding_short_names_for_slcAlarm_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/17),<br /> [RDM-2024-0047-Adding_short_names_for_slcParameterSetting_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/18),<br /> [RDM-2024-0048-Adding_short_names_for_slcReportInfo_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/19),<br /> [RDM-2024-0062-Correcting_short_name_for_lightCurrent_attribute](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/20),<br /> [RDM-2025-0001-Adding_short_names_for_temperatureAlarm_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/21),<br /> [RDM-2025-0002-Added_missing_link_for_unit_attribute](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/23),<br /> [RDM-2025-0002-Added_missing_link_for_unit_attribute](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/24),<br /> [RDM-2025-0005R01-Adding_short_names_for_waterMeterSetting_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/25), <br />[RDM-2025-0006-Adding_short_names_for_waterQualityMonitor_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/26),<br /> [RDM-2025-0007-Correcting_attribute_name_and_UoM_for_anemometer_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/27),<br /> [RDM-2025-0008-Adding_short_names_and_UoM_for_barometer_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/28),<br /> [RDM-2025-0009-Adding_short_names_for_disposal_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/29), <br />[RDM-2025-0010-Correcting_action_and_attribute_name_for_raingauge_MC_Adding_short_nam](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/30),<br /> [RDM-2025-0011-Adding_short_names_for_infraredSensor_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/31),<br /> [RDM-2025-0012-Adding_short_names_for_waterFilterType_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/32),<br /> [RDM-2025-0013-Adding_short_names_for_touchScreen_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/33),<br /> [RDM-2025-0014-Adding_short_names_for_prePaidCardReader_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/34),<br /> [RDM-2025-0015-Adding_short_names_for_billDeposit_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/35), <br />[RDM-2025-0016-Adding_short_names_for_billWithdrawal_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/36),<br /> [RDM-2025-0017-Adding_short_names_for_coinDeposit_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/37),<br /> [RDM-2025-0017-Adding_short_names_for_coinDeposit_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/38),<br /> [RDM-2025-0024-Adding_short_names_for_cardScanner_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/39),<br /> [RDM-2025-0026-Adding_short_names_for_waterMeterReportInfo_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/40), <br />[RDM-2025-0027-Adding_references_to_shortnames_of_headingSensor_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/41),<br /> [RDM-2025-0028-Adding_short_names_for_signalPanel_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/42), <br />[RDM-2025-0029-Adding_short_names_for_crossingBarrier_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/43),<br /> [RDM-2025-0030-Adding_short_names_for_threeDDisplay_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/44), <br />[RDM-2025-0031-Adding_short_names_for_threeDScanner_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/45), <br />[RDM-2025-0032-Adding_short_names_for_blender_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/46),<br /> [RDM-2025-0033-Adding_short_names_for_shoesWasherJobMode_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/47),<br /> [RDM-2025-0034-Adding_short_names_for_cowActivityMonitor_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/48),<br /> [RDM-2025-0035-Adding_short_names_for_baliseTransmissionModule_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/49),<br /> [RDM-2025-0036-Adding_short_names_for_localization_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/50),<br /> [RDM-2025-0037-Adding_short_names_for_disseminator_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/51),<br /> [RDM-2025-0038-Adding_short_names_for_emergencyHandler_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/52),<br /> [RDM-2025-0039-Adding_short_names_for_settings_MC](https://git.onem2m.org/specifications/ts/ts-0023/-/merge_requests/53)  |
